; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Module - V0.9.2
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - DebuggingMethods.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 22-07-2018
; Mise  jour : 06-08-2018
; Cod pour PureBasic : V5.70 beta 1
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule DebuggingMethods

  Declare.b GetDebugging()
  Declare SetDebugging(P_Debugging.b)
  Declare Reset()
  Declare ReadPrefs(P_GroupName.s)
  Declare WritePrefs(P_GroupName.s)
  Declare.s DeclareDebugging()
  Declare.s DefineDebugging()
  
EndDeclareModule

Module DebuggingMethods

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Dclaration de la Structure <<<<<

  Structure Instance

    Debugging.b

  EndStructure

  Global Instance.Instance

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les observateurs <<<<<

  Procedure.b GetDebugging()

    ProcedureReturn Instance\Debugging
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les mutateurs <<<<<

  Procedure SetDebugging(P_Debugging.b)

    Instance\Debugging = P_Debugging

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Reset <<<<<

  Procedure Reset()
    
    Instance\Debugging = 0
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Lecture d'un groupe Prfrences <<<<<

  Procedure ReadPrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    Instance\Debugging = ReadPreferenceLong("Debugging", Instance\Debugging)
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<

  Procedure WritePrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    WritePreferenceLong("Debugging", Instance\Debugging)
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Debugging <<<<<
  
  Procedure.s DeclareDebugging()
    
    Output.s = LineFeed::Single() + Comments::Tabulation(1) + "CompilerIf #PB_Compiler_Debugger" + LineFeed::Single()
    Output + Comments::Tabulation(2) + "Declare Debugging()" + LineFeed::Single()
    Output + Comments::Tabulation(1) + "CompilerEndIf" + LineFeed::Single()
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Oprateurs privs <<<<<
  
  Procedure.s InstructionDebugBasic(TabSize.b, InstanceAccessPath.s, Target.b)
    
    Select Field::GetFieldType(Target)
        
      Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_STRING02
        Instruction.s = Comments::Tabulation(TabSize) + "Debug " + InstanceAccessPath + Field::GetFieldAccess(Target) + LineFeed::Single()
        
      Case Field::#FIELD_TYPE_MODULE
        Instruction = Comments::Tabulation(TabSize) + Field::GetFieldExternModuleName(Target) + "::Debugging(" + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + LineFeed::Single()
        
    EndSelect
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s InstructionDebugStructure(TabSize.b, InstanceAccessPath.s, Target.b)
    
    Select Field::GetSubFieldType(Target)
        
      Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_STRING02
        Instruction.s = Comments::Tabulation(TabSize) + "Debug " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + LineFeed::Single()
        
      Case Field::#FIELD_TYPE_MODULE
        Instruction = Comments::Tabulation(TabSize) + Field::GetFieldExternModuleName(Target) + "::Debugging(" + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + LineFeed::Single()
        
    EndSelect
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s DebugCodeChunk(TabSize.b, InstanceAccessPath.s, Target.b)
    
    If Field::FirstInstance(Target)
      
      Repeat
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
            SeparatorNeeded = #True
            
          Case Field::#FIELD_STYLE_BASIC
            SeparatorNeeded = #False
            
        EndSelect
        
        If Field::InstanceIndex(Target) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
          Buffer.s + Comments::Tabulation(TabSize) + LineFeed::Single()
        EndIf 
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_ARRAY
            
            TabSize.b = 2   

            Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize, 0)
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionDebugBasic(TabSize+1, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + LineFeed::Single()
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize + 1      

                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionDebugStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + LineFeed::Single()
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + LineFeed::Single()
                        Buffer + InstructionDebugStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + LineFeed::Single()
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + LineFeed::Single()
                        Buffer + Comments::Tabulation(TabSize+2) + "Debug MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + ")" + LineFeed::Single()
                        Buffer + InstructionDebugStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + LineFeed::Single()
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionDebugStructure(TabSize+1, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + LineFeed::Single()
                        Buffer + InstructionDebugStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + LineFeed::Single()
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + LineFeed::Single()
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize, 0) + LineFeed::Single()
            
          Case Field::#FIELD_STYLE_LIST
            Buffer + Comments::Tabulation(TabSize) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + LineFeed::Single()
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionDebugBasic(TabSize+1, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + LineFeed::Single()
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize+1      
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionDebugStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + LineFeed::Single()
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + LineFeed::Single()
                        Buffer + InstructionDebugStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + LineFeed::Single()
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + LineFeed::Single()
                        Buffer + Comments::Tabulation(TabSize+2) + "Debug MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + ")" + LineFeed::Single()
                        Buffer + InstructionDebugStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + LineFeed::Single()
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionDebugStructure(TabSize+1, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + LineFeed::Single()
                        Buffer + InstructionDebugStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + LineFeed::Single()
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + LineFeed::Single()
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize) + "Next" + LineFeed::Single()
            
          Case Field::#FIELD_STYLE_MAP
            Buffer + Comments::Tabulation(TabSize) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + LineFeed::Single()
            Buffer + Comments::Tabulation(TabSize + 2) + "Debug MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target) + ")" + LineFeed::Single()
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionDebugBasic(TabSize + 1, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + LineFeed::Single()
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize         
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionDebugStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + LineFeed::Single()
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + LineFeed::Single()
                        Buffer + InstructionDebugStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + LineFeed::Single()
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + LineFeed::Single()
                        Buffer + Comments::Tabulation(TabSize + 2) + "Debug MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + ")" + LineFeed::Single()
                        Buffer + InstructionDebugStructure(TabSize + 2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize + 1) + "Next" + LineFeed::Single()
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionDebugStructure(TabSize + 1, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + LineFeed::Single()
                        Buffer + InstructionDebugStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + LineFeed::Single()
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + LineFeed::Single()
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize) + "Next" + LineFeed::Single()
            
          Case Field::#FIELD_STYLE_BASIC
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionDebugBasic(TabSize, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                        SeparatorNeeded2 = #True
                        
                      Case Field::#FIELD_STYLE_BASIC
                        SeparatorNeeded2 = #False
                        
                    EndSelect
                    
                    If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded2 = #True Or PreviousSeparator2 = #True
                      Buffer + Comments::Tabulation(TabSize) + LineFeed::Single()
                    EndIf   
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionDebugStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + LineFeed::Single()
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + LineFeed::Single()
                        Buffer + InstructionDebugStructure(TabSize+1, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + LineFeed::Single()
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + LineFeed::Single()
                        Buffer + Comments::Tabulation(TabSize + 1) + "Debug MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + ")" + LineFeed::Single()
                        Buffer + InstructionDebugStructure(TabSize + 1, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + LineFeed::Single()
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionDebugStructure(TabSize, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + LineFeed::Single()
                        Buffer + InstructionDebugStructure(TabSize+1, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize) + "Next" + LineFeed::Single()
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + LineFeed::Single()
                    EndIf
                    
                    PreviousSeparator2 = SeparatorNeeded2
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
          Case Field::#FIELD_STYLE_BASIC_ARRAY
            
            Buffer + Comments::Tabulation(TabSize) + "For " + Field::GetFieldArrayIndexName(Target) + " = 0 To " + Field::GetFieldArraySizeLoop(Target) + LineFeed::Single()
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_MODULE
                Buffer + InstructionDebugBasic(TabSize+1, InstanceAccessPath, Target)
                
              Case Field::#FIELD_TYPE_STRUCTURE
                
                If Field::FirstSubField(Target)
                  
                  Select Field::GetSubFieldStyle(Target)
                      
                    Case Field::#FIELD_STYLE_ARRAY To Field::#FIELD_STYLE_MAP, Field::#FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded3 = #True
                      
                    Case Field::#FIELD_STYLE_BASIC
                      SeparatorNeeded3 = #False
                      
                  EndSelect
                  
                  If Field::SubFieldIndex(Target) = 0 Or SeparatorNeeded3 = #True Or PreviousSeparator3 = #True
                    Buffer + Comments::Tabulation(TabSize) + LineFeed::Single()
                  EndIf   
                  
                  Repeat 
                    
                    Select Field::GetSubFieldStyle(Target)
                        
                      Case Field::#FIELD_STYLE_ARRAY
                        TabSize2.b = TabSize + 1
                        Buffer + Field::GetDynamicArrayOpeningLoop(Target, @TabSize2, 1)
                        Buffer + InstructionDebugStructure(TabSize2 + 1, InstanceAccessPath, Target)
                        Buffer + Field::GetDynamicArrayClosingLoop(Target, @TabSize2, 1) + LineFeed::Single()
                        
                      Case Field::#FIELD_STYLE_LIST
                        Buffer + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + LineFeed::Single()
                        Buffer + InstructionDebugStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + LineFeed::Single()
                        
                      Case Field::#FIELD_STYLE_MAP
                        Buffer + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceAccessPath + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + LineFeed::Single()
                        Buffer + Comments::Tabulation(TabSize + 2) + "Debug MapKey(" + InstanceAccessPath + Field::GetFieldAccess(Target)  + "\" + Field::GetSubFieldAccess(Target) + ")" + LineFeed::Single()
                        Buffer + InstructionDebugStructure(TabSize + 2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize + 1) + "Next" + LineFeed::Single()
                        
                      Case Field::#FIELD_STYLE_BASIC
                        Buffer + InstructionDebugStructure(TabSize+1, InstanceAccessPath, Target)
                        
                      Case Field::#FIELD_STYLE_BASIC_ARRAY
                        Buffer + Comments::Tabulation(TabSize+1) + "For " + Field::GetSubFieldArrayIndexName(Target) + " = 0 To " + Field::GetSubFieldArraySizeLoop(Target) + LineFeed::Single()
                        Buffer + InstructionDebugStructure(TabSize+2, InstanceAccessPath, Target)
                        Buffer + Comments::Tabulation(TabSize+1) + "Next" + LineFeed::Single()
                        
                    EndSelect 
                    
                    If Field::SubFieldIndex(Target) = Field::SubFieldSize(Target) - 1
                      Buffer + Comments::Tabulation(TabSize) + LineFeed::Single()
                    EndIf
                    
                    PreviousSeparator3 = SeparatorNeeded3
                    
                  Until Field::NextSubField(Target) = #Null
                  
                EndIf
                
            EndSelect 
            
            Buffer + Comments::Tabulation(TabSize) + "Next" + LineFeed::Single()
            
        EndSelect
        
        If General::GetSecondaryInstance() = #False
          If Field::InstanceIndex(Target) = Field::InstanceSize(Target) - 1
            Buffer + Comments::Tabulation(TabSize) + LineFeed::Single()
          EndIf
        EndIf 
        
        PreviousSeparator = SeparatorNeeded
        
      Until Field::NextInstance(Target) = #Null
      
    EndIf
    
    ProcedureReturn Buffer
  EndProcedure 
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Debugging <<<<<
  
  Procedure.s DefineDebugging()
    
    Buffer.s = Comments::Tabulation(1) + "CompilerIf #PB_Compiler_Debugger" + LineFeed::Twin()
    Buffer + Comments::Tabulation(2) + "Procedure Debugging()" + LineFeed::Single()
    
    Select General::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
        Buffer + DebugCodeChunk(3, Field::GetInstanceAccessPath(), 0)
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
        Buffer + Comments::Tabulation(2) + LineFeed::Single()
        Buffer + Comments::Tabulation(3) + "ForEach Instances()" + LineFeed::Single()
        Buffer + DebugCodeChunk(4, Field::GetInstanceAccessPath(), 0) + LineFeed::Single()
        Buffer + Comments::Tabulation(3) + "Next" + LineFeed::Single()

    EndSelect
    
    If General::GetSecondaryInstance() = #True
      Buffer + DebugCodeChunk(3, "Secondary\", 1)
      Buffer + Comments::Tabulation(3) + LineFeed::Single()
    EndIf
    
    Buffer + Comments::Tabulation(2) + "EndProcedure" + LineFeed::Twin()
    Buffer + Comments::Tabulation(1) + "CompilerEndIf" + LineFeed::Twin()
    
    ProcedureReturn Buffer
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (91000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 LTS (Linux - x64)
; Folding = ---
; EnableXP
; CompileSourceDirectory