; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Module - V0.0.9
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - Help.pb
; Version du fichier : 0.9.1
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 02-07-2016
; Mise  jour : 03-06-2018
; Cod pour PureBasic : V5.62
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Help

  Declare.l GetFileID()
  Declare.s GetPath()
  Declare.l GetWindowBackgroundColor()
  Declare.l GetComboBoxGadgetID()
  Declare.l GetWebGadgetID()
  Declare SetFileID(P_FileID.l)
  Declare SetPath(P_Path.s)
  Declare SetWindowBackgroundColor(P_WindowBackgroundColor.l)
  Declare SetComboBoxGadgetID(P_ComboBoxGadgetID.l)
  Declare SetWebGadgetID(P_WebGadgetID.l)
  Declare Initialize()
  Declare Reset()
  Declare ScanHelpFolder()
  Declare DirectlySelectHtmlFiles()
  
EndDeclareModule

Module Help
  
;   CompilerSelect #PB_Compiler_OS
;       
;     CompilerCase #PB_OS_Windows 
;       #PathSep = "\"
;       
;     CompilerCase #PB_OS_Linux
;       #PathSep = "/"
;       
;     CompilerCase #PB_OS_MacOS
;       #PathSep = "/"
;       
;   CompilerEndSelect
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Dclaration de la Structure <<<<<
  
  Structure Instance
    
    FileID.l
    Path.s
    WindowBackgroundColor.l
    ComboBoxGadgetID.l
    WebGadgetID.l

  EndStructure

  Global Instance.Instance
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les observateurs <<<<<

  Procedure.l GetFileID()

    ProcedureReturn Instance\FileID
  EndProcedure

  Procedure.s GetPath()

    ProcedureReturn Instance\Path
  EndProcedure

  Procedure.l GetWindowBackgroundColor()

    ProcedureReturn Instance\WindowBackgroundColor
  EndProcedure

  Procedure.l GetComboBoxGadgetID()

    ProcedureReturn Instance\ComboBoxGadgetID
  EndProcedure

  Procedure.l GetWebGadgetID()

    ProcedureReturn Instance\WebGadgetID
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les mutateurs <<<<<

  Procedure SetFileID(P_FileID.l)

    Instance\FileID = P_FileID

  EndProcedure

  Procedure SetPath(P_Path.s)

    Instance\Path = GetCurrentDirectory() + "help" + #PS$ + StringField(P_Path, 1, ".") + #PS$

  EndProcedure

  Procedure SetWindowBackgroundColor(P_WindowBackgroundColor.l)

    Instance\WindowBackgroundColor = P_WindowBackgroundColor

  EndProcedure

  Procedure SetComboBoxGadgetID(P_ComboBoxGadgetID.l)

    Instance\ComboBoxGadgetID = P_ComboBoxGadgetID

  EndProcedure

  Procedure SetWebGadgetID(P_WebGadgetID.l)

    Instance\WebGadgetID = P_WebGadgetID

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Initialize <<<<<

  Procedure Initialize()
   
    Instance\WindowBackgroundColor = $FFFFFF

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Reset <<<<<

  Procedure Reset()
    
    Instance\FileID = 0
    Instance\Path = ""
    Instance\WindowBackgroundColor = 0
    Instance\ComboBoxGadgetID = 0
    Instance\WebGadgetID = 0
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Ecriture d'un block CSS <<<<<
  
  Procedure WriteCssBlock(FileID.l, String.s)
    
    ClassName.s = StringField(String, 1, "{")
    Element.s = StringField(StringField(String, 2, "{"), 1, "}")
    FieldCount.l = CountString(Element, ";")
    
    WriteStringN(FileID, ClassName)
    WriteStringN(FileID, "{")
    
    For Index = 1 To FieldCount
      
      Line.s = Chr(9) + Trim(StringField(Element, Index, ";")) + ";"
      
      If FindString(Line, "%COLOR%", 1)
        Line = ReplaceString(Line, "%COLOR%", RgbToHtml::Convert(Instance\WindowBackgroundColor))
      EndIf
      
      WriteStringN(FileID, Line)
      
    Next
    
    WriteStringN(FileID, "}")
    WriteStringN(FileID, "")
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Construction du fichier CSS <<<<<
  
  Procedure CreateCSSFile()
    
    If CreateFile(0, Instance\Path + "Style.css") <> 0
      
      Restore CSSComment
      
      For Index = 0 To 5
        Read.s Buffer.s
        WriteStringN(0, Buffer)
      Next
      
      WriteStringN(0, "")
      
      Restore CSSBlock
      
      For Index = 0 To 23
        
        Read.s Buffer
        WriteCssBlock(0, Buffer)
        
      Next
      
      CloseFile(0)
      
    EndIf 
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Mise en place de la liste de fichiers <<<<<
  
  Procedure ScanHelpFolder()
    
    CreateCSSFile()
    ClearGadgetItems(Instance\ComboBoxGadgetID)
    
    NewList FileNames.s()
    
    If ExamineDirectory(0, Instance\Path, "*.html") <> 0
      
      While NextDirectoryEntry(0) <> 0
        
        FileName.s = DirectoryEntryName(0)
        
        If Left(FileName, 1) <> "."
          AddElement(FileNames())
          FileNames() = StringField(FileName, 1, ".")
        EndIf
        
      Wend
      
      SortList(FileNames(), #PB_Sort_Ascending)
      
      ForEach FileNames()
        AddGadgetItem(Instance\ComboBoxGadgetID, -1, FileNames())  
        FileNames() = ""
      Next
      
      FreeList(FileNames())
      
    EndIf
    
    Instance\FileID = 0
    SetGadgetState(Instance\ComboBoxGadgetID, 0)
    
    If IsGadget(Instance\WebGadgetID) <> 0 
      SetGadgetText(Instance\WebGadgetID, ReplaceString("file://" + Instance\Path + GetGadgetItemText(Instance\ComboBoxGadgetID, Instance\FileID) + ".html", "\", "/"))
    EndIf 
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Slection d'un fichier *.html directement. ComboBox <<<<<
  
  Procedure DirectlySelectHtmlFiles()
    
    Instance\FileID = GetGadgetState(Instance\ComboBoxGadgetID)
    
    If IsGadget(Instance\WebGadgetID) <> 0 
      SetGadgetText(Instance\WebGadgetID, ReplaceString("file://" + Instance\Path + GetGadgetItemText(Instance\ComboBoxGadgetID, Instance\FileID) + ".html", "\", "/"))
    EndIf 
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< DataSection des lignes pour le fichier Style.css <<<<<
  
  DataSection 
    
    CSSComment:
    
    Data.s "/* Fichier gnr par le programme Dev-Module."
    Data.s "Toutes modifications sont inutiles, le fichier"
    Data.s "est reconstruit  chaque dmarrage. Si d'autres"
    Data.s "styles doivent tre dfinis, les placer sur un"
    Data.s "autre fichier *.css et l'inclure en rfrence"
    Data.s "dans votre page html en plus de celle-ci. */"
    
    CSSBlock:
    
    Data.s "BODY {BACKGROUND: %COLOR%; COLOR: black;}"
    
    Data.s ".Symbol {font-family: Symbol; font-size: 12pt;}"
    Data.s ".TextTeal {color: #008080;}"
    Data.s ".TextOrange {color: #ff7713;}"
    Data.s ".TextRed {color: #ff0000;}"
    Data.s ".souligne {text-decoration: underline;}"
    
    Data.s "table { border-collapse:collapse; border-spacing:0; empty-cells:show;}"
    
    Data.s ".HeaderCell { font-family:Arial, Liberation; background-color:#C0C0C0; border-width:1px; border-style:solid; border-color:#000000; text-align:center ;margin-left:0px; font-size:12pt; font-weight:bold;}"
    Data.s ".NormalCell { font-family:Arial, Liberation;border-width:1px; border-style:solid  ; border-color:#000000; text-align:center; margin-left:0px; font-size:10pt;}"
    Data.s ".TotalCell { font-family:Arial, Liberation; border-width:1px; border-style:solid  ; border-color:#000000; text-align:center; margin-left:0px; font-size:10pt; font-weight:bold;}"
    
    Data.s ".Footer {color: #0000ff; font-family: Arial, Liberation; font-size: 8pt; text-align: center;}"
    Data.s ".TextJustify {color: #000000; font-family: Arial, Liberation; font-size: 10pt; text-align: justify;}"
    Data.s ".TextLeft {color: #000000; font-family: Arial, Liberation; font-size: 10pt; text-align: left;}"
    Data.s ".TextRight {color: #000000; font-family: Arial, Liberation; font-size: 10pt; text-align: right;}"
    Data.s ".TextCenter {color: #000000; font-family: Arial, Liberation; font-size: 10pt; text-align: center;}"
    Data.s ".TitleCenter {color: #000000; font-family: Arial, Liberation; font-size: 12pt; text-align: center;}"
    Data.s ".TitleLeft {color: #000000; font-family: Arial, Liberation; font-size: 12pt; text-align: left;}"
    
    Data.s ".CodeFooter {color: #0000ff; font-family: Consolas, Fixedsys, " + Chr(34) + "Liberation mono" + Chr(34) + "; font-size: 8pt; text-align: center;}"
    Data.s ".CodeTextJustify {color: #000000; font-family: Consolas, Fixedsys, " + Chr(34) + "Liberation mono" + Chr(34) + "; font-size: 10pt; text-align: justify;}"
    Data.s ".CodeTextLeft {color: #000000; font-family: Consolas, Fixedsys, " + Chr(34) + "Liberation mono" + Chr(34) + "; font-size: 10pt; text-align: left;}"
    Data.s ".CodeTextRight {color: #000000; font-family: Consolas, Fixedsys, " + Chr(34) + "Liberation mono" + Chr(34) + "; font-size: 10pt; text-align: right;}"
    Data.s ".CodeTextCenter {color: #000000; font-family: Consolas, Fixedsys, " + Chr(34) + "Liberation mono" + Chr(34) + "; font-size: 10pt; text-align: center;}"
    Data.s ".CodeTitleCenter {color: #000000; font-family: Consolas, Fixedsys, " + Chr(34) + "Liberation mono" + Chr(34) + "; font-size: 12pt; text-align: center;}"
    Data.s ".CodeTitleLeft {color: #000000; font-family: Consolas, Fixedsys, " + Chr(34) + "Liberation mono" + Chr(34) + "; font-size: 12pt; text-align: left;}"
    
  EndDataSection
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (64000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 LTS beta 3 (Linux - x64)
; Folding = ----
; EnableXP
; CompileSourceDirectory