; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - Constants.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 03-10-2014
; Mise  jour : 16-03-2019
; Code PureBasic : V5.70 LTS
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

#Version = " - V1.0.0 Beta"

Enumeration
  
  #MainWin
  #InternalStructureWin
  #OptionsWin
  
  #Panel
  
  #Panel_Primary_Secondary
  
  #Text_Module_Name
  #String_Module_Name
  #Option_Single_Instance
  #Option_Multiple_Instance_ID
  #Option_Multiple_Instance_Index
  #Option_Multiple_Instance_Name
  #Option_Off_Module_Instance
  
  #Frame_Internal_Structure
  #Button_Scan_Internal_Structure
  #ListView_Internal_Structure
  
  #Text_Internal_Structure_Name
  #Button_Internal_Structure_OK
  #Button_Internal_Structure_CANCEL
  
  #Editor_Internal_Structure
  
  #Editor_Module_Primary
  #Editor_Module_Secondary
  #Editor_Source_Code

  #Frame_Basic_Methods
  #Frame_Static_Array
  #Frame_Linked_List
  #frame_Dynamic_Array
  #Frame_Map
  #Frame_Maths_Operator
  #Frame_Debugging
  #Frame_Preference_Methods
  #Frame_XMLFile_Methods
  #Frame_JSONFile_Methods
  #Frame_DataBaseFile_Methods
  #Frame_BinaryFile_Methods
  #Frame_EncodedFile_Methods
  #Frame_CryptedFile_Methods
  
  #ComboBox_EncodedFile_Module
  #Button_Remove_EncodedFile_Module
  #Button_Add_EncodedFile_Module
  
  #ComboBox_CryptedFile_Module
  #Button_Remove_CryptedFile_Module
  #Button_Add_CryptedFile_Module
  
  #CheckBox_Observator
  #Option_Observator_Public
  #Option_Observator_Private
  
  #CheckBox_Mutator
  #Option_Mutator_Public
  #Option_Mutator_Private

  #CheckBox_Update
  #Option_Update_Public
  #Option_Update_Private
  
  #CheckBox_Initialize
  #Option_Initialize_Public
  #Option_Initialize_Private
  
  #CheckBox_Reset
  #Option_Reset_Public
  #Option_Reset_Private
  
  #CheckBox_Clear
  #Option_Clear_Public
  #Option_Clear_Private
  
  #CheckBox_QuickSortAscending
  #Option_QuickSortAscending_Public
  #Option_QuickSortAscending_Private
  
  #CheckBox_QuickSortDescending
  #Option_QuickSortDescending_Public
  #Option_QuickSortDescending_Private
  
  #CheckBox_LinearSearch
  #Option_LinearSearch_Public
  #Option_LinearSearch_Private
  
  #CheckBox_BinarySearch
  #Option_BinarySearch_Public
  #Option_BinarySearch_Private
  
  #CheckBox_FixedLengthQueue
  #Option_FixedLengthQueue_Public
  #Option_FixedLengthQueue_Private
  
  #CheckBox_Sort_Linked_List
  #Option_Sort_Linked_List_Public
  #Option_Sort_Linked_List_Private
  
  #CheckBox_Lin_Search_Linked_List
  #Option_Lin_Search_Linked_List_Public
  #Option_Lin_Search_Linked_List_Private
  
  #CheckBox_Bin_Search_Linked_List
  #Option_Bin_Search_Linked_List_Public
  #Option_Bin_Search_Linked_List_Private
  
  #CheckBox_Add_Linked_List
  #Option_Add_Linked_List_Public
  #Option_Add_Linked_List_Private
  
  #CheckBox_Select_Linked_List
  #Option_Select_Linked_List_Public
  #Option_Select_Linked_List_Private
  
  #CheckBox_First_Linked_List
  #Option_First_Linked_List_Public
  #Option_First_Linked_List_Private
  
  #CheckBox_Last_Linked_List
  #Option_Last_Linked_List_Public
  #Option_Last_Linked_List_Private
  
  #CheckBox_Previous_Linked_List
  #Option_Previous_Linked_List_Public
  #Option_Previous_Linked_List_Private
  
  #CheckBox_Next_Linked_List
  #Option_Next_Linked_List_Public
  #Option_Next_Linked_List_Private
  
  #CheckBox_Delete_Linked_List
  #Option_Delete_Linked_List_Public
  #Option_Delete_Linked_List_Private

  #CheckBox_Reset_Linked_List
  #Option_Reset_Linked_List_Public
  #Option_Reset_Linked_List_Private
  
  #CheckBox_Clear_Linked_List
  #Option_Clear_Linked_List_Public
  #Option_Clear_Linked_List_Private
  
  #CheckBox_Index_Linked_List
  #Option_Index_Linked_List_Public
  #Option_Index_Linked_List_Private
  
  #CheckBox_Size_Linked_List
  #Option_Size_Linked_List_Public
  #Option_Size_Linked_List_Private
  
  #CheckBox_Insert_Linked_List
  #Option_Insert_Linked_List_Public
  #Option_Insert_Linked_List_Private
  
  #CheckBox_Extract_Linked_List
  #Option_Extract_Linked_List_Public
  #Option_Extract_Linked_List_Private

  #CheckBox_Sort_Dynamic_Array
  #Option_Sort_Dynamic_Array_Public
  #Option_Sort_Dynamic_Array_Private
  
  #CheckBox_Lin_Search_Dynamic_Array
  #Option_Lin_Search_Dynamic_Array_Public
  #Option_Lin_Search_Dynamic_Array_Private
  
  #CheckBox_Bin_Search_Dynamic_Array
  #Option_Bin_Search_Dynamic_Array_Public
  #Option_Bin_Search_Dynamic_Array_Private
  
  #CheckBox_Insert_Dynamic_Array
  #Option_Insert_Dynamic_Array_Public
  #Option_Insert_Dynamic_Array_Private
  
  #CheckBox_Extract_Dynamic_Array
  #Option_Extract_Dynamic_Array_Public
  #Option_Extract_Dynamic_Array_Private
  
  #CheckBox_Add_Map
  #Option_Add_Map_Public
  #Option_Add_Map_Private
  
  #CheckBox_Clear_Map
  #Option_Clear_Map_Public
  #Option_Clear_Map_Private
  
  #CheckBox_Size_Map
  #Option_Size_Map_Public
  #Option_Size_Map_Private
  
  #CheckBox_Reset_Map
  #Option_Reset_Map_Public
  #Option_Reset_Map_Private
  
  #CheckBox_Delete_Map
  #Option_Delete_Map_Public
  #Option_Delete_Map_Private
  
  #CheckBox_Find_Map
  #Option_Find_Map_Public
  #Option_Find_Map_Private
  
  #CheckBox_Next_Map
  #Option_Next_Map_Public
  #Option_Next_Map_Private
  
  #CheckBox_Key_Map
  #Option_Key_Map_Public
  #Option_Key_Map_Private
  
  #CheckBox_Insert_Map
  #Option_Insert_Map_Public
  #Option_Insert_Map_Private
  
  #CheckBox_Extract_Map
  #Option_Extract_Map_Public
  #Option_Extract_Map_Private

  #CheckBox_Equal
  #Option_Equal_Public
  #Option_Equal_Private
  
  #CheckBox_Plus
  #Option_Plus_Public
  #Option_Plus_Private
  
  #CheckBox_Minus
  #Option_Minus_Public
  #Option_Minus_Private
  
  #CheckBox_Product
  #Option_Product_Public
  #Option_Product_Private
  
  #CheckBox_Divide
  #Option_Divide_Public
  #Option_Divide_Private

  #CheckBox_ProductByScalar
  #Option_ProductByScalar_Public
  #Option_ProductByScalar_Private
  
  #CheckBox_DivideByScalar
  #Option_DivideByScalar_Public
  #Option_DivideByScalar_Private
  
  #CheckBox_Copy
  #Option_Copy_Public
  #Option_Copy_Private
  
  #CheckBox_Compare
  #Option_Compare_Public
  #Option_Compare_Private
  
  #CheckBox_Swapping
  #Option_Swapping_Public
  #Option_Swapping_Private
  
  #CheckBox_Pref_Group
  #Option_Pref_Group_Public
  #Option_Pref_Group_Private
  
  #CheckBox_Pref_File
  #Option_Pref_File_Public
  #Option_Pref_File_Private
  
  #CheckBox_XML_SetGet_Node
  #Option_XML_SetGet_Node_Public
  #Option_XML_SetGet_Node_Private
  
  #CheckBox_XML_SetGet_Attribute
  #Option_XML_SetGet_Attribute_Public
  #Option_XML_SetGet_Attribute_Private
  
  #CheckBox_XML_AddCollect_Attribute
  #Option_XML_AddCollect_Attribute_Public
  #Option_XML_AddCollect_Attribute_Private
  
  #CheckBox_XML_CreateLoad_File
  #Option_XML_CreateLoad_File_Public
  #Option_XML_CreateLoad_File_Private
  
  #CheckBox_XML_Catch_File
  #Option_XML_Catch_File_Public
  #Option_XML_Catch_File_Private

  #CheckBox_JSON_CreateLoad_File
  #Option_JSON_CreateLoad_File_Public
  #Option_JSON_CreateLoad_File_Private

  #CheckBox_DataBase_CreateTable
  #Option_DataBase_CreateTable_Public
  #Option_DataBase_CreateTable_Private
  
  #CheckBox_DataBase_DropTable
  #Option_DataBase_DropTable_Public
  #Option_DataBase_DropTable_Private
  
  #CheckBox_DataBase_TruncateTable
  #Option_DataBase_TruncateTable_Public
  #Option_DataBase_TruncateTable_Private
  
  #CheckBox_DataBase_SelectTable
  #Option_DataBase_SelectTable_Public
  #Option_DataBase_SelectTable_Private
  
  #CheckBox_DataBase_CountRowInTable
  #Option_DataBase_CountRowInTable_Public
  #Option_DataBase_CountRowInTable_Private
    
  #CheckBox_DataBase_OpenFile
  #Option_DataBase_OpenFile_Public
  #Option_DataBase_OpenFile_Private
  
  #CheckBox_DataBase_ModuleTo
  #Option_DataBase_ModuleTo_Public
  #Option_DataBase_ModuleTo_Private
  
  #CheckBox_DataBase_ToModule
  #Option_DataBase_ToModule_Public
  #Option_DataBase_ToModule_Private
  
  #CheckBox_DataBase_Vacuumize
  #Option_DataBase_Vacuumize_Public
  #Option_DataBase_Vacuumize_Private

  #CheckBox_ReadWriteBinary
  #Option_ReadWriteBinary_Public
  #Option_ReadWriteBinary_Private
  
  #CheckBox_CreateBinary
  #Option_CreateBinary_Public
  #Option_CreateBinary_Private
  
  #CheckBox_OpenBinary
  #Option_OpenBinary_Public
  #Option_OpenBinary_Private
  
  #CheckBox_ReadBinary
  #Option_ReadBinary_Public
  #Option_ReadBinary_Private

  #CheckBox_ReadWriteEncoded
  #Option_ReadWriteEncoded_Public
  #Option_ReadWriteEncoded_Private
  
  #CheckBox_CreateEncoded
  #Option_CreateEncoded_Public
  #Option_CreateEncoded_Private
  
  #CheckBox_OpenEncoded
  #Option_OpenEncoded_Public
  #Option_OpenEncoded_Private
  
  #CheckBox_ReadEncoded
  #Option_ReadEncoded_Public
  #Option_ReadEncoded_Private

  #CheckBox_ReadWriteCrypted
  #Option_ReadWriteCrypted_Public
  #Option_ReadWriteCrypted_Private
  
  #CheckBox_CreateCrypted
  #Option_CreateCrypted_Public
  #Option_CreateCrypted_Private
  
  #CheckBox_OpenCrypted
  #Option_OpenCrypted_Public
  #Option_OpenCrypted_Private

  #CheckBox_ReadCrypted
  #Option_ReadCrypted_Public
  #Option_ReadCrypted_Private
  
  #CheckBox_Debugging
  #Option_Debugging_Public
  #Option_Debugging_Private

  #Frame_Project_SavePath
  #String_Project_SavePath
  #Button_Browse_Project_SavePath
  
  #Frame_Editor_Color
  #Text_Editor_FontName
  #Text_Editor_FontSize
  #String_Editor_FontName
  #String_Editor_FontSize
  #Button_Editor_FontSelect 
  
  #Frame_User
  #Text_User_Name
  #String_User_Name
  #Text_User_NickName
  #String_User_NickName
  #Text_User_Email
  #String_User_Email
  
  #Frame_Source_Formatting
  #Option_Use_NBSPACE_Tabulation
  #Option_Use_ASCII_Tabulation
  #TrackBar_Tabulation_Size
  #Text_Tabulation_Size
  
  #Frame_Date_Formatting
  #ComboBox_Date_Format
  #Button_Delete_Date_Mask
  #Button_Date_Format_Editor
  
  #Frame_Keyword_Bold
  #CheckBox_Keyword_Bold
  
  #Frame_Syntax_Colors
  #Scroll_Syntax_Colors
  
  #Text_DefaultForeColor
  #Text_DefaultBackColor
  #Text_CaretForeColor
  #Text_CaretBackColor
  #Text_SelectionForeColor
  #Text_SelectionBackColor
  #Text_LineNumbersForeColor
  #Text_LineNumbersBackColor
  #Text_FoldMarginHiBackColor
  #Text_FoldMarginLoBackColor
  #Text_FoldMarkerForeColor
  #Text_FoldMarkerBackColor
  #Text_LineHighlightColor
  #Text_KeywordsColor
  #Text_CommentColor
  #Text_LiteralStringColor
  #Text_NumbersColor
  #Text_ConstantsColor
  #Text_ProceduresColor
  #Text_SeperatorsColor
  #Text_OperatorsColor
  #Text_TypesColor
  #Text_ModulesColor
  #Text_PointersColor
  
  #PreviewColor_DefaultForeColor
  #PreviewColor_DefaultBackColor
  #PreviewColor_CaretForeColor
  #PreviewColor_CaretBackColor
  #PreviewColor_SelectionForeColor
  #PreviewColor_SelectionBackColor
  #PreviewColor_LineNumbersForeColor
  #PreviewColor_LineNumbersBackColor
  #PreviewColor_FoldMarginHiBackColor
  #PreviewColor_FoldMarginLoBackColor
  #PreviewColor_FoldMarkerForeColor
  #PreviewColor_FoldMarkerBackColor
  #PreviewColor_LineHighlightColor
  #PreviewColor_KeywordsColor
  #PreviewColor_CommentColor
  #PreviewColor_LiteralStringColor
  #PreviewColor_NumbersColor
  #PreviewColor_ConstantsColor
  #PreviewColor_ProceduresColor
  #PreviewColor_SeperatorsColor
  #PreviewColor_OperatorsColor
  #PreviewColor_TypesColor
  #PreviewColor_ModulesColor
  #PreviewColor_PointersColor
  
  #Button_Options_OK
  #Button_Options_CANCEL
  
  
  
  
  
  
  
  
  
  
  
  #ComboBox_Html_Help_Files
  #Web_Html_Help_File
  
  #Button_PushPin
  #Button_New
  #Button_Open
  #Button_Save
  #Button_Code
  #Button_Brush
  #Button_ClipBoard
  #Button_Language
  #Button_Options
  #Button_Quit
  
  
  
  
  
  
  
  
  #Shortcut_Matrix_Field_Setup
  #ShortCut_Matrix_Encoded
  #ShortCut_Stats_Windows
  
EndEnumeration

Enumeration 1
  
  #STYLES_COMMANDS
  #STYLES_COMMENTS
  #STYLES_LITERAL_STRINGS
  #STYLES_NUMBERS
  #STYLES_CONSTANTS
  #STYLES_FUNCTIONS
  #STYLES_SEPARATORS
  #STYLES_OPERATORS
  #STYLES_TYPES
  #STYLES_MODULES
  #STYLES_POINTERS
  
EndEnumeration

CompilerSelect #PB_Compiler_OS
    
  CompilerCase #PB_OS_Windows 
    #PathSep = "\"
    
  CompilerCase #PB_OS_Linux
    #PathSep = "/"
    
  CompilerCase #PB_OS_MacOS
    #PathSep = "/"
    
CompilerEndSelect

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 LTS (Linux - x64)
; Folding = -
; EnableXP
; CompileSourceDirectory