; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Module - V0.9.2
; Nom du projet : Le nom du projet ici
; Nom du fichier : Nom du fichier
; Version du fichier : 0.0.0
; Programmation :  vrifier
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 22-07-2018
; Mise  jour : 26-07-2018
; Cod pour PureBasic : V5.70 beta 1
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule DynamicArrayMethods

  Declare.b GetSort()
  Declare.b GetLinearSearch()
  Declare.b GetBinarySearch()
  Declare.b GetInsert()
  Declare.b GetExtract()
  Declare SetSort(P_Sort.b)
  Declare SetLinearSearch(P_LinearSearch.b)
  Declare SetBinarySearch(P_BinarySearch.b)
  Declare SetInsert(P_Insert.b)
  Declare SetExtract(P_Extract.b)
  Declare Reset()
  Declare ReadPrefs(P_GroupName.s)
  Declare WritePrefs(P_GroupName.s)
  
  Declare.s DeclareSort()
  Declare.s DeclareLinearSearch()
  Declare.s DeclareBinarySearch()
  Declare.s DeclareInsert()
  Declare.s DeclareExtract()
  
  Declare.s DefineSort()
  Declare.s DefineLinearSearch()
  Declare.s DefineBinarySearch()
  Declare.s DefineInsert()
  Declare.s DefineExtract()
  
EndDeclareModule

Module DynamicArrayMethods

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Dclaration de la Structure <<<<<

  Structure Instance

    Sort.b
    LinearSearch.b
    BinarySearch.b
    Insert.b
    Extract.b

  EndStructure

  Global Instance.Instance

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les observateurs <<<<<

  Procedure.b GetSort()

    ProcedureReturn Instance\Sort
  EndProcedure

  Procedure.b GetLinearSearch()

    ProcedureReturn Instance\LinearSearch
  EndProcedure

  Procedure.b GetBinarySearch()

    ProcedureReturn Instance\BinarySearch
  EndProcedure

  Procedure.b GetInsert()

    ProcedureReturn Instance\Insert
  EndProcedure

  Procedure.b GetExtract()

    ProcedureReturn Instance\Extract
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les mutateurs <<<<<

  Procedure SetSort(P_Sort.b)

    Instance\Sort = P_Sort

  EndProcedure

  Procedure SetLinearSearch(P_LinearSearch.b)

    Instance\LinearSearch = P_LinearSearch

  EndProcedure

  Procedure SetBinarySearch(P_BinarySearch.b)

    Instance\BinarySearch = P_BinarySearch

  EndProcedure

  Procedure SetInsert(P_Insert.b)

    Instance\Insert = P_Insert

  EndProcedure

  Procedure SetExtract(P_Extract.b)

    Instance\Extract = P_Extract

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Reset <<<<<

  Procedure Reset()
    
    ; ResetStructure(Instance, Instance)
    
    Instance\Sort = 0
    Instance\LinearSearch = 0
    Instance\BinarySearch = 0
    Instance\Insert = 0
    Instance\Extract = 0
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Lecture d'un groupe Prfrences <<<<<

  Procedure ReadPrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    Instance\Sort = ReadPreferenceLong("Sort", Instance\Sort)
    Instance\LinearSearch = ReadPreferenceLong("LinearSearch", Instance\LinearSearch)
    Instance\BinarySearch = ReadPreferenceLong("BinarySearch", Instance\BinarySearch)
    Instance\Insert = ReadPreferenceLong("Insert", Instance\Insert)
    Instance\Extract = ReadPreferenceLong("Extract", Instance\Extract)
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<

  Procedure WritePrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    WritePreferenceLong("Sort", Instance\Sort)
    WritePreferenceLong("LinearSearch", Instance\LinearSearch)
    WritePreferenceLong("BinarySearch", Instance\BinarySearch)
    WritePreferenceLong("Insert", Instance\Insert)
    WritePreferenceLong("Extract", Instance\Extract)
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Sort <<<<<
  
  Procedure.s DeclareSort()
    
    For Target = 0 To 1
      
      If Field::FirstInstance(Target)
        
        Repeat
          
          If Field::GetFieldStyle(Target) = Field::#FIELD_STYLE_ARRAY
            
            If Field::GetFieldType(Target) <= Field::#FIELD_TYPE_STRING02
              
              Output.s + Comments::Tabulation(1) + "Declare Sort" + Field::GetFieldName(Target) + "(P_Options.l)" + LineFeed::Single()
              
            ElseIf Field::GetFieldType(Target) = Field::#FIELD_TYPE_STRUCTURE
              
              If Field::FirstSubField(Target)
                
                Repeat
                  
                  If Field::GetSubFieldStyle(Target) = Field::#FIELD_STYLE_BASIC
                    
                    If Field::GetSubFieldType(Target) <= Field::#FIELD_TYPE_STRING02
                      Output + Comments::Tabulation(1) + "Declare Sort" + Field::GetFieldName(Target) + "By" + Field::GetSubFieldName(Target) + "(P_Options.l)" + LineFeed::Single()
                    EndIf
                    
                  EndIf
                  
                Until Field::NextSubField(Target) = #Null
                
              EndIf
              
            EndIf
            
          EndIf
          
        Until Field::NextInstance(Target) = #Null
        
      EndIf
      
    Next
    
    ProcedureReturn Output 
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration de fouille linaire <<<<<
  
  Procedure.s DeclareLinearSearch()
    
    If Field::FirstInstance(0)
      
      Repeat
        
        If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_ARRAY
          
          If Field::GetFieldType(0) <= Field::#FIELD_TYPE_STRING02
            
            If Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING02
              Output.s + Comments::Tabulation(1) + "Declare.l LinearSearch" + Field::GetFieldName(0) + "(P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) + ", P_CaseSensitive.b = #True)" + LineFeed::Single()
            Else
              Output + Comments::Tabulation(1) + "Declare.l LinearSearch" + Field::GetFieldName(0) + "(P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) + ")" + LineFeed::Single()
            EndIf
            
          ElseIf Field::GetFieldType(0) = Field::#FIELD_TYPE_STRUCTURE
            
            If Field::FirstSubField(0)
              
              Repeat
                
                If Field::GetSubFieldStyle(0) = Field::#FIELD_STYLE_BASIC
                  
                  If Field::GetSubFieldType(0) = Field::#FIELD_TYPE_STRING01 Or Field::GetSubFieldType(0) = Field::#FIELD_TYPE_STRING02
                    Output + Comments::Tabulation(1) + "Declare.l LinearSearch" + Field::GetFieldName(0) + "By" + Field::GetSubFieldName(0) + "(P_" + Field::GetSubFieldName(0) + Field::GetSubFieldExtensionLong(0) + ", P_CaseSensitive.b = #True)" + LineFeed::Single()
                  Else
                    Output + Comments::Tabulation(1) + "Declare.l LinearSearch" + Field::GetFieldName(0) + "By" + Field::GetSubFieldName(0) + "(P_" + Field::GetSubFieldName(0) + Field::GetSubFieldExtensionLong(0) + ")" + LineFeed::Single()
                  EndIf
                  
                EndIf
                
              Until Field::NextSubField(0) = #Null
              
            EndIf
            
          EndIf
          
        EndIf
        
      Until Field::NextInstance(0) = #Null
      
    EndIf
    
    If Field::FirstInstance(1)
      
      Repeat
        
        If Field::GetFieldStyle(1) = Field::#FIELD_STYLE_ARRAY
          
          If Field::GetFieldType(1) <= Field::#FIELD_TYPE_STRING02
            
            If Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING02
              Output + Comments::Tabulation(1) + "Declare.l LinearSearch" + Field::GetFieldName(1) + "(P_" + Field::GetFieldName(1) + Field::GetFieldExtensionLong(1) + ", P_CaseSensitive.b = #True)" + LineFeed::Single()
            Else
              Output + Comments::Tabulation(1) + "Declare.l LinearSearch" + Field::GetFieldName(1) + "(P_" + Field::GetFieldName(1) + Field::GetFieldExtensionLong(1) + ")" + LineFeed::Single()
            EndIf
            
          ElseIf Field::GetFieldType(0) = Field::#FIELD_TYPE_STRUCTURE
            
            If Field::FirstSubField(1)
              
              Repeat
                
                If Field::GetSubFieldStyle(1) = Field::#FIELD_STYLE_BASIC
                  
                  If Field::GetSubFieldType(1) = Field::#FIELD_TYPE_STRING01 Or Field::GetSubFieldType(1) = Field::#FIELD_TYPE_STRING02
                    Output + Comments::Tabulation(1) + "Declare.l LinearSearch" + Field::GetFieldName(1) + "By" + Field::GetSubFieldName(1) + "(P_" + Field::GetSubFieldName(1) + Field::GetSubFieldExtensionLong(0) + ", P_CaseSensitive.b = #True)" + LineFeed::Single()
                  Else
                    Output + Comments::Tabulation(1) + "Declare.l LinearSearch" + Field::GetFieldName(1) + "By" + Field::GetSubFieldName(1) + "(P_" + Field::GetSubFieldName(1) + Field::GetSubFieldExtensionLong(0) + ")" + LineFeed::Single()
                  EndIf
                  
                EndIf
                
              Until Field::NextSubField(1) = #Null
              
            EndIf
            
          EndIf
          
        EndIf
        
      Until Field::NextInstance(1) = #Null
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration de fouille dichotomique <<<<<
  
  Procedure.s DeclareBinarySearch()
    
    If Field::FirstInstance(0)
      
      Repeat
        
        If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_ARRAY
          
          If Field::GetFieldType(0) <= Field::#FIELD_TYPE_STRING02
            
            If Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING02
              Output.s + Comments::Tabulation(1) + "Declare.l BinarySearch" + Field::GetFieldName(0) + "(P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) + ", P_CaseSensitive.b = #True)" + LineFeed::Single()
            Else
              Output + Comments::Tabulation(1) + "Declare.l BinarySearch" + Field::GetFieldName(0) + "(P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) + ")" + LineFeed::Single()
            EndIf
            
          ElseIf Field::GetFieldType(0) = Field::#FIELD_TYPE_STRUCTURE
            
            If Field::FirstSubField(0)
              
              Repeat
                
                If Field::GetSubFieldStyle(0) = Field::#FIELD_STYLE_BASIC
                  
                  If Field::GetSubFieldType(0) = Field::#FIELD_TYPE_STRING01 Or Field::GetSubFieldType(0) = Field::#FIELD_TYPE_STRING02
                    Output + Comments::Tabulation(1) + "Declare.l BinarySearch" + Field::GetFieldName(0) + "By" + Field::GetSubFieldName(0) + "(P_" + Field::GetSubFieldName(0) + Field::GetSubFieldExtensionLong(0) + ", P_CaseSensitive.b = #True)" + LineFeed::Single()
                  Else
                    Output + Comments::Tabulation(1) + "Declare.l BinarySearch" + Field::GetFieldName(0) + "By" + Field::GetSubFieldName(0) + "(P_" + Field::GetSubFieldName(0) + Field::GetSubFieldExtensionLong(0) + ")" + LineFeed::Single()
                  EndIf
                  
                EndIf
                
              Until Field::NextSubField(0) = #Null
              
            EndIf
            
          EndIf
          
        EndIf
        
      Until Field::NextInstance(0) = #Null
      
    EndIf
    
    If Field::FirstInstance(1)
      
      Repeat
        
        If Field::GetFieldStyle(1) = Field::#FIELD_STYLE_ARRAY
          
          If Field::GetFieldType(1) <= Field::#FIELD_TYPE_STRING02
            
            If Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING02
              Output + Comments::Tabulation(1) + "Declare.l BinarySearch" + Field::GetFieldName(1) + "(P_" + Field::GetFieldName(1) + Field::GetFieldExtensionLong(1) + ", P_CaseSensitive.b = #True)" + LineFeed::Single()
            Else
              Output + Comments::Tabulation(1) + "Declare.l BinarySearch" + Field::GetFieldName(1) + "(P_" + Field::GetFieldName(1) + Field::GetFieldExtensionLong(1) + ")" + LineFeed::Single()
            EndIf
            
          ElseIf Field::GetFieldType(0) = Field::#FIELD_TYPE_STRUCTURE
            
            If Field::FirstSubField(1)
              
              Repeat
                
                If Field::GetSubFieldStyle(1) = Field::#FIELD_STYLE_BASIC
                  
                  If Field::GetSubFieldType(1) = Field::#FIELD_TYPE_STRING01 Or Field::GetSubFieldType(1) = Field::#FIELD_TYPE_STRING02
                    Output + Comments::Tabulation(1) + "Declare.l BinarySearch" + Field::GetFieldName(1) + "By" + Field::GetSubFieldName(1) + "(P_" + Field::GetSubFieldName(1) + Field::GetSubFieldExtensionLong(0) + ", P_CaseSensitive.b = #True)" + LineFeed::Single()
                  Else
                    Output + Comments::Tabulation(1) + "Declare.l BinarySearch" + Field::GetFieldName(1) + "By" + Field::GetSubFieldName(1) + "(P_" + Field::GetSubFieldName(1) + Field::GetSubFieldExtensionLong(0) + ")" + LineFeed::Single()
                  EndIf
                  
                EndIf
                
              Until Field::NextSubField(1) = #Null
              
            EndIf
            
          EndIf
          
        EndIf
        
      Until Field::NextInstance(1) = #Null
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Insert <<<<<
  
  Procedure.s DeclareInsert()
    
    For Target = 0 To 1
      
      If Field::FirstInstance(Target)
        
        Repeat
          
          If Field::GetFieldStyle(Target) = Field::#FIELD_STYLE_ARRAY
            
            If Field::GetFieldType(Target) <= Field::#FIELD_TYPE_STRING02
              Output.s + Comments::Tabulation(1) + "Declare Insert" + Field::GetFieldName(Target) + "(Array ToBeInserted" + Field::GetFieldExtensionLong(Target) + "())" + LineFeed::Single() 
            ElseIf Field::GetFieldType(Target) = Field::#FIELD_TYPE_MODULE
              Output.s + Comments::Tabulation(1) + "Declare Insert" + Field::GetFieldName(Target) + "(Array ToBeInserted." + Field::GetFieldExternModuleName(Target) + "::" + Field::GetFieldExternModuleStructure(Target) + "())" + LineFeed::Single() 
            ElseIf Field::GetFieldType(Target) = Field::#FIELD_TYPE_STRUCTURE
              
              If Field::FirstSubField(Target)
                
                Repeat 
                  
                  If Field::GetSubFieldStyle(Target) = Field::#FIELD_STYLE_ARRAY
                    
                    If Field::GetFieldType(Target) <= Field::#FIELD_TYPE_STRING02
                      Output + Comments::Tabulation(1) + "Declare Insert" + Field::GetFieldName(Target) + Field::GetSubFieldName(Target) + "(Array ToBeInserted" + Field::GetSubFieldExtensionLong(Target) + "())" + LineFeed::Single() 
                    ElseIf Field::GetFieldType(Target) = Field::#FIELD_TYPE_MODULE
                      Output + Comments::Tabulation(1) + "Declare Insert" + Field::GetFieldName(Target) + Field::GetSubFieldName(Target) + "(Array ToBeInserted." + Field::GetSubFieldExternModuleName(Target) + "::" + Field::GetSubFieldExternModuleStructure(Target) +  "())" + LineFeed::Single() 
                    EndIf
                    
                  EndIf
                  
                Until Field::NextSubField(Target) = #Null
                
              EndIf
              
            EndIf
            
          EndIf
          
        Until Field::NextInstance(Target) = #Null
        
      EndIf
      
    Next
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration Extract <<<<<
  
  Procedure.s DeclareExtract()
    
    For Target = 0 To 1
      
      If Field::FirstInstance(Target)
        
        Repeat
          
          If Field::GetFieldStyle(Target) = Field::#FIELD_STYLE_ARRAY
            
            If Field::GetFieldType(Target) <= Field::#FIELD_TYPE_STRING02
              Output.s + Comments::Tabulation(1) + "Declare Extract" + Field::GetFieldName(Target) + "(Array Extracted" + Field::GetFieldExtensionLong(Target) + "())" + LineFeed::Single() 
            ElseIf Field::GetFieldType(Target) = Field::#FIELD_TYPE_MODULE
              Output.s + Comments::Tabulation(1) + "Declare Extract" + Field::GetFieldName(Target) + "(Array Extracted." + Field::GetFieldExternModuleName(Target) + "::" + Field::GetFieldExternModuleStructure(Target) + "())" + LineFeed::Single() 
            ElseIf Field::GetFieldType(Target) = Field::#FIELD_TYPE_STRUCTURE
              
              If Field::FirstSubField(Target)
                
                Repeat 
                  
                  If Field::GetSubFieldStyle(Target) = Field::#FIELD_STYLE_ARRAY
                    
                    If Field::GetFieldType(Target) <= Field::#FIELD_TYPE_STRING02
                      Output + Comments::Tabulation(1) + "Declare Extract" + Field::GetFieldName(Target) + Field::GetSubFieldName(Target) + "(Array Extracted" + Field::GetSubFieldExtensionLong(Target) + "())" + LineFeed::Single() 
                    ElseIf Field::GetFieldType(Target) = Field::#FIELD_TYPE_MODULE
                      Output + Comments::Tabulation(1) + "Declare Extract" + Field::GetFieldName(Target) + Field::GetSubFieldName(Target) + "(Array Extracted." + Field::GetSubFieldExternModuleName(Target) + "::" + Field::GetSubFieldExternModuleStructure(Target) +  "())" + LineFeed::Single() 
                    EndIf
                    
                  EndIf
                  
                Until Field::NextSubField(Target) = #Null
                
              EndIf
              
            EndIf
            
          EndIf
          
        Until Field::NextInstance(Target) = #Null
        
      EndIf
      
    Next
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Sort <<<<<
  
  Procedure.s DefineSort()
    
    For Target = 0 To 1
      
      If Field::FirstInstance(Target)
        
        If Target = 0
          InstanceStyle.s = Field::GetInstanceAccessPath()
        Else
          InstanceStyle = "Secondary\"
        EndIf
        
        Repeat
          
          If Field::GetFieldStyle(Target) = Field::#FIELD_STYLE_ARRAY
            
            If Field::GetFieldType(Target) <= Field::#FIELD_TYPE_STRING02
              
              Output.s + Comments::Tabulation(1) + "Procedure Sort" + Field::GetFieldName(Target) + "(P_Options.l)" + LineFeed::Twin()
              
              If Field::GetFieldType(Target) = Field::#FIELD_TYPE_STRING01
                Output + Comments::Tabulation(2) + "SortArray(" + InstanceStyle + Field::GetFieldName(Target) + "$(), P_Options)" + LineFeed::Twin()
              Else
                Output + Comments::Tabulation(2) + "SortArray(" + InstanceStyle + Field::GetFieldName(Target) + "(), P_Options)" + LineFeed::Twin()
              EndIf
              
              Output + Comments::Tabulation(1) + "EndProcedure" + LineFeed::Twin() 
              
            ElseIf Field::GetFieldType(Target) = Field::#FIELD_TYPE_STRUCTURE
              
              If Field::FirstSubField(Target)
                
                Repeat
                  
                  If Field::GetSubFieldStyle(Target) = Field::#FIELD_STYLE_BASIC
                    
                    If Field::GetSubFieldType(Target) <= Field::#FIELD_TYPE_STRING02
                      
                      Output + Comments::Tabulation(1) + "Procedure Sort" + Field::GetFieldName(Target) + "By" + Field::GetSubFieldName(Target) + "(P_Options.l)" + LineFeed::Twin()
                      
                      If Field::GetSubFieldType(Target) = Field::#FIELD_TYPE_STRING01
                        StructField.s = Field::GetFieldExtensionShort(Target) + "\" + Field::GetSubFieldName(Target) + "$"
                      Else
                        StructField.s = Field::GetFieldExtensionShort(Target) + "\" + Field::GetSubFieldName(Target)
                      EndIf
                      
                      Output + Comments::Tabulation(2) + "SortStructuredArray(" + InstanceStyle + Field::GetFieldName(Target) + "(), P_Options, OffsetOf(" + StructField + "), TypeOf(" + StructField + "))" + LineFeed::Twin()
                      
                      Output + Comments::Tabulation(1) + "EndProcedure"  + LineFeed::Twin()
                      
                    EndIf
                    
                  EndIf
                  
                Until Field::NextSubField(Target) = #Null
                
              EndIf
              
            EndIf
            
          EndIf
          
        Until Field::NextInstance(Target) = #Null
        
      EndIf
      
    Next
 
    ProcedureReturn Output 
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition de fouille linaire <<<<<
  
  Procedure.s DefineLinearSearch()
    
    For Target = 0 To 1
      
      If Field::FirstInstance(Target)
        
        If Target = 0
          InstanceStyle.s = Field::GetInstanceAccessPath()
        Else
          InstanceStyle = "Secondary\"
        EndIf
        
        Repeat
          
          If Field::GetFieldStyle(Target) = Field::#FIELD_STYLE_ARRAY
            
            If Field::GetFieldType(Target) <= Field::#FIELD_TYPE_STRING02
              
              If Field::GetFieldType(Target) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(Target) = Field::#FIELD_TYPE_STRING02
                Output.s + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Field::GetFieldName(Target) + "(P_" + Field::GetFieldName(Target) + Field::GetFieldExtensionLong(Target) + ", P_CaseSensitive.b = #True)" + LineFeed::Twin()
                Flag = 1
              Else
                Output + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Field::GetFieldName(Target) + "(P_" + Field::GetFieldName(Target) + Field::GetFieldExtensionLong(Target) + ")" + LineFeed::Twin()
                Flag = 0
              EndIf
              
              Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + LineFeed::Twin()
              
              ArraySizeLoop.s = "For Index = 0 To ArraySize(" + Field::GetFieldName(Target) + "(), 1)"
              
              If Field::GetFieldType(Target) = Field::#FIELD_TYPE_STRING01
                Test01.s = "UCase(" + Field::GetFieldName(Target) + "$(Index)) = UCase(P_" + Field::GetFieldName(Target) + "$)"
                Test02.s = Field::GetFieldName(Target) + "$(Index) = P_" + Field::GetFieldName(Target) + "$"
              Else
                Test01.s = "UCase(" + Field::GetFieldName(Target) + "(Index)) = UCase(P_" + Field::GetFieldName(Target) + ")"
                Test02.s = Field::GetFieldName(Target) + "(Index) = P_" + Field::GetFieldName(Target)
              EndIf
              
              If Flag = 1
                Output + Comments::Tabulation(2) + "If P_CaseSensitive = #True" + LineFeed::Twin()
                Output + Field::InsertLinearSearch(3, ArraySizeLoop, Test01) + LineFeed::Single()
                Output + Comments::Tabulation(2) + "Else" + LineFeed::Twin()
                Output + Field::InsertLinearSearch(3, ArraySizeLoop, Test02) + LineFeed::Single()
                Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              Else 
                Output + Field::InsertLinearSearch(2, ArraySizeLoop, Test02) + LineFeed::Single()
              EndIf
              
              Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex"+ LineFeed::Single()
              Output + Comments::Tabulation(1) + "EndProcedure"  + LineFeed::Twin()
              
            ElseIf Field::GetFieldType(Target) = Field::#FIELD_TYPE_STRUCTURE
              
              If Field::FirstSubField(Target)
                
                Repeat
                  
                  If Field::GetSubFieldStyle(Target) = Field::#FIELD_STYLE_BASIC
                    
                    If Field::GetSubFieldType(Target) <= Field::#FIELD_TYPE_STRING02
                      
                      If Field::GetSubFieldType(Target) = Field::#FIELD_TYPE_STRING01 Or Field::GetSubFieldType(Target) = Field::#FIELD_TYPE_STRING02
                        Output + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Field::GetFieldName(Target) + "By" + Field::GetSubFieldName(Target) + "(P_" + Field::GetSubFieldName(Target) + Field::GetSubFieldExtensionLong(Target) + ", P_CaseSensitive.b = #True)" + LineFeed::Twin()
                        Flag = 1
                      Else
                        Output + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Field::GetFieldName(Target) + "By" + Field::GetSubFieldName(Target) + "(P_" + Field::GetSubFieldName(Target) + Field::GetSubFieldExtensionLong(Target) + ")" + LineFeed::Twin()
                        Flag = 0
                      EndIf
                      
                      Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + LineFeed::Twin()
                      
                      ArraySizeLoop.s = "For Index = 0 To ArraySize(" + Field::GetFieldName(Target) + "(), 1)"
                      
                      If Field::GetSubFieldType(Target) = Field::#FIELD_TYPE_STRING01
                        Test01.s = "UCase(" + Field::GetFieldName(Target) + "(Index)\" + Field::GetSubFieldName(Target) + "$) = UCase(P_" + Field::GetSubFieldName(Target) + "$)"
                        Test02.s = Field::GetFieldName(Target) + "(Index)\" + Field::GetSubFieldName(Target) + "$ = P_" + Field::GetSubFieldName(Target) + "$"
                      Else
                        Test01.s = "UCase(" + Field::GetFieldName(Target) + "(Index)\" + Field::GetSubFieldName(Target) + ") = UCase(P_" + Field::GetSubFieldName(Target) + ")"
                        Test02.s = Field::GetFieldName(Target) + "(Index)\" + Field::GetSubFieldName(Target) + " = P_" + Field::GetSubFieldName(Target)
                      EndIf
                      
                      If Flag = 1
                        Output + Comments::Tabulation(2) + "If P_CaseSensitive = #False" + LineFeed::Twin()
                        Output + Field::InsertLinearSearch(3, ArraySizeLoop, Test01) + LineFeed::Single()
                        Output + Comments::Tabulation(2) + "Else" + LineFeed::Twin()
                        Output + Field::InsertLinearSearch(3, ArraySizeLoop, Test02) + LineFeed::Single()
                        Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
                      Else 
                        Output + Field::InsertLinearSearch(2, ArraySizeLoop, Test02) + LineFeed::Single()
                      EndIf
                      
                      Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex" + LineFeed::Single()             
                      Output + Comments::Tabulation(1) + "EndProcedure"  + LineFeed::Twin()
                    EndIf
                    
                  EndIf
                  
                Until Field::NextSubField(Target) = #Null
                
              EndIf
              
            EndIf
            
          EndIf
          
        Until Field::NextInstance(Target) = #Null
        
      EndIf
      
    Next
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition de fouille dichotomique <<<<<
  
  Procedure.s DefineBinarySearch()
    
    For Target = 0 To 1
      
      If Field::FirstInstance(Target)
        
        If Target = 0 
          InstanceStyle.s = Field::GetInstanceAccessPath() 
        Else
          InstanceStyle = "Secondary\"
        EndIf
        
        Repeat
          
          If Field::GetFieldStyle(Target) = Field::#FIELD_STYLE_ARRAY
            
            If Field::GetFieldType(Target) <= Field::#FIELD_TYPE_STRING02
              
              If Field::GetFieldType(Target) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(Target) = Field::#FIELD_TYPE_STRING02
                Output.s + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Field::GetFieldName(Target) + "(P_" + Field::GetFieldName(Target) + Field::GetFieldExtensionLong(Target) + ", P_CaseSensitive.b = #True)" + LineFeed::Twin()
                Flag = 1
              Else
                Output + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Field::GetFieldName(Target) + "(P_" + Field::GetFieldName(Target) + Field::GetFieldExtensionLong(Target) + ")" + LineFeed::Twin()
                Flag = 0
              EndIf
              
              Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + LineFeed::Single()
              Output + Comments::Tabulation(2) + "Protected StartPosition.l = 0" + LineFeed::Single()
              Output + Comments::Tabulation(2) + "Protected MiddlePosition.l = 0" + LineFeed::Single()
              
              If Field::GetFieldType(Target) = Field::#FIELD_TYPE_STRING01
                Output + Comments::Tabulation(2) + "Protected EndPosition.l = ArraySize(" + Field::GetFieldName(Target) + "$(), 1)"+ LineFeed::Twin()
                Test01.s = "UCase(P_" + Field::GetFieldName(Target) + "$) < UCase(" + Field::GetFieldName(Target) + "$(MiddlePosition))"
                Test02.s = "UCase(P_" + Field::GetFieldName(Target) + "$) > UCase(" + Field::GetFieldName(Target) + "$(MiddlePosition))"
                Test03.s = "P_" + Field::GetFieldName(Target) + "$ < " + Field::GetFieldName(Target) + "$(MiddlePosition)"
                Test04.s = "P_" + Field::GetFieldName(Target) + "$ > " + Field::GetFieldName(Target) + "$(MiddlePosition)"
              Else
                Output + Comments::Tabulation(2) + "Protected EndPosition.l = ArraySize(" + Field::GetFieldName(Target) + "(), 1)"+ LineFeed::Twin()
                Test01.s = "UCase(P_" + Field::GetFieldName(Target) + ") < UCase(" + Field::GetFieldName(Target) + "(MiddlePosition))"
                Test02.s = "UCase(P_" + Field::GetFieldName(Target) + ") > UCase(" + Field::GetFieldName(Target) + "(MiddlePosition))"
                Test03.s = "P_" + Field::GetFieldName(Target) + " < " + Field::GetFieldName(Target) + "(MiddlePosition)"
                Test04.s = "P_" + Field::GetFieldName(Target) + " > " + Field::GetFieldName(Target) + "(MiddlePosition)"
              EndIf
              
              If Flag = 1
                Output + Comments::Tabulation(2) + "If P_CaseSensitive = #False" + LineFeed::Twin()
                Output + Comments::Tabulation(3) + "If EndPosition > 1" + LineFeed::Twin()
                Output + Field::InsertBinarySearch(4, "", Test01, Test02) + LineFeed::Single()
                Output + Comments::Tabulation(3) + "EndIf" + LineFeed::Twin()
                Output + Comments::Tabulation(2) + "Else" + LineFeed::Twin()
                Output + Comments::Tabulation(3) + "If EndPosition > 1" + LineFeed::Twin()
                Output + Field::InsertBinarySearch(4, "", Test03, Test04) + LineFeed::Single()
                Output + Comments::Tabulation(3) + "EndIf" + LineFeed::Twin()
                Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              Else 
                Output + Comments::Tabulation(2) + "If EndPosition > 1" + LineFeed::Twin()
                Output + Field::InsertBinarySearch(3, "", Test03, Test04) + LineFeed::Single()
                Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              EndIf
              
              Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex"+ LineFeed::Single()
              Output + Comments::Tabulation(1) + "EndProcedure"  + LineFeed::Twin()
              
            ElseIf Field::GetFieldType(Target) = Field::#FIELD_TYPE_STRUCTURE
              
              If Field::FirstSubField(Target)
                
                Repeat
                  
                  If Field::GetSubFieldStyle(Target) = Field::#FIELD_STYLE_BASIC
                    
                    If Field::GetSubFieldType(Target) <= Field::#FIELD_TYPE_STRING02
                      
                      If Field::GetSubFieldType(Target) = Field::#FIELD_TYPE_STRING01 Or Field::GetSubFieldType(Target) = Field::#FIELD_TYPE_STRING02
                        Output + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Field::GetFieldName(Target) + "By" + Field::GetSubFieldName(Target) + "(P_" + Field::GetSubFieldName(Target) + Field::GetSubFieldExtensionLong(Target) + ", P_CaseSensitive.b = #True)" + LineFeed::Twin()
                        Flag = 1
                      Else
                        Output + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Field::GetFieldName(Target) + "By" + Field::GetSubFieldName(Target) + "(P_" + Field::GetSubFieldName(Target) + Field::GetSubFieldExtensionLong(Target) + ")" + LineFeed::Twin()
                        Flag = 0
                      EndIf
                      
                      Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + LineFeed::Single()
                      Output + Comments::Tabulation(2) + "Protected StartPosition.l = 0" + LineFeed::Single()
                      Output + Comments::Tabulation(2) + "Protected MiddlePosition.l = 0" + LineFeed::Single()
                      Output + Comments::Tabulation(2) + "Protected EndPosition.l = ArraySize(" + Field::GetFieldName(Target) + "(), 1)"+ LineFeed::Twin()
                      
                      If Field::GetSubFieldType(Target) = Field::#FIELD_TYPE_STRING01
                        Test01.s = "UCase(P_" + Field::GetSubFieldName(Target) + "$) < UCase(" + Field::GetFieldName(Target) + "(MiddlePosition)\" + Field::GetSubFieldName(Target) + "$)"
                        Test02.s = "UCase(P_" + Field::GetSubFieldName(Target) + "$) > UCase(" + Field::GetFieldName(Target) + "(MiddlePosition)\" + Field::GetSubFieldName(Target) + "$)"
                        Test03.s = "P_" + Field::GetSubFieldName(Target) + "$ < " + Field::GetFieldName(Target) + "(MiddlePosition)\" + Field::GetSubFieldName(Target) + "$"
                        Test04.s = "P_" + Field::GetSubFieldName(Target) + "$ > " + Field::GetFieldName(Target) + "(MiddlePosition)\" + Field::GetSubFieldName(Target) + "$"
                      Else
                        Test01.s = "UCase(P_" + Field::GetSubFieldName(Target) + ") < UCase(" + Field::GetFieldName(Target) + "(MiddlePosition)\" + Field::GetSubFieldName(Target) + ")"
                        Test02.s = "UCase(P_" + Field::GetSubFieldName(Target) + ") > UCase(" + Field::GetFieldName(Target) + "(MiddlePosition)\" + Field::GetSubFieldName(Target) + ")"
                        Test03.s = "P_" + Field::GetSubFieldName(Target) + " < " + Field::GetFieldName(Target) + "(MiddlePosition)\" + Field::GetSubFieldName(Target)
                        Test04.s = "P_" + Field::GetSubFieldName(Target) + " > " + Field::GetFieldName(Target) + "(MiddlePosition)\" + Field::GetSubFieldName(Target)
                      EndIf
                      
                      If Flag = 1
                        Output + Comments::Tabulation(2) + "If P_CaseSensitive = #False" + LineFeed::Twin()
                        Output + Comments::Tabulation(3) + "If EndPosition > 1" + LineFeed::Twin()
                        Output + Field::InsertBinarySearch(4, "", Test01, Test02) + LineFeed::Single()
                        Output + Comments::Tabulation(3) + "EndIf" + LineFeed::Twin()
                        Output + Comments::Tabulation(2) + "Else" + LineFeed::Twin()
                        Output + Comments::Tabulation(3) + "If EndPosition > 1" + LineFeed::Twin()
                        Output + Field::InsertBinarySearch(4, "", Test03, Test04) + LineFeed::Single()
                        Output + Comments::Tabulation(3) + "EndIf" + LineFeed::Twin()
                        Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
                      Else 
                        Output + Comments::Tabulation(2) + "If EndPosition > 1" + LineFeed::Twin()
                        Output + Field::InsertBinarySearch(3, "", Test03, Test04) + LineFeed::Single()
                        Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
                      EndIf   
                      
                      Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex" + LineFeed::Single()             
                      Output + Comments::Tabulation(1) + "EndProcedure"  + LineFeed::Twin()
                      
                    EndIf  
                    
                  EndIf
                  
                Until Field::NextSubField(Target) = #Null
                
              EndIf
              
            EndIf
            
          EndIf
          
        Until Field::NextInstance(Target) = #Null
        
      EndIf
      
    Next
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Insert <<<<<
  
  Procedure.s DefineInsert()
    
    For Target = 0 To 1
      
      If Target = 0
        
        Select General::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_UNIQUE
            InstanceStyle.s = "Instance\"
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
            InstanceStyle.s = "Instances()\"
            
          Case Field::#INSTANCE_STYLE_OFF_MODULE
            InstanceStyle.s = "*" + General::GetModuleName() + "A\"
            
        EndSelect
        
      Else
        
        InstanceStyle = "Secondary\"
        
      EndIf
      
      If Field::FirstInstance(Target)
        
        Repeat
          
          If Field::GetFieldStyle(Target) = Field::#FIELD_STYLE_ARRAY
            
            If Field::GetFieldType(Target) <= Field::#FIELD_TYPE_STRING02
              Output.s + Comments::Tabulation(1) + "Procedure Insert" + Field::GetFieldName(Target) + "(Array ToBeInserted." + Field::GetFieldExtensionShort(Target) + "())" + LineFeed::Single() 
              Output + Comments::Tabulation(2) + "CopyArray(ToBeInserted(), " + InstanceStyle + Field::GetFieldAccess(Target) + ")" + LineFeed::Twin()
              Output + Comments::Tabulation(1) + "EndProcedure"  + LineFeed::Twin()
            ElseIf Field::GetFieldType(Target) = Field::#FIELD_TYPE_MODULE
              Output + Comments::Tabulation(1) + "Procedure Insert" + Field::GetFieldName(Target) + "(Array ToBeInserted." + Field::GetFieldExternModuleName(Target) + "::" + Field::GetFieldExternModuleStructure(Target) + "())" + LineFeed::Twin() 
              Output + Comments::Tabulation(2) + "CopyArray(ToBeInserted(), " + InstanceStyle + Field::GetFieldAccess(Target) + ")" + LineFeed::Twin()
              Output + Comments::Tabulation(1) + "EndProcedure"  + LineFeed::Twin()
            ElseIf Field::GetFieldType(Target) = Field::#FIELD_TYPE_STRUCTURE
              
              If Field::FirstSubField(Target)
                
                Repeat 
                  
                  If Field::GetSubFieldStyle(Target) = Field::#FIELD_STYLE_ARRAY
                    
                    If Field::GetFieldType(Target) <= Field::#FIELD_TYPE_STRING02
                      Output + Comments::Tabulation(1) + "Procedure Insert" + Field::GetFieldName(Target) + Field::GetSubFieldName(Target) + "(Array ToBeInserted" + Field::GetSubFieldExtensionLong(Target) + "())" + LineFeed::Twin() 
                      Output + Comments::Tabulation(2) + "CopyArray(ToBeInserted(), " + InstanceStyle + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + LineFeed::Twin()
                      Output + Comments::Tabulation(1) + "EndProcedure"  + LineFeed::Twin()
                    ElseIf Field::GetFieldType(Target) = Field::#FIELD_TYPE_MODULE
                      Output + Comments::Tabulation(1) + "Procedure Insert" + Field::GetFieldName(Target) + Field::GetSubFieldName(Target) + "(Array ToBeInserted." + Field::GetSubFieldExternModuleName(Target) + "::" + Field::GetSubFieldExternModuleStructure(Target) +  "())" + LineFeed::Twin()
                      Output + Comments::Tabulation(2) + "CopyArray(ToBeInserted(), " + InstanceStyle + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ")" + LineFeed::Twin()
                      Output + Comments::Tabulation(1) + "EndProcedure"  + LineFeed::Twin()
                    EndIf
                    
                  EndIf
                  
                Until Field::NextSubField(Target) = #Null
                
              EndIf
              
            EndIf
            
          EndIf
          
        Until Field::NextInstance(Target) = #Null
        
      EndIf
      
    Next
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition Extract <<<<<
  
  Procedure.s DefineExtract()
    
    For Target = 0 To 1
      
      If Target = 0
        
        Select General::GetInstanceStyle()
            
          Case Field::#INSTANCE_STYLE_UNIQUE
            InstanceStyle.s = "Instance\"
            
          Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX, Field::#INSTANCE_STYLE_MULTIPLE_NAME
            InstanceStyle.s = "Instances()\"
            
          Case Field::#INSTANCE_STYLE_OFF_MODULE
            InstanceStyle.s = "*" + General::GetModuleName() + "A\"
            
        EndSelect
        
      Else
        
        InstanceStyle = "Secondary\"
        
      EndIf
      
      If Field::FirstInstance(Target)
        
        Repeat
          
          If Field::GetFieldStyle(Target) = Field::#FIELD_STYLE_ARRAY
            
            If Field::GetFieldType(Target) <= Field::#FIELD_TYPE_STRING02
              Output.s + Comments::Tabulation(1) + "Procedure Extract" + Field::GetFieldName(Target) + "(Array Extracted" + Field::GetFieldExtensionLOng(Target) + "())" + LineFeed::Twin() 
              Output + Comments::Tabulation(2) + "CopyArray(" + InstanceStyle + Field::GetFieldAccess(Target) + ", Extracted())" + LineFeed::Twin()
              Output + Comments::Tabulation(1) + "EndProcedure"  + LineFeed::Twin()
            ElseIf Field::GetFieldType(Target) = Field::#FIELD_TYPE_MODULE
              Output + Comments::Tabulation(1) + "Procedure Extract" + Field::GetFieldName(Target) + "(Array Extracted." + Field::GetFieldExternModuleName(Target) + "::" + Field::GetFieldExternModuleStructure(Target) + "())" + LineFeed::Twin() 
              Output + Comments::Tabulation(2) + "CopyArray(" + InstanceStyle + Field::GetFieldAccess(Target) + ", Extracted())" + LineFeed::Twin()
              Output + Comments::Tabulation(1) + "EndProcedure"  + LineFeed::Twin()
            ElseIf Field::GetFieldType(Target) = Field::#FIELD_TYPE_STRUCTURE
              
              If Field::FirstSubField(Target)
                
                Repeat 
                  
                  If Field::GetSubFieldStyle(Target) = Field::#FIELD_STYLE_ARRAY
                    
                    If Field::GetFieldType(Target) <= Field::#FIELD_TYPE_STRING02
                      Output + Comments::Tabulation(1) + "Procedure Extract" + Field::GetFieldName(Target) + Field::GetSubFieldName(Target) + "(Array Extracted" + Field::GetSubFieldExtensionLong(Target) + "())" + LineFeed::Twin() 
                      Output + Comments::Tabulation(2) + "CopyArray(" + InstanceStyle + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ", Extracted())" + LineFeed::Twin()
                      Output + Comments::Tabulation(1) + "EndProcedure"  + LineFeed::Twin()
                    ElseIf Field::GetFieldType(Target) = Field::#FIELD_TYPE_MODULE
                      Output + Comments::Tabulation(1) + "Procedure Extract" + Field::GetFieldName(Target) + Field::GetSubFieldName(Target) + "(Array Extracted." + Field::GetSubFieldExternModuleName(Target) + "::" + Field::GetSubFieldExternModuleStructure(Target) +  "())" + LineFeed::Twin() 
                      Output + Comments::Tabulation(2) + "CopyArray(" + InstanceStyle + Field::GetFieldAccess(Target) + "\" + Field::GetSubFieldAccess(Target) + ", Extracted())" + LineFeed::Twin()
                      Output + Comments::Tabulation(1) + "EndProcedure"  + LineFeed::Twin()
                    EndIf
                    
                  EndIf
                  
                Until Field::NextSubField(Target) = #Null
                
              EndIf
              
            EndIf
            
          EndIf
          
        Until Field::NextInstance(Target) = #Null
        
      EndIf
      
    Next
    
    ProcedureReturn Output
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (125000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 LTS (Linux - x64)
; Folding = -----
; EnableXP
; CompileSourceDirectory