; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - Language.pb
; Version du fichier : 0.9.1
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 15-02-2015
; Mise  jour : 06-02-2019
; Code PureBasic : V5.70 LTS
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Language_To_GUI (Private) <<<<<

Procedure Language_To_GUI()
  
  SetWindowTitle(#MainWin, Language::Message("Dev-Module") + #Version)
  
  SetGadgetItemText(#Panel, 0, Language::Message("Module"))
  SetGadgetItemText(#Panel, 1, Language::Message("Methods") + " 1")    
  SetGadgetItemText(#Panel, 2, Language::Message("Methods") + " 2")   
  SetGadgetItemText(#Panel, 3, Language::Message("Methods") + " 3")   
  SetGadgetItemText(#Panel, 4, Language::Message("Source"))
  SetGadgetItemText(#Panel, 5, Language::Message("Help"))
  
  SetGadgetItemText(#Panel_Primary_Secondary, 0, Language::Message("Primary Instance"))
  SetGadgetItemText(#Panel_Primary_Secondary, 1, Language::Message("Secondary Instance"))
  SetGadgetItemText(#Panel_Primary_Secondary, 2, Language::Message("Internal Structures"))
  
  SetGadgetText(#Frame_Internal_Structure, Language::Message("Internal Structures"))
  SetGadgetText(#Button_Scan_Internal_Structure, Language::Message("Scan Primary/Secondary Instance"))

  SetGadgetText(#Text_Module_Name, Language::Message("Module name") + " :")
  SetGadgetText(#Option_Single_Instance, Language::Message("Single Instance"))
  SetGadgetText(#Option_Multiple_Instance_ID, Language::Message("Multiple Instances (ID)"))
  SetGadgetText(#Option_Multiple_Instance_Index, Language::Message("Multiple Instances (Index)"))
  SetGadgetText(#Option_Multiple_Instance_Name, Language::Message("Multiple Instances (Name)"))
  SetGadgetText(#Option_Off_Module_Instance, Language::Message("Off-Module Instance"))
  
  SetGadgetText(#Frame_Basic_Methods, Language::Message("Basic Methods"))
  
  SetGadgetText(#CheckBox_Observator, Language::Message("Observator"))
  SetGadgetText(#Option_Observator_Private, Language::Message("Private"))
  SetGadgetText(#Option_Observator_Public, Language::Message("Public"))
  
  SetGadgetText(#CheckBox_Mutator, Language::Message("Mutator"))
  SetGadgetText(#Option_Mutator_Private, Language::Message("Private"))
  SetGadgetText(#Option_Mutator_Public, Language::Message("Public"))
  
  SetGadgetText(#CheckBox_Update, Language::Message("Update"))
  SetGadgetText(#Option_Update_Private, Language::Message("Private"))
  SetGadgetText(#Option_Update_Public, Language::Message("Public"))
  
  SetGadgetText(#CheckBox_Initialize, Language::Message("Initialize"))
  SetGadgetText(#Option_Initialize_Private, Language::Message("Private"))
  SetGadgetText(#Option_Initialize_Public, Language::Message("Public"))
  
  SetGadgetText(#CheckBox_Reset, Language::Message("Reset"))
  SetGadgetText(#Option_Reset_Private, Language::Message("Private"))
  SetGadgetText(#Option_Reset_Public, Language::Message("Public"))
  
  SetGadgetText(#CheckBox_Clear, Language::Message("Clear"))
  SetGadgetText(#Option_Clear_Public, Language::Message("Public"))
  SetGadgetText(#Option_Clear_Private, Language::Message("Private"))
  
  SetGadgetText(#Frame_Static_Array, Language::Message("Static Array Operators"))
  
  SetGadgetText(#CheckBox_QuickSortAscending, Language::Message("QuickSort Ascending"))
  SetGadgetText(#Option_QuickSortAscending_Public, Language::Message("Public"))
  SetGadgetText(#Option_QuickSortAscending_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_QuickSortDescending, Language::Message("QuickSort Descending"))
  SetGadgetText(#Option_QuickSortDescending_Public, Language::Message("Public"))
  SetGadgetText(#Option_QuickSortDescending_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_LinearSearch, Language::Message("Linear Search"))
  SetGadgetText(#Option_LinearSearch_Public, Language::Message("Public"))
  SetGadgetText(#Option_LinearSearch_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_BinarySearch, Language::Message("Binary Search"))
  SetGadgetText(#Option_BinarySearch_Public, Language::Message("Public"))
  SetGadgetText(#Option_BinarySearch_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_FixedLengthQueue, Language::Message("Fixed Queue"))
  SetGadgetText(#Option_FixedLengthQueue_Public, Language::Message("Public"))
  SetGadgetText(#Option_FixedLengthQueue_Private, Language::Message("Private"))
  
  SetGadgetText(#Frame_Linked_List, Language::Message("Linked List Operators"))
  
  SetGadgetText(#CheckBox_Sort_Linked_List, Language::Message("Sort"))
  SetGadgetText(#Option_Sort_Linked_List_Public, Language::Message("Public"))
  SetGadgetText(#Option_Sort_Linked_List_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Lin_Search_Linked_List, Language::Message("Linear Search"))
  SetGadgetText(#Option_Lin_Search_Linked_List_Public, Language::Message("Public"))
  SetGadgetText(#Option_Lin_Search_Linked_List_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Bin_Search_Linked_List, Language::Message("Binary Search"))
  SetGadgetText(#Option_Bin_Search_Linked_List_Public, Language::Message("Public"))
  SetGadgetText(#Option_Bin_Search_Linked_List_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Add_Linked_List, Language::Message("Add"))
  SetGadgetText(#Option_Add_Linked_List_Public, Language::Message("Public"))
  SetGadgetText(#Option_Add_Linked_List_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Select_Linked_List, Language::Message("Select"))
  SetGadgetText(#Option_Select_Linked_List_Public, Language::Message("Public"))
  SetGadgetText(#Option_Select_Linked_List_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_First_Linked_List, Language::Message("First"))
  SetGadgetText(#Option_First_Linked_List_Public, Language::Message("Public"))
  SetGadgetText(#Option_First_Linked_List_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Last_Linked_List, Language::Message("Last"))
  SetGadgetText(#Option_Last_Linked_List_Public, Language::Message("Public"))
  SetGadgetText(#Option_Last_Linked_List_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Previous_Linked_List, Language::Message("Previous"))
  SetGadgetText(#Option_Previous_Linked_List_Public, Language::Message("Public"))
  SetGadgetText(#Option_Previous_Linked_List_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Next_Linked_List, Language::Message("Next"))
  SetGadgetText(#Option_Next_Linked_List_Public, Language::Message("Public"))
  SetGadgetText(#Option_Next_Linked_List_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Delete_Linked_List, Language::Message("Delete"))
  SetGadgetText(#Option_Delete_Linked_List_Public, Language::Message("Public"))
  SetGadgetText(#Option_Delete_Linked_List_Private, Language::Message("Private"))

  SetGadgetText(#CheckBox_Reset_Linked_List, Language::Message("Reset"))
  SetGadgetText(#Option_Reset_Linked_List_Public, Language::Message("Public"))
  SetGadgetText(#Option_Reset_Linked_List_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Clear_Linked_List, Language::Message("Clear"))
  SetGadgetText(#Option_Clear_Linked_List_Public, Language::Message("Public"))
  SetGadgetText(#Option_Clear_Linked_List_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Index_Linked_List, Language::Message("Index"))
  SetGadgetText(#Option_Index_Linked_List_Public, Language::Message("Public"))
  SetGadgetText(#Option_Index_Linked_List_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Size_Linked_List, Language::Message("Size"))
  SetGadgetText(#Option_Size_Linked_List_Public, Language::Message("Public"))
  SetGadgetText(#Option_Size_Linked_List_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Insert_Linked_List, Language::Message("Insert"))
  SetGadgetText(#Option_Insert_Linked_List_Public, Language::Message("Public"))
  SetGadgetText(#Option_Insert_Linked_List_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Extract_Linked_List, Language::Message("Extract"))
  SetGadgetText(#Option_Extract_Linked_List_Public, Language::Message("Public"))
  SetGadgetText(#Option_Extract_Linked_List_Private, Language::Message("Private"))

  SetGadgetText(#Frame_Dynamic_Array, Language::Message("Dynamic Array Operators"))
  
  SetGadgetText(#CheckBox_Sort_Dynamic_Array, Language::Message("Sort"))
  SetGadgetText(#Option_Sort_Dynamic_Array_Public, Language::Message("Public"))
  SetGadgetText(#Option_Sort_Dynamic_Array_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Lin_Search_Dynamic_Array, Language::Message("Linear Search"))
  SetGadgetText(#Option_Lin_Search_Dynamic_Array_Public, Language::Message("Public"))
  SetGadgetText(#Option_Lin_Search_Dynamic_Array_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Bin_Search_Dynamic_Array, Language::Message("Binary Search"))
  SetGadgetText(#Option_Bin_Search_Dynamic_Array_Public, Language::Message("Public"))
  SetGadgetText(#Option_Bin_Search_Dynamic_Array_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Insert_Dynamic_Array, Language::Message("Insert"))
  SetGadgetText(#Option_Insert_Dynamic_Array_Public, Language::Message("Public"))
  SetGadgetText(#Option_Insert_Dynamic_Array_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Extract_Dynamic_Array, Language::Message("Extract"))
  SetGadgetText(#Option_Extract_Dynamic_Array_Public, Language::Message("Public"))
  SetGadgetText(#Option_Extract_Dynamic_Array_Private, Language::Message("Private"))
  
  SetGadgetText(#Frame_Map, Language::Message("Map Operators"))
  
  SetGadgetText(#CheckBox_Add_Map, Language::Message("Add"))
  SetGadgetText(#Option_Add_Map_Public, Language::Message("Public"))
  SetGadgetText(#Option_Add_Map_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Clear_Map, Language::Message("Clear"))
  SetGadgetText(#Option_Clear_Map_Public, Language::Message("Public"))
  SetGadgetText(#Option_Clear_Map_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Size_Map, Language::Message("Size"))
  SetGadgetText(#Option_Size_Map_Public, Language::Message("Public"))
  SetGadgetText(#Option_Size_Map_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Reset_Map, Language::Message("Reset"))
  SetGadgetText(#Option_Reset_Map_Public, Language::Message("Public"))
  SetGadgetText(#Option_Reset_Map_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Delete_Map, Language::Message("Delete"))
  SetGadgetText(#Option_Delete_Map_Public, Language::Message("Public"))
  SetGadgetText(#Option_Delete_Map_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Find_Map, Language::Message("Find"))
  SetGadgetText(#Option_Find_Map_Public, Language::Message("Public"))
  SetGadgetText(#Option_Find_Map_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Next_Map, Language::Message("Next"))
  SetGadgetText(#Option_Next_Map_Public, Language::Message("Public"))
  SetGadgetText(#Option_Next_Map_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Key_Map, Language::Message("Key"))
  SetGadgetText(#Option_Key_Map_Public, Language::Message("Public"))
  SetGadgetText(#Option_Key_Map_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Insert_Map, Language::Message("Insert"))
  SetGadgetText(#Option_Insert_Map_Public, Language::Message("Public"))
  SetGadgetText(#Option_Insert_Map_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Extract_Map, Language::Message("Extract"))
  SetGadgetText(#Option_Extract_Map_Public, Language::Message("Public"))
  SetGadgetText(#Option_Extract_Map_Private, Language::Message("Private"))

  
  SetGadgetText(#Frame_Maths_Operator, Language::Message("Mathematics Operators"))
  
  SetGadgetText(#CheckBox_Equal, Language::Message("Equal"))
  SetGadgetText(#Option_Equal_Public, Language::Message("Public"))
  SetGadgetText(#Option_Equal_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Plus, Language::Message("Plus"))
  SetGadgetText(#Option_Plus_Public, Language::Message("Public"))
  SetGadgetText(#Option_Plus_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Minus, Language::Message("Minus"))
  SetGadgetText(#Option_Minus_Public, Language::Message("Public"))
  SetGadgetText(#Option_Minus_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Product, Language::Message("Product"))
  SetGadgetText(#Option_Product_Public, Language::Message("Public"))
  SetGadgetText(#Option_Product_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Divide, Language::Message("Divide"))
  SetGadgetText(#Option_Divide_Public, Language::Message("Public"))
  SetGadgetText(#Option_Divide_Private, Language::Message("Private"))

  SetGadgetText(#CheckBox_ProductByScalar, Language::Message("ProductByScalar"))
  SetGadgetText(#Option_ProductByScalar_Public, Language::Message("Public"))
  SetGadgetText(#Option_ProductByScalar_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_DivideByScalar, Language::Message("DivideByScalar"))
  SetGadgetText(#Option_DivideByScalar_Public, Language::Message("Public"))
  SetGadgetText(#Option_DivideByScalar_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Copy, Language::Message("Copy"))
  SetGadgetText(#Option_Copy_Public, Language::Message("Public"))
  SetGadgetText(#Option_Copy_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Compare, Language::Message("Compare"))
  SetGadgetText(#Option_Compare_Public, Language::Message("Public"))
  SetGadgetText(#Option_Compare_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_Swapping, Language::Message("Swapping"))
  SetGadgetText(#Option_Swapping_Public, Language::Message("Public"))
  SetGadgetText(#Option_Swapping_Private, Language::Message("Private"))
  
  SetGadgetText(#Frame_Debugging, Language::Message("Debugging Operator"))
  
  SetGadgetText(#CheckBox_Debugging, Language::Message("Debugging"))
  SetGadgetText(#Option_Debugging_Public, Language::Message("Public"))
  SetGadgetText(#Option_Debugging_Private, Language::Message("Private"))

  SetGadgetText(#Frame_Preference_Methods, Language::Message("Preferences File"))
  
  SetGadgetText(#CheckBox_Pref_Group, Language::Message("Read/Write group"))
  SetGadgetText(#Option_Pref_Group_Private, Language::Message("Private"))
  SetGadgetText(#Option_Pref_Group_Public, Language::Message("Public"))
  
  SetGadgetText(#CheckBox_Pref_File, Language::Message("Create/Open file"))
  SetGadgetText(#Option_Pref_File_Private, Language::Message("Private"))
  SetGadgetText(#Option_Pref_File_Public, Language::Message("Public"))
  
  SetGadgetText(#Frame_XMLFile_Methods, Language::Message("XML file"))
  
  SetGadgetText(#CheckBox_XML_SetGet_Node, Language::Message("Node with child node"))
  SetGadgetText(#Option_XML_SetGet_Node_Public, Language::Message("Public"))
  SetGadgetText(#Option_XML_SetGet_Node_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_XML_SetGet_Attribute, Language::Message("Node with attributes"))
  SetGadgetText(#Option_XML_SetGet_Attribute_Public, Language::Message("Public"))
  SetGadgetText(#Option_XML_SetGet_Attribute_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_XML_AddCollect_Attribute, Language::Message("Add/Collect attributes"))
  SetGadgetText(#Option_XML_AddCollect_Attribute_Public, Language::Message("Public"))
  SetGadgetText(#Option_XML_AddCollect_Attribute_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_XML_CreateLoad_File, Language::Message("Create-Load file"))
  SetGadgetText(#Option_XML_CreateLoad_File_Public, Language::Message("Public"))
  SetGadgetText(#Option_XML_CreateLoad_File_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_XML_Catch_File, Language::Message("Catch file"))
  SetGadgetText(#Option_XML_Catch_File_Public, Language::Message("Public"))
  SetGadgetText(#Option_XML_Catch_File_Private, Language::Message("Private"))
  
  SetGadgetText(#Frame_JSONFile_Methods, Language::Message("JSON file"))
  
  SetGadgetText(#CheckBox_JSON_CreateLoad_File, Language::Message("Create-Load file"))
  SetGadgetText(#Option_JSON_CreateLoad_File_Public, Language::Message("Public"))
  SetGadgetText(#Option_JSON_CreateLoad_File_Private, Language::Message("Private"))
  
  SetGadgetText(#Frame_DataBaseFile_Methods, Language::Message("DataBase"))
  
  SetGadgetText(#CheckBox_DataBase_CreateTable, Language::Message("Create Table"))
  SetGadgetText(#Option_DataBase_CreateTable_Public, Language::Message("Public"))
  SetGadgetText(#Option_DataBase_CreateTable_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_DataBase_DropTable, Language::Message("Drop Table"))
  SetGadgetText(#Option_DataBase_DropTable_Public, Language::Message("Public"))
  SetGadgetText(#Option_DataBase_DropTable_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_DataBase_TruncateTable, Language::Message("Truncate Table"))
  SetGadgetText(#Option_DataBase_TruncateTable_Public, Language::Message("Public"))
  SetGadgetText(#Option_DataBase_TruncateTable_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_DataBase_SelectTable, Language::Message("Select Table"))
  SetGadgetText(#Option_DataBase_SelectTable_Public, Language::Message("Public"))
  SetGadgetText(#Option_DataBase_SelectTable_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_DataBase_CountRowInTable, Language::Message("Count row"))
  SetGadgetText(#Option_DataBase_CountRowInTable_Public, Language::Message("Public"))
  SetGadgetText(#Option_DataBase_CountRowInTable_Private, Language::Message("Private"))
 
  SetGadgetText(#CheckBox_DataBase_OpenFile, Language::Message("Open File"))
  SetGadgetText(#Option_DataBase_OpenFile_Public, Language::Message("Public"))
  SetGadgetText(#Option_DataBase_OpenFile_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_DataBase_ModuleTo, Language::Message("Module To DataBase"))
  SetGadgetText(#Option_DataBase_ModuleTo_Public, Language::Message("Public"))
  SetGadgetText(#Option_DataBase_ModuleTo_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_DataBase_ToModule, Language::Message("DataBase To Module"))
  SetGadgetText(#Option_DataBase_ToModule_Public, Language::Message("Public"))
  SetGadgetText(#Option_DataBase_ToModule_Private, Language::Message("Private"))
  
  SetGadgetText(#CheckBox_DataBase_Vacuumize, Language::Message("Vacuumize"))
  SetGadgetText(#Option_DataBase_Vacuumize_Public, Language::Message("Public"))
  SetGadgetText(#Option_DataBase_Vacuumize_Private, Language::Message("Private"))
  
  SetGadgetText(#Frame_BinaryFile_Methods, Language::Message("Binary File"))
  
  SetGadgetText(#CheckBox_ReadWriteBinary, Language::Message("Read and Write on file"))
  SetGadgetText(#Option_ReadWriteBinary_Private, Language::Message("Private"))
  SetGadgetText(#Option_ReadWriteBinary_Public, Language::Message("Public"))
  
  SetGadgetText(#CheckBox_CreateBinary, Language::Message("Create File"))
  SetGadgetText(#Option_CreateBinary_Private, Language::Message("Private"))
  SetGadgetText(#Option_CreateBinary_Public, Language::Message("Public"))
  
  SetGadgetText(#CheckBox_OpenBinary, Language::Message("Open File"))
  SetGadgetText(#Option_OpenBinary_Private, Language::Message("Private"))
  SetGadgetText(#Option_OpenBinary_Public, Language::Message("Public"))
  
  SetGadgetText(#CheckBox_ReadBinary, Language::Message("Read File"))
  SetGadgetText(#Option_ReadBinary_Private, Language::Message("Private"))
  SetGadgetText(#Option_ReadBinary_Public, Language::Message("Public"))
  
  SetGadgetText(#Frame_EncodedFile_Methods, Language::Message("Encoded File"))
  
  SetGadgetText(#CheckBox_ReadWriteEncoded, Language::Message("Read and Write on file"))
  SetGadgetText(#Option_ReadWriteEncoded_Private, Language::Message("Private"))
  SetGadgetText(#Option_ReadWriteEncoded_Public, Language::Message("Public"))
  
  SetGadgetText(#CheckBox_CreateEncoded, Language::Message("Create File"))
  SetGadgetText(#Option_CreateEncoded_Private, Language::Message("Private"))
  SetGadgetText(#Option_CreateEncoded_Public, Language::Message("Public"))
  
  SetGadgetText(#CheckBox_OpenEncoded, Language::Message("Open File"))
  SetGadgetText(#Option_OpenEncoded_Private, Language::Message("Private"))
  SetGadgetText(#Option_OpenEncoded_Public, Language::Message("Public"))
  
  SetGadgetText(#CheckBox_ReadEncoded, Language::Message("Read File"))
  SetGadgetText(#Option_ReadEncoded_Private, Language::Message("Private"))
  SetGadgetText(#Option_ReadEncoded_Public, Language::Message("Public"))
  
  SetGadgetText(#Frame_CryptedFile_Methods, Language::Message("Crypted File"))
  
  SetGadgetText(#CheckBox_ReadWriteCrypted, Language::Message("Read and Write on file"))
  SetGadgetText(#Option_ReadWriteCrypted_Private, Language::Message("Private"))
  SetGadgetText(#Option_ReadWriteCrypted_Public, Language::Message("Public"))
  
  SetGadgetText(#CheckBox_CreateCrypted, Language::Message("Create File"))
  SetGadgetText(#Option_CreateCrypted_Private, Language::Message("Private"))
  SetGadgetText(#Option_CreateCrypted_Public, Language::Message("Public"))
  
  SetGadgetText(#CheckBox_OpenCrypted, Language::Message("Open File"))
  SetGadgetText(#Option_OpenCrypted_Private, Language::Message("Private"))
  SetGadgetText(#Option_OpenCrypted_Public, Language::Message("Public"))
  
  SetGadgetText(#CheckBox_ReadCrypted, Language::Message("Read File"))
  SetGadgetText(#Option_ReadCrypted_Private, Language::Message("Private"))
  SetGadgetText(#Option_ReadCrypted_Public, Language::Message("Public"))
  
  GadgetToolTip(#Button_PushPin, Language::Message("Always on top"))
  GadgetToolTip(#Button_New, Language::Message("New"))
  GadgetToolTip(#Button_Open, Language::Message("Open"))
  GadgetToolTip(#Button_Save, Language::Message("Save"))
  GadgetToolTip(#Button_Code, Language::Message("Generate code"))
  GadgetToolTip(#Button_Brush, Language::Message("Code cleanup"))
  GadgetToolTip(#Button_ClipBoard, Language::Message("Send to Clipboard"))
  GadgetToolTip(#Button_Language, Language::Message("Language Requester"))
  GadgetToolTip(#Button_Options, Language::Message("Options"))
  GadgetToolTip(#Button_Quit, Language::Message("Quit"))
  
  AdvancedDateFormatting::Reset()
  
  AdvancedDateFormatting::SetMonth(00, Language::Message("Jan"), Language::Message("January"))
  AdvancedDateFormatting::SetMonth(01, Language::Message("Feb"), Language::Message("February"))
  AdvancedDateFormatting::SetMonth(02, Language::Message("Mar"), Language::Message("March"))
  AdvancedDateFormatting::SetMonth(03, Language::Message("Apr"), Language::Message("April"))
  AdvancedDateFormatting::SetMonth(04, Language::Message("May"), Language::Message("May"))
  AdvancedDateFormatting::SetMonth(05, Language::Message("Jun"), Language::Message("June"))
  AdvancedDateFormatting::SetMonth(06, Language::Message("Jul"), Language::Message("July"))
  AdvancedDateFormatting::SetMonth(07, Language::Message("Aug"), Language::Message("August"))
  AdvancedDateFormatting::SetMonth(08, Language::Message("Sep"), Language::Message("September"))
  AdvancedDateFormatting::SetMonth(09, Language::Message("Oct"), Language::Message("October"))
  AdvancedDateFormatting::SetMonth(10, Language::Message("Nov"), Language::Message("November"))
  AdvancedDateFormatting::SetMonth(11, Language::Message("Dec"), Language::Message("December"))
  
  AdvancedDateFormatting::SetDay(00, Language::Message("Sun"), Language::Message("Sunday"))
  AdvancedDateFormatting::SetDay(01, Language::Message("Mon"), Language::Message("Monday"))
  AdvancedDateFormatting::SetDay(02, Language::Message("Tue"), Language::Message("Tuesday"))
  AdvancedDateFormatting::SetDay(03, Language::Message("Wed"), Language::Message("Wednesday"))
  AdvancedDateFormatting::SetDay(04, Language::Message("Thu"), Language::Message("Thursday"))
  AdvancedDateFormatting::SetDay(05, Language::Message("Fri"), Language::Message("Friday"))
  AdvancedDateFormatting::SetDay(06, Language::Message("Sat"), Language::Message("Saturday"))
  
  AdvancedDateFormatting::SetOrdinal(Language::Message("st:1,21,31|nd:2,22|rd:3,23|th:x"))
  AdvancedDateFormatting::SetEditorText(0, Language::Message("Date Mask Editor"))
  AdvancedDateFormatting::SetEditorText(1, Language::Message("Mask parts"))
  AdvancedDateFormatting::SetEditorText(2, Language::Message("2 digits day"))
  AdvancedDateFormatting::SetEditorText(3, Language::Message("3 characters day name"))
  AdvancedDateFormatting::SetEditorText(4, Language::Message("Long day name"))
  AdvancedDateFormatting::SetEditorText(5, Language::Message("Ordinal"))
  AdvancedDateFormatting::SetEditorText(6, Language::Message("2 digits month"))
  AdvancedDateFormatting::SetEditorText(7, Language::Message("3 characters month name"))
  AdvancedDateFormatting::SetEditorText(8, Language::Message("Long month name"))
  AdvancedDateFormatting::SetEditorText(9, Language::Message("4 digits year"))
  AdvancedDateFormatting::SetEditorText(10, Language::Message("2 digits hours"))
  AdvancedDateFormatting::SetEditorText(11, Language::Message("2 digits minutes"))
  AdvancedDateFormatting::SetEditorText(12, Language::Message("2 digits seconds"))
  AdvancedDateFormatting::SetEditorText(13, Language::Message("Definition"))
  AdvancedDateFormatting::SetEditorText(14, Language::Message("OK"))
  AdvancedDateFormatting::SetEditorText(15, Language::Message("Cancel"))
  
  Comments::RefreshHeader()
  
EndProcedure

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< BuiltLanguageDefaultFiles (Private) <<<<<

CompilerIf #PB_Compiler_Debugger
  
  Procedure BuiltLanguageDefaultFiles(P_PathName.s)
    
    BuiltPathDirectory::DoIt(P_PathName)
    
    Language::Initialize(P_PathName, "English.xml")
    
    Language::AddTableElement("Dev-Module", "Dev-Module")
    Language::AddTableElement("Module", "Module")
    Language::AddTableElement("Methods", "Methods")
    Language::AddTableElement("Options", "Options")
    Language::AddTableElement("Source", "Source")
    Language::AddTableElement("Help", "Help")
    
    Language::AddTableElement("Module name", "Module name")
    Language::AddTableElement("Single Instance", "Single Instance")
    Language::AddTableElement("Multiple Instances (ID)", "Multiple Instances (ID)")  
    Language::AddTableElement("Multiple Instances (Index)", "Multiple Instances (Index)")  
    Language::AddTableElement("Multiple Instances (Name)", "Multiple Instances (Name)")  
    Language::AddTableElement("Off-Module Instance", "Off-Module Instance")  
    
    Language::AddTableElement("Primary Instance", "Primary Instance")
    Language::AddTableElement("Secondary Instance", "Secondary Instance")
    Language::AddTableElement("Internal Structures", "Internal Structures")
    Language::AddTableElement("Scan Primary/Secondary Instance", "Scan Primary/Secondary Instance")
    
    Language::AddTableElement("Private", "Private")  
    Language::AddTableElement("Public", "Public")  
    
    Language::AddTableElement("Basic Methods", "Basic Methods")
    Language::AddTableElement("Preferences File", "Preferences File")
    Language::AddTableElement("Binary File", "Binary File")
    Language::AddTableElement("Encoded File", "Encoded File")
    Language::AddTableElement("Crypted File", "Crypted File")
    
    Language::AddTableElement("Observator", "Observator")
    Language::AddTableElement("Mutator", "Mutator")
    Language::AddTableElement("Update", "Update")
    Language::AddTableElement("Initialize", "Initialize")
    Language::AddTableElement("Reset", "Reset")
    
    Language::AddTableElement("Static Array Operators", "Static Array Operators")
    Language::AddTableElement("QuickSort Ascending", "QuickSort Ascending")
    Language::AddTableElement("QuickSort Descending", "QuickSort Descending")
    Language::AddTableElement("Linear Search", "Linear Search")
    Language::AddTableElement("Binary Search", "Binary Search")
    Language::AddTableElement("Fixed Queue", "Fixed Queue")
    
    Language::AddTableElement("Linked List Operators", "Linked List Operators")
    Language::AddTableElement("Add", "Add")
    Language::AddTableElement("Select", "Select")
    Language::AddTableElement("First", "First")
    Language::AddTableElement("Last", "Last")
    Language::AddTableElement("Previous", "Previous")
    Language::AddTableElement("Next", "Next")
    Language::AddTableElement("Delete", "Delete")
    Language::AddTableElement("Clear", "Clear")
    Language::AddTableElement("Index", "Index")
    Language::AddTableElement("Insert", "Insert")
    Language::AddTableElement("Extract", "Extract")
    
    Language::AddTableElement("Sort", "Sort")
    Language::AddTableElement("Dynamic Array Operators", "Dynamic Array Operators")
    
    Language::AddTableElement("Map Operators", "Map Operators")
    Language::AddTableElement("Find", "Find")
    Language::AddTableElement("Key", "Key")
    
    Language::AddTableElement("Mathematics Operators", "Mathematics Operators")
    Language::AddTableElement("Equal", "Equal")
    Language::AddTableElement("Plus", "Plus")
    Language::AddTableElement("Minus", "Minus")
    Language::AddTableElement("Product", "Product")
    Language::AddTableElement("Divide", "Divide")
    Language::AddTableElement("ProductByScalar", "ProductByScalar")
    Language::AddTableElement("DivideByScalar", "DivideByScalar")
    
    Language::AddTableElement("Copy", "Copy")
    Language::AddTableElement("Compare", "Compare")
    Language::AddTableElement("Swapping", "Swapping")
    
    Language::AddTableElement("Debugging Operator", "Debugging Operator")
    Language::AddTableElement("Debugging", "Debugging")
    
    Language::AddTableElement("Read/Write group", "Read/Write group")
    Language::AddTableElement("Create/Open file", "Create/Open file")
    
    Language::AddTableElement("XML file", "XML file")
    Language::AddTableElement("Node with child node", "Node with child node")
    Language::AddTableElement("Node with attributes", "Node with attributes")
    Language::AddTableElement("Add/Collect attributes", "Add/Collect attributes")
    Language::AddTableElement("Create-Load file", "Create-Load file")
    Language::AddTableElement("Catch file", "Catch file")
    
    Language::AddTableElement("JSON file", "JSON file")

    Language::AddTableElement("DataBase File", "DataBase File")
    Language::AddTableElement("Create Table", "Create Table")
    Language::AddTableElement("Drop Table", "Drop Table")
    Language::AddTableElement("Truncate Table", "Truncate Table")
    Language::AddTableElement("Select Table", "Select Table")
    Language::AddTableElement("Count row", "Count row")
    Language::AddTableElement("Open DataBase File", "Open DataBase File")
    Language::AddTableElement("Module To DataBase", "Module To DataBase")
    Language::AddTableElement("DataBase To Module", "DataBase To Module")
    Language::AddTableElement("Vacuumize", "Vacuumize")

    Language::AddTableElement("Read and Write on file", "Read and Write on file")
    Language::AddTableElement("Create File", "Create File")
    Language::AddTableElement("Open File", "Open File")
    Language::AddTableElement("Read File", "Read File")
    
    Language::AddTableElement("Project files folder", "Projects files folder")
    Language::AddTableElement("Browse", "Browse")
    Language::AddTableElement("Select folder", "Select folder")
    Language::AddTableElement("Editor style and color", "Editor style and color")
    Language::AddTableElement("Font", "Font")
    Language::AddTableElement("Size", "Size")
    Language::AddTableElement("Text color", "Text color")
    Language::AddTableElement("Background color", "Background color")
    Language::AddTableElement("User Informations", "User Informations")
    Language::AddTableElement("Name", "Name")
    Language::AddTableElement("AKA", "AKA")
    Language::AddTableElement("E-mail", "E-mail")
    
    Language::AddTableElement("Source code formatting", "Source code formatting")
    Language::AddTableElement("Tabulation (Number of space)", "Tabulation (Number of space)")
    Language::AddTableElement("Use the real tabulation character", "Use the real tabulation character")
    
    Language::AddTableElement("Dates formatting","Dates formatting")
    
    Language::AddTableElement("Select project to open", "Select project to open")
    Language::AddTableElement("Select project to save", "Select project to save")
    Language::AddTableElement("DevModule Project (*.devm)|*.devm", "DevModule Project (*.devm)|*.devm")
    Language::AddTableElement("Select the Source code to save", "Select the Source code to save")
    Language::AddTableElement("PureBasic SourceCode (*.pb)|*.pb", "PureBasic SourceCode (*.pb)|*.pb")
    Language::AddTableElement("Warning - File already exist", "Warning - File already exist")
    Language::AddTableElement("The file %FILE% already exist. Would you like to overwrite ?", "The file %FILE% already exist. Would you like to overwrite ?")
    Language::AddTableElement("You are about to delete the date mask : %DATE_MASK%. Would you like to continue ?", "You are about to delete the date mask : %DATE_MASK%. Would you like to continue ?")
    Language::AddTableElement("You are about to remove the %MODULE_NAME% module. Are you sure ?", "You are about to remove the %MODULE_NAME% module. Are you sure ?")
    Language::AddTableElement("Dev-Module - Warning", "Dev-Module - Warning")
    Language::AddTableElement("Dev-Module - Error", "Dev-Module - Error")
    Language::AddTableElement("The Module name is missing !", "The Module name is missing !")
    Language::AddTableElement("No Date Mask !", "No Date Mask !")
    
    Language::AddTableElement("Internal Structure Editor", "Internal Structure Editor")
    Language::AddTableElement("Structure name", "Structure name")
    Language::AddTableElement("Always on top", "Premier Plan")
    
    Language::AddTableElement("New", "New")
    Language::AddTableElement("Open", "Open")
    Language::AddTableElement("Save", "Save")
    Language::AddTableElement("Generate code", "Generate code")
    Language::AddTableElement("Code cleanup", "Code cleanup")
    Language::AddTableElement("Send to Clipboard", "Send to Clipboard")
    Language::AddTableElement("Language Requester", "Choose language")
    Language::AddTableElement("Quit", "Quit")
    
    Language::AddTableElement("Matrix Encoded Library Generator", "Matrix Encoded Library Generator")
    Language::AddTableElement("Encoding matrix count (per size)", "Encoding matrix count (per size)")
    Language::AddTableElement("Count", "Count")
    Language::AddTableElement("Matrix Finder Progression", "Matrix Finder Progression")
    Language::AddTableElement("Matrix", "Matrix")

    Language::AddTableElement("AUTOMATICALLY GENERATED CODE, DO NOT MODIFY", "AUTOMATICALLY GENERATED CODE, DO NOT MODIFY")
    Language::AddTableElement("UNLESS YOU REALLY, REALLY, REALLY MEAN IT !!", "UNLESS YOU REALLY, REALLY, REALLY MEAN IT !!")
    Language::AddTableElement("Code generated by :", "Code generated by :")
    Language::AddTableElement("Project name : the project name here", "Project name : the project name here")
    Language::AddTableElement("File name : File name here", "File name : File name here")
    Language::AddTableElement("File Version : 0.0.0", "File Version : 0.0.0")
    Language::AddTableElement("Programmation : In progress", "Programmation : In progress")
    Language::AddTableElement("Programmed by :", "Programmed by :")
    Language::AddTableElement("AKA :", "AKA :")
    Language::AddTableElement("E-mail :", "E-mail :")
    Language::AddTableElement("Creation Date :", "Creation Date :")
    Language::AddTableElement("Last update :", "Last update :")
    Language::AddTableElement("Coded for PureBasic :", "Coded for PureBasic :")
    Language::AddTableElement("Platform : Windows, Linux, MacOS X", "Platform : Windows, Linux, MacOS X")
    
    Language::AddTableElement("Size Array Constants", "Size Array Constants")
    Language::AddTableElement("Constants Enumeration", "Constants Enumeration")
    Language::AddTableElement("Structure declaration", "Structure declaration")
    Language::AddTableElement("Structures declaration", "Structures declaration")
    
    Language::AddTableElement("The mutators", "The mutators")
    Language::AddTableElement("The observators", "The observators")
    Language::AddTableElement("The Update operator", "The Update operator")
    Language::AddTableElement("The Initialize operator", "The Initialize operator")
    Language::AddTableElement("The Reset operator", "The Reset operator")
    Language::AddTableElement("The Clear operator", "The Clear operator")

    Language::AddTableElement("The Equal operator : A = B", "The Equal operator : A = B")
    Language::AddTableElement("The Plus operator : R = A + B", "The Plus operator : R = A + B")
    Language::AddTableElement("The Minus operator : R = A - B", "The Minus operator : R = A - B")
    Language::AddTableElement("The Product operator : R = A * B", "The Product operator : R = A * B")
    Language::AddTableElement("The Divide operator : R = A / B", "The Divide operator : R = A / B")
    Language::AddTableElement("The ProductByScalar operator : R = A * Scalar", "The ProductByScalar operator : R = A * Scalar")
    Language::AddTableElement("The DivideByScalar operator : R = A / Scalar", "The DivideByScalar operator : R = A / Scalar")
    
    Language::AddTableElement("The Copy operator : A = Source : B = Destination", "The Copy operator : A = Source : B = Destination")
    Language::AddTableElement("The Compare operator", "The Compare operator")
    Language::AddTableElement("The Swapping operator", "The Swapping operator")
    
    Language::AddTableElement("The Identity operator", "The Identity operator")
    Language::AddTableElement("The Transpose operator", "The Transpose operator")
    Language::AddTableElement("The Random operator", "The Random operator")
    Language::AddTableElement("The Determinant operator", "The Determinant operator")
    Language::AddTableElement("The Inverse operator", "The Inverse operator")
    Language::AddTableElement("The Format operators", "The Format operators")
    Language::AddTableElement("The Unformat operators", "The Unformat operators")
    
    Language::AddTableElement("The QuickSort Ascendant operator", "The QuickSort Ascendant operator")
    Language::AddTableElement("The QuickSort Descendant operator", "The QuickSort Descendant operator")
    Language::AddTableElement("The Linear Search operator", "The Linear Search operator")
    Language::AddTableElement("The Binary Search operator", "The Binary Search operator")
    Language::AddTableElement("The InsertTopBottomOut operator", "The InsertTopBottomOut operator")
    
    Language::AddTableElement("The sort linked list operator(s)", "The sort linked list operator(s)")
    Language::AddTableElement("The linear search linked list operator(s)", "The linear search linked list operator(s)")
    Language::AddTableElement("The binary search linked list operator(s)", "The binary search linked list operator(s)")
    Language::AddTableElement("The Add to linked list operator(s)", "The Add to linked list operator(s)")
    Language::AddTableElement("The Select in linked list operator(s)", "The Select in linked list operator(s)")
    Language::AddTableElement("The First element in linked list operator(s)", "The First element in linked list operator(s)")
    Language::AddTableElement("The Last element in linked list operator(s)", "The Last element in linked list operator(s)")
    Language::AddTableElement("The Previous element in linked list operator(s)", "The Previous element in linked list operator(s)")
    Language::AddTableElement("The Next element in linked list operator(s)", "The Next element in linked list operator(s)")
    Language::AddTableElement("The Delete element from linked list operator(s)", "The Delete element from linked list operator(s)")
    Language::AddTableElement("The Reset linked list operator(s)", "The Reset linked list operator(s)")
    Language::AddTableElement("The Clear linked list operator(s)", "The Clear linked list operator(s)") 
    Language::AddTableElement("The Index in the linked list operator(s)", "The Index in the linked list operator(s)")
    Language::AddTableElement("The Size of the linked list operator(s)", "The Size of the linked list operator(s)")
    Language::AddTableElement("The Insert linked list operator(s)", "The Insert linked list operator(s)")
    Language::AddTableElement("The Extract linked list operator(s)", "The Extract linked list operator(s)")
    
    Language::AddTableElement("The sort dynamic array operator(s)", "The sort dynamic array operator(s)")
    Language::AddTableElement("The linear search dynamic array operator(s)", "The linear search dynamic array operator(s)")
    Language::AddTableElement("The binary search dynamic array operator(s)", "The binary search dynamic array operator(s)")
    Language::AddTableElement("The Insert dynamic array operator(s)", "The Insert dynamic array operator(s)")
    Language::AddTableElement("The Extract dynamic array operator(s)", "The Extract dynamic array operator(s)")
    
    Language::AddTableElement("The Add to map operator(s)", "The Add to map operator(s)")
    Language::AddTableElement("The Clear map operator(s)", "The Clear map operator(s)")
    Language::AddTableElement("The map Size operator(s)", "The map Size operator(s)")
    Language::AddTableElement("The Reset map operator(s)", "The Reset map operator(s)")
    Language::AddTableElement("The Delete map element operator(s)", "The Delete map element operator(s)")
    Language::AddTableElement("The Find map element operator(s)", "The Find map element operator(s)")
    Language::AddTableElement("The Next map element operator(s)", "The Next map element operator(s)")
    Language::AddTableElement("The map Key operator(s)", "The map Key operator(s)")
    Language::AddTableElement("The Insert map operator(s)", "The Insert map operator(s)")
    Language::AddTableElement("The Extract map operator(s)", "The Extract map operator(s)")
    
    Language::AddTableElement("The Special operator(s)", "The Special operator(s)")
    
    Language::AddTableElement("Write preferences group", "Write preferences group")
    Language::AddTableElement("Read preferences group", "Read preferences group")
    Language::AddTableElement("Create preferences file", "Create preferences file")
    Language::AddTableElement("Open preferences file", "Open preferences file")
    
    Language::AddTableElement("Set - Node with child nodes", "Set - Node with child nodes")
    Language::AddTableElement("Get - Node with child nodes", "Get - Node with child nodes")
    Language::AddTableElement("Set - Node with attributes", "Set - Node with attributes")
    Language::AddTableElement("Get - Node with attributes", "Get - Node with attributes")
    Language::AddTableElement("Add attributes to current node", "Add attributes to current node")
    Language::AddTableElement("Collect attributes from current node", "Collect attributes from current node")
    Language::AddTableElement("Create XML file", "Create XML file")
    Language::AddTableElement("Load XML file", "Load XML file")
    Language::AddTableElement("Catch XML file", "Catch XML file")
    
    Language::AddTableElement("Create JSON file", "Create JSON file")
    Language::AddTableElement("Load JSON file", "Load JSON file")
    
    Language::AddTableElement("Create Database table", "Create Database table")
    Language::AddTableElement("Drop Database table", "Drop Database table")
    Language::AddTableElement("Turncate Database table", "Turncate Database table")
    Language::AddTableElement("Select Database table", "Select Database table")
    Language::AddTableElement("Count Row In Database table", "Count Row In Database table")
    
    Language::AddTableElement("Insert Database Table entry", "Insert Database Table entry")
    Language::AddTableElement("Insert Database Table(s) entry", "Insert Database Table(s) entry")
    
    Language::AddTableElement("Update Database Table entry", "Update Database Table entry")
    Language::AddTableElement("Update Database Table(s) entry", "Update Database Table(s) entry")
    
    Language::AddTableElement("Delete Database Table entry", "Delete Database Table entry")
    Language::AddTableElement("Delete Database Table(s) entry", "Delete Database Table(s) entry")
    
    Language::AddTableElement("Extract Database Table entry", "Extract Database Table entry")
    Language::AddTableElement("Extract Database Table(s) entry", "Extract Database Table(s) entry")
    
    Language::AddTableElement("Transfer Database To Table(s)", "Transfer Database To Table(s)")
    Language::AddTableElement("Transfer Table(s) To Database", "Transfer Table(s) To Database")
    
    Language::AddTableElement("Open Database", "Open Database")

    Language::AddTableElement("Transfer from Module to Database", "Transfer from Module to Database")
    Language::AddTableElement("Transfer from Database to Module", "Transfer from Database to Module")
    
    Language::AddTableElement("Vacuumize Database", "Vacuumize Database")
    
    Language::AddTableElement("Write in Binary file", "Write in Binary file")
    Language::AddTableElement("Read in Binary file", "Read in Binary file")
    Language::AddTableElement("Create Binary File", "Create Binary File")
    Language::AddTableElement("Open Binary File", "Open Binary File")
    Language::AddTableElement("Read Binary File", "Read Binary File")
    
    Language::AddTableElement("Write in Encoded file", "Write in Encoded file")
    Language::AddTableElement("Read in Encoded file", "Read in Encoded file")
    Language::AddTableElement("Create Encoded File", "Create Encoded File")
    Language::AddTableElement("Open Encoded File", "Open Encoded File")
    Language::AddTableElement("Read Encoded File", "Read Encoded File")
    Language::AddTableElement("Write in Crypted file", "Write in Crypted file")
    Language::AddTableElement("Read in Crypted file", "Read in Crypted file")
    Language::AddTableElement("Create Crypted File", "Create Crypted File")
    Language::AddTableElement("Open Crypted File", "Open Crypted File")
    Language::AddTableElement("Read Crypted File", "Read Crypted File")
    
    Language::AddTableElement("The Debugging Operator", "The Debugging Operator")
    
    Language::AddTableElement("Code generated in : %TIME% seconds (%RATE% lines/second)", "Code generated in : %TIME% seconds (%RATE% lines/second)")
    Language::AddTableElement("END OF FILE", "END OF FILE")
    
    Language::AddTableElement("January", "January")
    Language::AddTableElement("February", "February")
    Language::AddTableElement("March", "March")
    Language::AddTableElement("April", "April")
    Language::AddTableElement("May", "May")
    Language::AddTableElement("June", "June")
    Language::AddTableElement("July", "July")
    Language::AddTableElement("August", "August")
    Language::AddTableElement("September", "September")
    Language::AddTableElement("October", "October")
    Language::AddTableElement("November", "November")
    Language::AddTableElement("December", "December")
    
    Language::AddTableElement("Jan", "Jan")
    Language::AddTableElement("Feb", "Feb")
    Language::AddTableElement("Mar", "Mar")
    Language::AddTableElement("Apr", "Apr")
    Language::AddTableElement("May", "May")
    Language::AddTableElement("Jun", "Jun")
    Language::AddTableElement("Jul", "Jul")
    Language::AddTableElement("Aug", "Aug")
    Language::AddTableElement("Sep", "Sep")
    Language::AddTableElement("Oct", "Oct")
    Language::AddTableElement("Nov", "Nov")
    Language::AddTableElement("Dec", "Dec")
    
    Language::AddTableElement("Sunday", "Sunday")
    Language::AddTableElement("Monday", "Monday")
    Language::AddTableElement("Tuesday", "Tuesday")
    Language::AddTableElement("Wednesday", "Wednesday")
    Language::AddTableElement("Thursday", "Thursday")
    Language::AddTableElement("Friday", "Friday")
    Language::AddTableElement("Saturday", "Saturday")
    
    Language::AddTableElement("st:1,21,31|nd:2,22|rd:3,23|th:x", "st:1,21,31|nd:2,22|rd:3,23|th:x")
    
    Language::AddTableElement("Date Mask Editor", "Date Mask Editor")
    Language::AddTableElement("Mask parts", "Mask parts")
    Language::AddTableElement("2 digits day", "2 digits day")
    Language::AddTableElement("3 characters day name", "3 characters day name")
    Language::AddTableElement("Long day name", "Long day name")
    Language::AddTableElement("Ordinal", "Ordinal")
    Language::AddTableElement("2 digits month", "2 digits month")
    Language::AddTableElement("3 characters month name", "3 characters month name")
    Language::AddTableElement("Long month name", "Long month name")
    Language::AddTableElement("4 digits year", "4 digits year")
    Language::AddTableElement("2 digits hours", "2 digits hours")
    Language::AddTableElement("2 digits minutes", "2 digits minutes")
    Language::AddTableElement("2 digits seconds", "2 digits seconds")
    Language::AddTableElement("Definition", "Definition")
    
    Language::AddTableElement("OK", "OK")
    Language::AddTableElement("Cancel", "Cancel")
    
    Language::AddTableElement("Code Generator Statistics", "Code Generator Statistics")
    Language::AddTableElement("Statistics based on last %X% code generations", "Statistics based on last %X% code generations")
    Language::AddTableElement("Generation Rate (Line/Second)", "Generation Rate (Line/Second)")
    Language::AddTableElement("Top 5 (Line/Second)", "Top 5 (Line/Second)")
    Language::AddTableElement("Generation Time (Second)", "Generation Time (Second)")
    Language::AddTableElement("Top 5 (Second)", "Top 5 (Second)")
    Language::AddTableElement("Best", "Best")
    Language::AddTableElement("Average", "Average")
    Language::AddTableElement("Worst", "Worst")
    Language::AddTableElement("Standard Deviation", "Standard Deviation")
    Language::AddTableElement("Close", "Close")
    
    Language::AddTableElement("Editors Font", "Editors Font")
    Language::AddTableElement("Syntax coloring", "Syntax coloring")
    Language::AddTableElement("Normal Text", "Normal Text")
    Language::AddTableElement("Background", "Background")
    Language::AddTableElement("Caret", "Caret")
    Language::AddTableElement("Current line Background", "Current line Background")
    Language::AddTableElement("Selection", "Selection")
    Language::AddTableElement("Selection Background", "Selection Background")
    Language::AddTableElement("Line Numbers", "Line Numbers")
    Language::AddTableElement("Line Numbers Background", "Line Numbers Background")
    Language::AddTableElement("Fold Margin Background", "Fold Margin Background")
    Language::AddTableElement("Fold Markers", "Fold Markers")
    Language::AddTableElement("Fold Markers Background", "Fold Markers Background")
    Language::AddTableElement("Line Highlight", "Line Highlight")
    Language::AddTableElement("Keywords", "Keywords")
    Language::AddTableElement("Comments", "Comments")
    Language::AddTableElement("Literal Strings", "Literal Strings")
    Language::AddTableElement("Numbers", "Numbers")
    Language::AddTableElement("Constants", "Constants")
    Language::AddTableElement("Procedures", "Procedures")
    Language::AddTableElement("Separators", "Separators")
    Language::AddTableElement("Operators", "Operators")
    Language::AddTableElement("Types", "Types")
    Language::AddTableElement("Modules", "Modules")
    Language::AddTableElement("Pointers", "Pointers")
    Language::AddTableElement("Keywords in bold", "Keywords in bold")
    Language::AddTableElement("Click me", "Click me")
    
    Language::CreateTableFile()
    Language::Reset()
    
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    Language::Initialize(P_PathName, "Franais.xml")
    
    Language::AddTableElement("Dev-Module", "Dev-Module")
    
    Language::AddTableElement("Module", "Module")
    Language::AddTableElement("Source", "Source")
    Language::AddTableElement("Methods", "Mthodes")
    Language::AddTableElement("Options", "Options")
    Language::AddTableElement("Help", "Aide")
    
    Language::AddTableElement("Module name", "Nom du Module")
    Language::AddTableElement("Single Instance", "Instance Unique")
    Language::AddTableElement("Multiple Instances (ID)", "Instances Multiple (ID)")
    Language::AddTableElement("Multiple Instances (Index)", "Instances Multiple (Index)")
    Language::AddTableElement("Multiple Instances (Name)", "Instances Multiple (Nom)")
    Language::AddTableElement("Off-Module Instance", "Instance hors module")  
    
    Language::AddTableElement("Primary Instance", "Instance Primaire")
    Language::AddTableElement("Secondary Instance", "Instance Secondaire")
    Language::AddTableElement("Internal Structures", "Structures Internes")
    Language::AddTableElement("Scan Primary/Secondary Instance", "Scan Instance Primaire/Secondaire")

    Language::AddTableElement("Private", "Prive")  
    Language::AddTableElement("Public", "Publique")  
    
    Language::AddTableElement("Basic Methods", "Mthodes de base")
    Language::AddTableElement("Mathematics Operators", "Les Oprateurs Mathmatiques")
    Language::AddTableElement("Preferences File", "Fichier de Prfrences")
    Language::AddTableElement("Binary File", "Fichier Binaire")
    Language::AddTableElement("Encoded File", "Fichier Encod")
    Language::AddTableElement("Crypted File", "Fichier Crypt")
    
    Language::AddTableElement("Observator", "Observateur")
    Language::AddTableElement("Mutator", "Mutateur")
    Language::AddTableElement("Update", "Update")
    Language::AddTableElement("Initialize", "Initialize")
    Language::AddTableElement("Reset", "Reset")
    
    Language::AddTableElement("Static Array Operators", "Oprateurs de Tableau Statique")
    
    Language::AddTableElement("QuickSort Ascending", "QuickSort Ascendant")
    Language::AddTableElement("QuickSort Descending", "QuickSort Descendant")
    Language::AddTableElement("Linear Search", "Fouille linaire")
    Language::AddTableElement("Binary Search", "Fouille dichotomique")
    Language::AddTableElement("Fixed Queue", "File d'attente fixe")
    
    Language::AddTableElement("Linked List Operators", "Oprateurs de liste chaine")
    Language::AddTableElement("Add", "Ajouter")
    Language::AddTableElement("Select", "Slectionner")
    Language::AddTableElement("First", "Premier")
    Language::AddTableElement("Last", "Dernier")
    Language::AddTableElement("Previous", "Prcdent")
    Language::AddTableElement("Next", "Suivant")
    Language::AddTableElement("Delete", "Supprimer")
    Language::AddTableElement("Clear", "Clear")
    Language::AddTableElement("Index", "Index")
    Language::AddTableElement("Insert", "Insrer")
    Language::AddTableElement("Extract", "Extraire")

    Language::AddTableElement("Sort", "Trier")
    Language::AddTableElement("Dynamic Array Operators", "Oprateurs de tableau dynamique")
    
    Language::AddTableElement("Map Operators", "Oprateurs de map")
    Language::AddTableElement("Find", "Trouver")
    Language::AddTableElement("Key", "Cl")
    
    Language::AddTableElement("Equal", "Equal")
    Language::AddTableElement("Plus", "Plus")
    Language::AddTableElement("Minus", "Minus")
    Language::AddTableElement("Product", "Product")
    Language::AddTableElement("Divide", "Divide")
    Language::AddTableElement("ProductByScalar", "ProductByScalar")
    Language::AddTableElement("DivideByScalar", "DivideByScalar")
    
    Language::AddTableElement("Copy", "Copy")
    Language::AddTableElement("Compare", "Compare")
    Language::AddTableElement("Swapping", "Swapping")
    
    Language::AddTableElement("Debugging Operator", "L'oprateur de dboggage")
    Language::AddTableElement("Debugging", "Dboggage")   
    
    Language::AddTableElement("Read/Write group", "Lire/crire un groupe")
    Language::AddTableElement("Create/Open file", "Crer/Ouvrir un fichier")
    
    Language::AddTableElement("XML file", "Fichier XML")
    Language::AddTableElement("Node with child node", "Noeud avec noeuds enfants")
    Language::AddTableElement("Node with attributes", "Noeud avec Attributs")
    Language::AddTableElement("Add/Collect attributes", "Ajout/Collecte d'Attributs")
    Language::AddTableElement("Create-Load file", "Crer-Charger un fichier")
    Language::AddTableElement("Catch file", "Capture de fichier")
    
    Language::AddTableElement("JSON file", "Fichier JSON")

    Language::AddTableElement("DataBase", "Base de donnes")
    Language::AddTableElement("Create Table", "Crer une Table")
    Language::AddTableElement("Drop Table", "Supprimer une Table")
    Language::AddTableElement("Truncate Table", "Tronquer une Table")
    Language::AddTableElement("Select Table", "Slectionner une Table")
    Language::AddTableElement("Count row", "Compter les lignes")
    Language::AddTableElement("Open File", "Ouvrir un fichier")
    Language::AddTableElement("Module To DataBase", "Envoyer Module vers")
    Language::AddTableElement("DataBase To Module", "Charger Module depuis")
    Language::AddTableElement("Vacuumize", "Passer l'aspirateur")

    Language::AddTableElement("Read and Write on file", "Lecture/criture sur fichier")
    Language::AddTableElement("Create File", "Crer un fichier")
    Language::AddTableElement("Open File", "Ouvrir un fichier")
    Language::AddTableElement("Read File", "Lire un fichier")
    
    Language::AddTableElement("Project files folder", "Rpertoire de fichiers Projet")
    
    Language::AddTableElement("Browse", "Parcourir")
    Language::AddTableElement("Select folder", "Slectionnez un rpertoire")
    Language::AddTableElement("Editor style and color", "Style et couleur pour les diteurs")
    Language::AddTableElement("Font", "Police")
    Language::AddTableElement("Size", "Grandeur")
    Language::AddTableElement("Text color", "Couleur du texte")
    Language::AddTableElement("Background color", "Couleur du fond")
    Language::AddTableElement("User Informations", "Informations utilisateur")
    Language::AddTableElement("Name", "Nom")
    Language::AddTableElement("AKA", "Alias")
    Language::AddTableElement("E-mail", "Courriel")
    
    Language::AddTableElement("Source code formatting", "Mise en forme du code")
    Language::AddTableElement("Tabulation (Number of space)", "Tabulation (Nombre d'espace)")
    Language::AddTableElement("Use the real tabulation character", "Utiliser le vrai caractre de tabulation")
    
    Language::AddTableElement("Dates formatting", "Formatage des dates")
    
    Language::AddTableElement("Select project to open", "Slectionnez le projet  ouvrir")
    Language::AddTableElement("Select project to save", "Slectionnez le projet  enregistrer")
    Language::AddTableElement("DevModule Project (*.devm)|*.devm", "DevModule Project (*.devm)|*.devm")
    Language::AddTableElement("Select the Source code to save", "Slectionnez le Code source  enregistrer")
    Language::AddTableElement("PureBasic SourceCode (*.pb)|*.pb", "PureBasic SourceCode (*.pb)|*.pb")
    Language::AddTableElement("Warning - File already exist", "Attention - Fichier existant")
    Language::AddTableElement("The file %FILE% already exist. Would you like to overwrite ?", "Le fichier %FILE% existe dja. Voulez-vous le remplacer ?")
    
    Language::AddTableElement("You are about to delete the date mask : %DATE_MASK%. Would you like to continue ?", "Vous tes sur le point de supprimer le masque : %DATE_MASK%. Voulez-vous continuer ?")
    Language::AddTableElement("You are about to remove the %MODULE_NAME% module. Are you sure ?", "Vous tes sur le point de supprimer le Module %MODULE_NAME%. Voulez-vous continuer ?")
    Language::AddTableElement("Dev-Module - Warning", "Dev-Module - Attention")
    Language::AddTableElement("Dev-Module - Error", "Dev-Module - Erreur")
    Language::AddTableElement("The Module name is missing !", "Le nom du Module est manquant !")
    Language::AddTableElement("No Date Mask !", "Aucun masque pour la date !")
    
    Language::AddTableElement("Internal Structure Editor", "diteur de Structure Interne")
    Language::AddTableElement("Structure name", "Nom de la Structure")
    
    Language::AddTableElement("Always on top", "Premier Plan")
    Language::AddTableElement("New", "Nouveau")
    Language::AddTableElement("Open", "Ouvrir")
    Language::AddTableElement("Save", "Enregister")
    Language::AddTableElement("Generate code", "Gnrer le code")
    Language::AddTableElement("Code cleanup", "Nettoyer le code")
    Language::AddTableElement("Send to Clipboard", "Presse-papier")
    Language::AddTableElement("Language Requester", "Choix de la langue")
    Language::AddTableElement("Quit", "Quitter")
    
    Language::AddTableElement("Matrix Encoded Library Generator", "Gnrateur de librairie d'encodage matricielle")
    Language::AddTableElement("Encoding matrix count (per size)", "Nombre de matrice d'encodage (par grandeur)")
    Language::AddTableElement("Count", "Nombre")
    Language::AddTableElement("Matrix Finder Progression", "Progression recherche de matrices")
    Language::AddTableElement("Matrix", "Matrice")
    
    Language::AddTableElement("AUTOMATICALLY GENERATED CODE, DO NOT MODIFY", "CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER ")
    Language::AddTableElement("UNLESS YOU REALLY, REALLY, REALLY MEAN IT !!", "MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!")
    Language::AddTableElement("Code generated by :", "Code gnr par :")
    Language::AddTableElement("Project name : the project name here", "Nom du projet : Le nom du projet ici")
    Language::AddTableElement("File name : File name here", "Nom du fichier : Nom du fichier")
    Language::AddTableElement("File Version : 0.0.0", "Version du fichier : 0.0.0")
    Language::AddTableElement("Programmation : In progress", "Programmation :  vrifier")
    Language::AddTableElement("Programmed by :", "Programm par :")
    Language::AddTableElement("AKA :", "Alias :")
    Language::AddTableElement("E-mail :", "Courriel :")
    Language::AddTableElement("Creation Date :", "Date :")
    Language::AddTableElement("Last update :", "Mise  jour :")
    Language::AddTableElement("Coded for PureBasic :", "Cod pour PureBasic :")
    Language::AddTableElement("Platform : Windows, Linux, MacOS X", "Plateforme : Windows, Linux, MacOS X")
    
    Language::AddTableElement("Size Array Constants", "Constantes de dimensionnement")
    Language::AddTableElement("Constants Enumeration", "numration de Constantes")
    Language::AddTableElement("Structure declaration", "Dclaration de la Structure")
    Language::AddTableElement("Structures declaration", "Dclaration des Structures")
    
    Language::AddTableElement("The mutators", "Les mutateurs")
    Language::AddTableElement("The observators", "Les observateurs")
    Language::AddTableElement("The Update operator", "L'oprateur Update")
    Language::AddTableElement("The Initialize operator", "L'oprateur Initialize")
    Language::AddTableElement("The Reset operator", "L'oprateur Reset")
    Language::AddTableElement("The Clear operator", "L'oprateur Clear")
    
    Language::AddTableElement("The Equal operator : A = B", "L'oprateur Equal : A = B")
    Language::AddTableElement("The Plus operator : R = A + B", "L'oprateur Plus : R = A + B")
    Language::AddTableElement("The Minus operator : R = A - B", "L'oprateur Minus : R = A - B")
    Language::AddTableElement("The Product operator : R = A * B", "L'oprateur Product : R = A * B")
    Language::AddTableElement("The Divide operator : R = A / B", "L'oprateur Divide : R = A / B")
    Language::AddTableElement("The ProductByScalar operator : R = A * Scalar", "L'oprateur ProductByScalar : R = A * Scalar")
    Language::AddTableElement("The DivideByScalar operator : R = A / Scalar", "L'oprateur DivideByScalar : R = A / Scalar")
    
    Language::AddTableElement("The Identity operator", "L'oprateur Identity")
    Language::AddTableElement("The Transpose operator", "L'oprateur Transpose")
    Language::AddTableElement("The Random operator", "L'oprateur Random")
    Language::AddTableElement("The Determinant operator", "L'oprateur Dterminant")
    Language::AddTableElement("The Inverse operator", "L'oprateur Inverse")
    Language::AddTableElement("The Format operators", "Les oprateurs de Formatage")
    Language::AddTableElement("The Unformat operators", "Les oprateurs de Dformatage")
    
    Language::AddTableElement("The Copy operator : A = Source : B = Destination", "L'oprateur Copy : A = Source : B = Destination")
    Language::AddTableElement("The Compare operator", "L'oprateur Compare")
    Language::AddTableElement("The Swapping operator", "L'oprateur Swapping")
    
    Language::AddTableElement("The QuickSort Ascendant operator", "L'oprateur QuickSort Ascendant")
    Language::AddTableElement("The QuickSort Descendant operator", "L'oprateur QuickSort Descendant")
    Language::AddTableElement("The Linear Search operator", "L'oprateur fouille linaire")
    Language::AddTableElement("The Binary Search operator", "L'oprateur fouille dichotomique")
    Language::AddTableElement("The InsertTopBottomOut operator", "L'oprateur InsertTopBottomOut")
    
    Language::AddTableElement("The sort linked list operator(s)", "L'oprateur(s) de triage de liste chane")
    Language::AddTableElement("The linear search linked list operator(s)", "L'oprateur(s) de fouille linaire de liste chane")
    Language::AddTableElement("The binary search linked list operator(s)", "L'oprateur(s) de fouille dichotomique de liste chane")
    
    Language::AddTableElement("The Add to linked list operator(s)", "L'operateur(s) d'ajout  la liste chane")
    Language::AddTableElement("The Select in linked list operator(s)", "L'operateur(s) de Slection dans la lliste chane")
    Language::AddTableElement("The First element in linked list operator(s)", "L'operateur(s) Premier lment de la liste chane")
    Language::AddTableElement("The Last element in linked list operator(s)", "L'operateur(s) Dernier lment de la liste chane")
    Language::AddTableElement("The Previous element in linked list operator(s)", "L'operateur(s) lment Prcdent de la liste chane")
    Language::AddTableElement("The Next element in linked list operator(s)", "L'operateur(s) lment Suivant de la liste chane")
    Language::AddTableElement("The Delete element from linked list operator(s)", "L'operateur(s) Supprimer l'lment courant de la liste chane")
    Language::AddTableElement("The Reset linked list operator(s)", "L'operateur(s) Reset de la liste chane")
    Language::AddTableElement("The Clear linked list operator(s)", "L'operateur(s) Clear de la liste chane") 
    Language::AddTableElement("The Index in the linked list operator(s)", "L'operateur(s) de numro d'index de la liste chane")
    Language::AddTableElement("The Size of the linked list operator(s)", "L'operateur(s) de grandeur de la liste chane")
    Language::AddTableElement("The Insert linked list operator(s)", "L'oprateur(s) d'insertion d'une liste chaine")
    Language::AddTableElement("The Extract linked list operator(s)", "L'oprateur(s) d'extraction d'une liste chaine")
    
    Language::AddTableElement("The Sort dynamic array operator(s)", "L'oprateur(s) de triage de tableau dynamique")
    Language::AddTableElement("The Linear search dynamic array operator(s)", "L'oprateur(s) de fouille linaire de tableau dynamique")
    Language::AddTableElement("The Binary search dynamic array operator(s)", "L'oprateur(s) de fouille dichotomique de tableau dynamique")
    Language::AddTableElement("The Insert dynamic array operator(s)", "L'oprateur(s) d'insertion d'un tableau dynamique")
    Language::AddTableElement("The Extract dynamic array operator(s)", "L'oprateur(s) d'extraction d'un tableau dynamique")
    
    Language::AddTableElement("The Add to map operator(s)", "L'oprateur(s) d'.ajout  la Map")
    Language::AddTableElement("The Clear map operator(s)", "L'operateur(s) Clear de la Map")
    Language::AddTableElement("The map Size operator(s)", "L'operateur(s) de grandeur de la Map")
    Language::AddTableElement("The Reset map operator(s)", "L'operateur(s) Reset de la Map")
    Language::AddTableElement("The Delete map element operator(s)", "L'operateur(s) Supprimer l'lment courant de la Map")
    Language::AddTableElement("The Find map element operator(s)", "L'oprateur(s) Trouver un lment de la Map")
    Language::AddTableElement("The Next map element operator(s)", "L'operateur(s) lment Suivant de la Map")
    Language::AddTableElement("The map Key operator(s)", "L'oprateur(s) d'obtention de la cl de l'lment actuel de la Map")
    Language::AddTableElement("The Insert map operator(s)", "L'oprateur(s) d'insertion d'une Map")
    Language::AddTableElement("The Extract map operator(s)", "L'oprateur(s) d'extraction d'une Map")
    
    Language::AddTableElement("The Special operator(s)", "Les oprateurs Spciaux")
    
    Language::AddTableElement("Write preferences group", "criture d'un groupe de Prfrences")
    Language::AddTableElement("Read preferences group", "Lecture d'un groupe Prfrences")
    Language::AddTableElement("Create preferences file", "Cration d'un fichier de Prfrences")
    Language::AddTableElement("Open preferences file", "Ouverture d'un fichier de Prfrences")
    
    Language::AddTableElement("Set - Node with child nodes", "Set - Noeud avec noeuds enfants")
    Language::AddTableElement("Get - Node with child nodes", "Get - Noeud avec noeuds enfants")
    Language::AddTableElement("Set - Node with attributes", "Set - Noeud avec attributs")
    Language::AddTableElement("Get - Node with attributes", "Get - Noeud avec attributs")
    Language::AddTableElement("Add attributes to current node", "Ajout d'attribus au noeud courant")
    Language::AddTableElement("Collect attributes from current node", "Collecte d'attributs  partir du noeud courant")
    Language::AddTableElement("Create XML file", "Cration d'un fichier XML")
    Language::AddTableElement("Load XML file", "Chargement d'un fichier XML")
    Language::AddTableElement("Catch XML file", "Capture d'un fichier XML")
    
    Language::AddTableElement("Create JSON file", "Cration d'un fichier JSON")
    Language::AddTableElement("Load JSON file", "Chargement d'un fichier JSON")

    Language::AddTableElement("Create Database table", "Cration d'une table dans la base de donnes")
    Language::AddTableElement("Drop Database table", "Supression d'une table dans la base de donnes")
    Language::AddTableElement("Turncate Database table", "Tronquer une table dans la base de donnes")
    Language::AddTableElement("Select Database table", "Slection d'une table dans la base de donnes")
    Language::AddTableElement("Count Row In Database table", "Compte de nombre d'enregistrement prsent dans la table")

    Language::AddTableElement("Insert Database Table entry", "Insertion d'une entre dans la table d'une base de donnes")
    Language::AddTableElement("Insert Database Table(s) entry", "Insertion d'une entre dans la/les table(s) d'une base de donnes")
    
    Language::AddTableElement("Update Database Table entry", "Mise  jour d'une entre dans la table d'une base de donnes")
    Language::AddTableElement("Update Database Table(s) entry", "Mise  jour d'une entre dans la/les table(s) d'une base de donnes")
    
    Language::AddTableElement("Delete Database Table entry", "Suppression d'une entre dans la table d'une base de donnes")
    Language::AddTableElement("Delete Database Table(s) entry", "Suppression d'une entre dans la/les table(s) d'une base de donnes")
    
    Language::AddTableElement("Extract Database Table entry", "Extraction d'une entre dans la table d'une base de donnes")
    Language::AddTableElement("Extract Database Table(s) entry", "Extraction d'une entre dans la/les table(s) d'une base de donnes")
    
    Language::AddTableElement("Transfer Database To Table(s)", "Transfrer depuis la base de donnes vers la/les Table(s)")
    Language::AddTableElement("Transfer Table(s) To Database", "Transfrer la/les table(s) vers la base de donnes")
    
    Language::AddTableElement("Open Database", "Ouverture de la base de donne")
    Language::AddTableElement("Transfer from Module to Database", "Transfer depuis le Module vers la base de donnes")
    Language::AddTableElement("Transfer from Database to Module", "Transfer depuis la base de donnes vers le Module")
    Language::AddTableElement("Vacuumize Database", "Passer l'aspirateur dans la base de donnes")
    
    Language::AddTableElement("Write in Binary file", "criture sur fichier Binaire")
    Language::AddTableElement("Read in Binary file", "Lecture sur fichier Binaire")
    Language::AddTableElement("Create Binary File", "Cration d'un fichier Binaire")
    Language::AddTableElement("Open Binary File", "Ouverture d'un fichier Binaire")
    Language::AddTableElement("Read Binary File", "Lecture d'un fichier Binaire")
    
    Language::AddTableElement("Write in Encoded file", "criture sur fichier Encod")
    Language::AddTableElement("Read in Encoded file", "Lecture sur fichier Encod")
    Language::AddTableElement("Create Encoded File", "Cration d'un fichier Encod")
    Language::AddTableElement("Open Encoded File", "Ouverture d'un fichier Encod")
    Language::AddTableElement("Read Encoded File", "Lecture d'un fichier Encod")
    Language::AddTableElement("Write in Crypted file", "criture sur fichier Crypt")
    Language::AddTableElement("Read in Crypted file", "Lecture sur fichier Crypt")
    Language::AddTableElement("Create Crypted File", "Cration d'un fichier Crypt")
    Language::AddTableElement("Open Crypted File", "Ouverture d'un fichier Crypt")
    Language::AddTableElement("Read Crypted File", "Lecture d'un fichier Crypt")
    
    Language::AddTableElement("The Debugging Operator", "L'oprateur de Deboggage")
    
    Language::AddTableElement("Code generated in : %TIME% seconds (%RATE% lines/second)", "Code gnr en : %TIME% secondes (%RATE% lignes/seconde)")
    Language::AddTableElement("END OF FILE", "FIN DU FICHIER")
    
    Language::AddTableElement("January", "Janvier")
    Language::AddTableElement("February", "Fvrier")
    Language::AddTableElement("March", "Mars")
    Language::AddTableElement("April", "Avril")
    Language::AddTableElement("May", "Mai")
    Language::AddTableElement("June", "Juin")
    Language::AddTableElement("July", "Juillet")
    Language::AddTableElement("August", "Aot")
    Language::AddTableElement("September", "Septembre")
    Language::AddTableElement("October", "Octobre")
    Language::AddTableElement("November", "Novembre")
    Language::AddTableElement("December", "Dcembre")
    
    Language::AddTableElement("Jan", "Jan")
    Language::AddTableElement("Feb", "Fv")
    Language::AddTableElement("Mar", "Mar")
    Language::AddTableElement("Apr", "Avr")
    Language::AddTableElement("May", "Mai")
    Language::AddTableElement("Jun", "Jun")
    Language::AddTableElement("Jul", "Jui")
    Language::AddTableElement("Aug", "Ao")
    Language::AddTableElement("Sep", "Sep")
    Language::AddTableElement("Oct", "Oct")
    Language::AddTableElement("Nov", "Nov")
    Language::AddTableElement("Dec", "Dc")
    
    Language::AddTableElement("Sunday", "Dimanche")
    Language::AddTableElement("Monday", "Lundi")
    Language::AddTableElement("Tuesday", "Mardi")
    Language::AddTableElement("Wednesday", "Mercredi")
    Language::AddTableElement("Thursday", "Jeudi")
    Language::AddTableElement("Friday", "Vendredi")
    Language::AddTableElement("Saturday", "Samedi")
    Language::AddTableElement("st:1,21,31|nd:2,22|rd:3,23|th:x", "er: 1|: x")
    
    Language::AddTableElement("Date Mask Editor", "diteur de masque de date")
    Language::AddTableElement("Mask parts", "Parties du masque")
    Language::AddTableElement("2 digits day", "Le jour sur 2 chiffres")
    Language::AddTableElement("3 characters day name", "Le nom du jour (3 lettres)")
    Language::AddTableElement("Long day name", "Le nom du jour")
    Language::AddTableElement("Ordinal", "Ordinal")
    Language::AddTableElement("2 digits month", "Le mois sur 2 chiffres")
    Language::AddTableElement("3 characters month name", "Le nom du mois (3 lettres)")
    Language::AddTableElement("Long month name", "Le nom du mois")
    Language::AddTableElement("4 digits year", "L'anne sur 4 chiffres")
    Language::AddTableElement("2 digits hours", "Les heures sur 2 chiffres")
    Language::AddTableElement("2 digits minutes", "Les minutes sur 2 chiffres")
    Language::AddTableElement("2 digits seconds", "Les secondes sur 2 chiffres")
    Language::AddTableElement("Definition", "Dfinition")
    
    Language::AddTableElement("OK", "Terminer")
    Language::AddTableElement("Cancel", "Annuler")
    
    Language::AddTableElement("Code Generator Statistics", "Statistiques du gnrateur de code")
    Language::AddTableElement("Statistics based on last %X% code generations", "Statistiques bases sur les %X% dernires gnrations de code")
    Language::AddTableElement("Generation Rate (Line/Second)", "Taux de Gnration (Ligne/Seconde)")
    Language::AddTableElement("Top 5 (Line/Second)", "Top 5 (Ligne/Seconde)")
    Language::AddTableElement("Generation Time (Second)", "Temps de Gnration (Seconde)")
    Language::AddTableElement("Top 5 (Second)", "Top 5 (Seconde)")
    Language::AddTableElement("Best", "Meilleur")
    Language::AddTableElement("Average", "Moyen")
    Language::AddTableElement("Worst", "Pire")
    Language::AddTableElement("Standard Deviation", "cart-Type")
    Language::AddTableElement("Close", "Fermer")
    
    Language::AddTableElement("Editors Font", "Police des diteurs")
    Language::AddTableElement("Syntax coloring", "Coloration syntaxique")
    Language::AddTableElement("Normal Text", "Texte normal")
    Language::AddTableElement("Background", "Arrire-plan")
    Language::AddTableElement("Caret", "Caret")
    Language::AddTableElement("Current line Background", "Arrire-plan ligne courante")
    Language::AddTableElement("Selection", "Slection")
    Language::AddTableElement("Selection Background", "Arrire-plan Slection")
    Language::AddTableElement("Line Numbers", "Numros de ligne")
    Language::AddTableElement("Line Numbers Background", "Arrire-plan numros de ligne")
    Language::AddTableElement("Fold Margin Background", "Arrire-plan marge pliage")
    Language::AddTableElement("Fold Markers", "Marqueur de pliage")
    Language::AddTableElement("Fold Markers Background", "Arriere-plan Marqueur de pliage")
    Language::AddTableElement("Line Highlight", "Ligne en surbrillance")
    Language::AddTableElement("Keywords", "Mot-cls")
    Language::AddTableElement("Comments", "Commentaires")
    Language::AddTableElement("Literal Strings", "Chaine de caractres")
    Language::AddTableElement("Numbers", "Nombres")
    Language::AddTableElement("Constants", "Constantes")
    Language::AddTableElement("Procedures", "Procdures")
    Language::AddTableElement("Separators", "Sparateurs")
    Language::AddTableElement("Operators", "Oprateurs")
    Language::AddTableElement("Types", "Types")
    Language::AddTableElement("Modules", "Modules")
    Language::AddTableElement("Pointers", "Pointeurs")
    Language::AddTableElement("Keywords in bold", "Mot-cls en gras")
    Language::AddTableElement("Click me", "Clique moi")
    
    Language::CreateTableFile()
    Language::Reset()
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< LinuxDesktopFile_N_Icon <<<<<
  
  CompilerIf #PB_Compiler_OS = #PB_OS_Linux
   
    Procedure LinuxDesktopFile_N_Icon()
      
      FileName.s = GetHomeDirectory() + ".local/share/applications/devmodule.desktop"
      
      If FileSize(FileName) = -1
        
        If CreateFile(0, FileName)
          
          WriteStringN(0, "#!/usr/bin/env xdg-open")
          WriteStringN(0, "")
          WriteStringN(0, "[Desktop Entry]")
          WriteStringN(0, "Version=1.0")
          WriteStringN(0, "Type=Application")
          WriteStringN(0, "Terminal=false")
          WriteStringN(0, "Exec=" + GetHomeDirectory() +"Files/Programmes/DevModule/DevModule")
          WriteStringN(0, "Name=Dev-Module")
          WriteStringN(0, "Name[fr]=Dev-Module")
          WriteStringN(0, "Icon=DevModule.png")
          WriteStringN(0, "Categories=Development")
          
          CloseFile(0)
          
        EndIf
        
      EndIf
      
      IconFileSource.s = GetPathPart(ProgramFilename()) + "icons/"
      IconFileName.s = "DevModule.png"
      IconFilePath.s = GetHomeDirectory() + ".icons/"
      
      If BuiltPathDirectory::DoIt(IconFilePath)
        
        If FileSize(IconFilePath + IconFileName) = -1
          CopyFile(IconFileSource + IconFileName, IconFilePath + IconFileName)
        EndIf
        
      EndIf 
      
    EndProcedure
    
  CompilerEndIf 
  
CompilerEndIf 

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 LTS (Linux - x64)
; Folding = -
; EnableXP
; CompileSourceDirectory