; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Module - V0.9.2
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - StaticArrayMethods.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 22-07-2018
; Mise  jour : 26-07-2018
; Cod pour PureBasic : V5.70 beta 1
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule StaticArrayMethods

  Declare.b GetQuickSortAscendant()
  Declare.b GetQuickSortDescendant()
  Declare.b GetLinearSearch()
  Declare.b GetBinarySearch()
  Declare.b GetFixedLenghtQueue()
  Declare SetQuickSortAscendant(P_QuickSortAscendant.b)
  Declare SetQuickSortDescendant(P_QuickSortDescendant.b)
  Declare SetLinearSearch(P_LinearSearch.b)
  Declare SetBinarySearch(P_BinarySearch.b)
  Declare SetFixedLenghtQueue(P_FixedLenghtQueue.b)
  Declare Reset()
  Declare ReadPrefs(P_GroupName.s)
  Declare WritePrefs(P_GroupName.s)
  Declare.s DeclareQuickSortAscendant()
  Declare.s DeclareQuickSortDescendant()
  Declare.s DeclareLinearSearch()
  Declare.s DeclareBinarySearch()
  Declare.s DeclareFixedLenghtQueue()
  Declare.s DefineQuickSortAscendant()
  Declare.s DefineQuickSortDescendant()
  Declare.s DefineLinearSearch()
  Declare.s DefineBinarySearch()
  Declare.s DefineFixedLenghtQueue()
  
EndDeclareModule

Module StaticArrayMethods
  
  Enumeration

    #INSTRUCTION_MODE_QUICK_SORT_ASCENDING
    #INSTRUCTION_MODE_QUICK_SORT_DESCENDING
    #INSTRUCTION_MODE_LINEAR_SEARCH
    #INSTRUCTION_MODE_BINARY_SEARCH
    #INSTRUCTION_MODE_FIXED_LENGTH_QUEUE
    
  EndEnumeration
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Dclaration de la Structure <<<<<

  Structure Instance

    QuickSortAscendant.b
    QuickSortDescendant.b
    LinearSearch.b
    BinarySearch.b
    FixedLenghtQueue.b

  EndStructure

  Global Instance.Instance

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les observateurs <<<<<

  Procedure.b GetQuickSortAscendant()

    ProcedureReturn Instance\QuickSortAscendant
  EndProcedure

  Procedure.b GetQuickSortDescendant()

    ProcedureReturn Instance\QuickSortDescendant
  EndProcedure

  Procedure.b GetLinearSearch()

    ProcedureReturn Instance\LinearSearch
  EndProcedure

  Procedure.b GetBinarySearch()

    ProcedureReturn Instance\BinarySearch
  EndProcedure

  Procedure.b GetFixedLenghtQueue()

    ProcedureReturn Instance\FixedLenghtQueue
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les mutateurs <<<<<

  Procedure SetQuickSortAscendant(P_QuickSortAscendant.b)

    Instance\QuickSortAscendant = P_QuickSortAscendant

  EndProcedure

  Procedure SetQuickSortDescendant(P_QuickSortDescendant.b)

    Instance\QuickSortDescendant = P_QuickSortDescendant

  EndProcedure

  Procedure SetLinearSearch(P_LinearSearch.b)

    Instance\LinearSearch = P_LinearSearch

  EndProcedure

  Procedure SetBinarySearch(P_BinarySearch.b)

    Instance\BinarySearch = P_BinarySearch

  EndProcedure

  Procedure SetFixedLenghtQueue(P_FixedLenghtQueue.b)

    Instance\FixedLenghtQueue = P_FixedLenghtQueue

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Reset <<<<<

  Procedure Reset()
    
    Instance\QuickSortAscendant = 0
    Instance\QuickSortDescendant = 0
    Instance\LinearSearch = 0
    Instance\BinarySearch = 0
    Instance\FixedLenghtQueue = 0
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Lecture d'un groupe Prfrences <<<<<

  Procedure ReadPrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    Instance\QuickSortAscendant = ReadPreferenceLong("QuickSortAscendant", Instance\QuickSortAscendant)
    Instance\QuickSortDescendant = ReadPreferenceLong("QuickSortDescendant", Instance\QuickSortDescendant)
    Instance\LinearSearch = ReadPreferenceLong("LinearSearch", Instance\LinearSearch)
    Instance\BinarySearch = ReadPreferenceLong("BinarySearch", Instance\BinarySearch)
    Instance\FixedLenghtQueue = ReadPreferenceLong("FixedLenghtQueue", Instance\FixedLenghtQueue)
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<

  Procedure WritePrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    WritePreferenceLong("QuickSortAscendant", Instance\QuickSortAscendant)
    WritePreferenceLong("QuickSortDescendant", Instance\QuickSortDescendant)
    WritePreferenceLong("LinearSearch", Instance\LinearSearch)
    WritePreferenceLong("BinarySearch", Instance\BinarySearch)
    WritePreferenceLong("FixedLenghtQueue", Instance\FixedLenghtQueue)
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration QuickSortAscendant <<<<<
  
  Procedure.s DeclareQuickSortAscendant()

    Select General::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        ExtraParam1.s = ""
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam1.s = Field::GetInstanceParam() + " = -1, "
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam1.s = Field::GetInstanceParam() + " = " + Field::#EmptyString + ", "
       
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        ExtraParam1.s = "*" + General::GetModuleName() + "A." + General::GetModuleName() + ", "
        
    EndSelect
    
    If Field::FirstInstance(0)
      
      Repeat
        
        If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(0) <= Field::#FIELD_TYPE_STRING02
          If Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING02
            Output.s + Comments::Tabulation(1) + "Declare QuickSortAscendant" + Field::GetFieldName(0) + "(" + ExtraParam1 +  "CaseSensitive.b = #False, FirstIndex = 0, LastIndex = " + Field::GetFieldArraySizeLoop(0) + ")" + LineFeed::Single()
          Else
            Output.s + Comments::Tabulation(1) + "Declare QuickSortAscendant" + Field::GetFieldName(0) + "(" + ExtraParam1 +  "FirstIndex = 0, LastIndex = " + Field::GetFieldArraySizeLoop(0) + ")" + LineFeed::Single()
          EndIf
        EndIf
        
      Until Field::NextInstance(0) = #Null
      
    EndIf
    
    If Field::FirstInstance(1)
      
      Repeat
        
        If Field::GetFieldStyle(1) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(1) <= Field::#FIELD_TYPE_STRING02
          If Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING02
            Output.s + Comments::Tabulation(1) + "Declare QuickSortAscendant" + Field::GetFieldName(1) + "(CaseSensitive.b = #False, FirstIndex = 0, LastIndex = " + Field::GetFieldArraySizeLoop(1) + ")" + LineFeed::Single()
          Else
            Output.s + Comments::Tabulation(1) + "Declare QuickSortAscendant" + Field::GetFieldName(1) + "(FirstIndex = 0, LastIndex = " + Field::GetFieldArraySizeLoop(1) + ")" + LineFeed::Single()
          EndIf
        EndIf
        
      Until Field::NextInstance(1) = #Null
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration QuickSortDescendant <<<<<  
  
  Procedure.s DeclareQuickSortDescendant()
    
    Select General::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        ExtraParam1.s = ""
       
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam1.s = Field::GetInstanceParam() + " = -1, "
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam1.s = Field::GetInstanceParam() + " = " + Field::#EmptyString + ", "
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        ExtraParam1.s = "*" + General::GetModuleName() + "A." + General::GetModuleName() + ", "
        
    EndSelect
    
    If Field::FirstInstance(0)
      
      Repeat
        
        If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(0) <= Field::#FIELD_TYPE_STRING02
          If Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING02
            Output.s + Comments::Tabulation(1) + "Declare QuickSortDescendant" + Field::GetFieldName(0) + "(" + ExtraParam1 +  "CaseSensitive.b = #False, FirstIndex = 0, LastIndex = " + Field::GetFieldArraySizeLoop(0) + ")" + LineFeed::Single()
          Else
            Output.s + Comments::Tabulation(1) + "Declare QuickSortDescendant" + Field::GetFieldName(0) + "(" + ExtraParam1 +  "FirstIndex = 0, LastIndex = " + Field::GetFieldArraySizeLoop(0) + ")" + LineFeed::Single()
          EndIf
        EndIf
        
      Until Field::NextInstance(0) = #Null
      
    EndIf
    
    If Field::FirstInstance(1)
      
      Repeat
        
        If Field::GetFieldStyle(1) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(1) <= Field::#FIELD_TYPE_STRING02
          If Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING02
            Output.s + Comments::Tabulation(1) + "Declare QuickSortDescendant" + Field::GetFieldName(1) + "(CaseSensitive.b = #False, FirstIndex = 0, LastIndex = " + Field::GetFieldArraySizeLoop(1) + ")" + LineFeed::Single()
          Else
            Output.s + Comments::Tabulation(1) + "Declare QuickSortDescendant" + Field::GetFieldName(1) + "(FirstIndex = 0, LastIndex = " + Field::GetFieldArraySizeLoop(1) + ")" + LineFeed::Single()
          EndIf
        EndIf
        
      Until Field::NextInstance(1) = #Null
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration de fouille linaire <<<<<  
  
  Procedure.s DeclareLinearSearch()
    
    Select General::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        ExtraParam2.s = ""
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam2.s = Field::GetInstanceParam() + ", "
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam2.s = Field::GetInstanceParam() + ", "
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        ExtraParam2.s = "*" + General::GetModuleName() + "A." + General::GetModuleName() + ", "
        
    EndSelect
    
    If Field::FirstInstance(0)
      
      Repeat
        If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(0) <= Field::#FIELD_TYPE_STRING02
          If Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING02
            Output.s + Comments::Tabulation(1) + "Declare.l LinearSearch" + Field::GetFieldName(0) + "(" + ExtraParam2 + "SearchValue" + Field::GetFieldExtensionLong(0) + ", CaseSensitive.b = #False)" + LineFeed::Single()
          Else
            Output.s + Comments::Tabulation(1) + "Declare.l LinearSearch" + Field::GetFieldName(0) + "(" + ExtraParam2 + "SearchValue" + Field::GetFieldExtensionLong(0) + ")" + LineFeed::Single()
          EndIf
        EndIf 
      Until Field::NextInstance(0) = #Null
      
    EndIf
    
    If Field::FirstInstance(1)
      
      Repeat
        If Field::GetFieldStyle(1) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(1) <= Field::#FIELD_TYPE_STRING02
          If Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING02
            Output.s + Comments::Tabulation(1) + "Declare.l LinearSearch" + Field::GetFieldName(1) + "(SearchValue." + Field::GetFieldExtensionLong(1) + ", CaseSensitive.b = #False)" + LineFeed::Single()
          Else
            Output.s + Comments::Tabulation(1) + "Declare.l LinearSearch" + Field::GetFieldName(1) + "(SearchValue." + Field::GetFieldExtensionLong(1) + ")" + LineFeed::Single()
          EndIf
        EndIf 
      Until Field::NextInstance(1) = #Null
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration de fouille dichotomique <<<<<  
  
  Procedure.s DeclareBinarySearch()
    
    Select General::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        ExtraParam2.s = ""
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam2.s = Field::GetInstanceParam() + ", "
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam2.s = Field::GetInstanceParam() + ", "
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        ExtraParam2.s = "*" + General::GetModuleName() + "A." + General::GetModuleName() + ", "
        
    EndSelect
    
    If Field::FirstInstance(0)
      
      Repeat
        
        If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(0) <= Field::#FIELD_TYPE_STRING02
          If Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING02
            Output.s + Comments::Tabulation(1) + "Declare.l BinarySearch" + Field::GetFieldName(0) + "(" + ExtraParam2 + "SearchValue" + Field::GetFieldExtensionLong(0) + ", CaseSensitive.b = #False)" + LineFeed::Single()
          Else
            Output.s + Comments::Tabulation(1) + "Declare.l BinarySearch" + Field::GetFieldName(0) + "(" + ExtraParam2 + "SearchValue" + Field::GetFieldExtensionLong(0) + ")" + LineFeed::Single()
          EndIf
        EndIf 
        
      Until Field::NextInstance(0) = #Null
      
    EndIf
    
    If Field::FirstInstance(1)
      
      Repeat
        
        If Field::GetFieldStyle(1) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(1) <= Field::#FIELD_TYPE_STRING02
          If Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING02
            Output.s + Comments::Tabulation(1) + "Declare.l BinarySearch" + Field::GetFieldName(1) + "(SearchValue" + Field::GetFieldExtensionLong(1) + ", CaseSensitive.b = #False)" + LineFeed::Single()
          Else
            Output.s + Comments::Tabulation(1) + "Declare.l BinarySearch" + Field::GetFieldName(1) + "(SearchValue" + Field::GetFieldExtensionLong(1) + ")" + LineFeed::Single()
          EndIf
        EndIf 
        
      Until Field::NextInstance(1) = #Null
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dclaration de file d'attente  longueur fixe <<<<<  
  
  Procedure.s DeclareFixedLenghtQueue()
    
    Select General::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        ExtraParam2.s = ""
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam2.s = Field::GetInstanceParam() + ", "
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam2.s = Field::GetInstanceParam() + ", "
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        ExtraParam2.s = "*" + General::GetModuleName() + "A." + General::GetModuleName() + ", "
        
    EndSelect
    
    If Field::FirstInstance(0)
      
      Repeat
        If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(0) <= Field::#FIELD_TYPE_STRING02
          Output.s + Comments::Tabulation(1) + "Declare InsertTopBottomOut" + Field::GetFieldName(0) + "(" + ExtraParam2 + "P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) + ")" + LineFeed::Single()
        EndIf
      Until Field::NextInstance(0) = #Null
      
    EndIf
    
    If Field::FirstInstance(1)
      
      Repeat
        If Field::GetFieldStyle(1) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(1) <= Field::#FIELD_TYPE_STRING02
          Output.s + Comments::Tabulation(1) + "Declare InsertTopBottomOut" + Field::GetFieldName(1) + "(P_" + Field::GetFieldName(1) + Field::GetFieldExtensionLong(1) + ")" + LineFeed::Single()
        EndIf
      Until Field::NextInstance(1) = #Null
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Oprateur priv <<<<<
  
  Procedure.s InstructionStaticArray(Target.l, MethodID.l, TabSize.b)
    
    InstanceStyle.s = Field::GetInstanceAccessPath()
    
    Select General::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        ExtraParam.s = ""
        ExtraParam1.s = ""
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID To Field::#INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = ", " + Field::GetInstanceParam() + " = -1"
        ExtraParam1.s = StringField(Field::GetInstanceParam(), 1, ".") + ", "
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = ", *" + General::GetModuleName() + "A." + General::GetModuleName()
        ExtraParam1.s = "*" + General::GetModuleName() + "A, "
        
    EndSelect
    
    If General::GetSecondaryInstance() = #True And Target = 1
      ExtraParam.s = ""
      ExtraParam1.s = ""
      InstanceStyle.s = "Secondary\"
    EndIf
    
    If Field::GetFieldType(Target) = Field::#FIELD_TYPE_STRING01
      DollarSign.s = "$"
    Else
      DollarSign = ""
    EndIf
    
    
    Select MethodID
        
      Case #INSTRUCTION_MODE_QUICK_SORT_ASCENDING
        
        InstructionMin.s = InstanceStyle + Field::GetFieldName(Target) + DollarSign + "[MinIndex]"
        InstructionMax.s = InstanceStyle + Field::GetFieldName(Target) + DollarSign + "[MaxIndex]"
        InstructionMid.s = InstanceStyle + Field::GetFieldName(Target) + DollarSign + "[(FirstIndex + LastIndex) >> 1]"
        Test01.s = "UCase(" + InstructionMin + ") < UCase(SplitValue" + DollarSign + ")"
        Test02.s = "UCase(" + InstructionMax + ") > UCase(SplitValue" + DollarSign + ")"
        Test03.s = InstructionMin + " < SplitValue" + DollarSign
        Test04.s = InstructionMax + " > SplitValue" + DollarSign
        
        Instruction.s + Comments::Tabulation(TabSize) + "MinIndex = FirstIndex" + LineFeed::Single() 
        Instruction + Comments::Tabulation(TabSize) + "MaxIndex = LastIndex" + LineFeed::Single()
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_BASIC_ARRAY
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_STRING01, Field::#FIELD_TYPE_STRING02
                CommandName02.s = "QuickSortAscendant" + Field::GetFieldName(Target) + "(" + ExtraParam1 + "CaseSensitive, FirstIndex, MaxIndex)"
                CommandName03.s = "QuickSortAscendant" + Field::GetFieldName(Target) + "(" + ExtraParam1 + "CaseSensitive, MinIndex, LastIndex)"
                
                Instruction + Comments::Tabulation(TabSize) + "SplitValue" + Field::GetFieldExtensionLong(Target) + " = " + InstructionMid + LineFeed::Twin()
                Instruction + Comments::Tabulation(TabSize) + "If CaseSensitive = #True" + LineFeed::Twin()
                Instruction + Field::InsertQuickSort(TabSize + 1, Test01, Test02, InstructionMin, InstructionMax) + LineFeed::Single()
                Instruction + Comments::Tabulation(TabSize) + "Else" + LineFeed::Twin()
                Instruction + Field::InsertQuickSort(TabSize + 1, Test03, Test04, InstructionMin, InstructionMax) + LineFeed::Single()
                Instruction + Comments::Tabulation(TabSize) + "EndIf" + LineFeed::Twin()
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_DOUBLE
                CommandName02.s = "QuickSortAscendant" + Field::GetFieldName(Target) + "(" + ExtraParam1 + "FirstIndex, MaxIndex)"
                CommandName03.s = "QuickSortAscendant" + Field::GetFieldName(Target) + "(" + ExtraParam1 + "MinIndex, LastIndex)"
                Instruction + Comments::Tabulation(TabSize) + "SplitValue" + Field::GetFieldExtensionLong(Target) + " = " + InstructionMid + LineFeed::Twin()
                Instruction + Field::InsertQuickSort(TabSize, Test03, Test04, InstructionMin, InstructionMax) + LineFeed::Single()
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "If FirstIndex < MaxIndex" + LineFeed::Single()
            Instruction + Comments::Tabulation(TabSize + 1) + CommandName02 + LineFeed::Single() 
            Instruction + Comments::Tabulation(TabSize) + "EndIf" + LineFeed::Twin()
            Instruction + Comments::Tabulation(TabSize) + "If MinIndex < LastIndex" + LineFeed::Single() 
            Instruction + Comments::Tabulation(TabSize + 1) + CommandName03 + LineFeed::Single()
            Instruction + Comments::Tabulation(TabSize) + "EndIf" + LineFeed::Twin()
            
        EndSelect
        
      Case #INSTRUCTION_MODE_QUICK_SORT_DESCENDING
        
        InstructionMin.s = InstanceStyle + Field::GetFieldName(Target) + DollarSign + "[MinIndex]"
        InstructionMax.s = InstanceStyle + Field::GetFieldName(Target) + DollarSign + "[MaxIndex]"
        InstructionMid.s = InstanceStyle + Field::GetFieldName(Target) + DollarSign + "[(FirstIndex + LastIndex) >> 1]"
        Test01.s = "UCase(" + InstructionMin + ") > UCase(SplitValue" + DollarSign + ")"
        Test02.s = "UCase(" + InstructionMax + ") < UCase(SplitValue" + DollarSign + ")"
        Test03.s = InstructionMin + " > SplitValue" + DollarSign
        Test04.s = InstructionMax + " < SplitValue" + DollarSign
        
        Instruction + Comments::Tabulation(TabSize) + "MinIndex = FirstIndex" + LineFeed::Single() 
        Instruction + Comments::Tabulation(TabSize) + "MaxIndex = LastIndex" + LineFeed::Single()
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_BASIC_ARRAY
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_STRING01, Field::#FIELD_TYPE_STRING02
                CommandName02.s = "QuickSortDescendant" + Field::GetFieldName(Target) + "(" + ExtraParam1 + "CaseSensitive, FirstIndex, MaxIndex)"
                CommandName03.s = "QuickSortDescendant" + Field::GetFieldName(Target) + "(" + ExtraParam1 + "CaseSensitive, MinIndex, LastIndex)"
                
                Instruction + Comments::Tabulation(TabSize) + "SplitValue" + Field::GetFieldExtensionLong(Target) + " = " + InstructionMid + LineFeed::Twin()
                Instruction + Comments::Tabulation(TabSize) + "If CaseSensitive = #True" + LineFeed::Twin()
                Instruction + Field::InsertQuickSort(TabSize + 1, Test01, Test02, InstructionMin, InstructionMax) + LineFeed::Single()
                Instruction + Comments::Tabulation(TabSize) + "Else" + LineFeed::Twin()
                Instruction + Field::InsertQuickSort(TabSize + 1, Test03, Test04, InstructionMin, InstructionMax) + LineFeed::Single()
                Instruction + Comments::Tabulation(TabSize) + "EndIf" + LineFeed::Twin()
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_DOUBLE
                CommandName02.s = "QuickSortDescendant" + Field::GetFieldName(Target) + "(" + ExtraParam1 + "FirstIndex, MaxIndex)"
                CommandName03.s = "QuickSortDescendant" + Field::GetFieldName(Target) + "(" + ExtraParam1 + "MinIndex, LastIndex)"
                Test03.s = InstructionMin + " > SplitValue"
                Test04.s = InstructionMax + " < SplitValue"
                Instruction + Comments::Tabulation(TabSize) + "SplitValue" + Field::GetFieldExtensionLong(Target) + " = " + InstructionMid + LineFeed::Twin()
                Instruction + Field::InsertQuickSort(TabSize, Test03, Test04, InstructionMin, InstructionMax) + LineFeed::Single()
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "If FirstIndex < MaxIndex" + LineFeed::Single()
            Instruction + Comments::Tabulation(TabSize + 1) + CommandName02 + LineFeed::Single() 
            Instruction + Comments::Tabulation(TabSize) + "EndIf" + LineFeed::Twin()
            Instruction + Comments::Tabulation(TabSize) + "If MinIndex < LastIndex" + LineFeed::Single() 
            Instruction + Comments::Tabulation(TabSize + 1) + CommandName03 + LineFeed::Single()
            Instruction + Comments::Tabulation(TabSize) + "EndIf" + LineFeed::Twin()
            
        EndSelect
        
      Case #INSTRUCTION_MODE_LINEAR_SEARCH
        
        InstructionA.s = InstanceStyle + Field::GetFieldName(Target) + DollarSign + "[" + Field::GetFieldArrayIndexName(Target) + "]"
        Test01.s = "UCase(" + InstructionA + ") = UCase(SearchValue" + DollarSign + ")"
        Test02.s = InstructionA + " = SearchValue" + DollarSign
        ArraySizeLoop.s = "For " + Field::GetFieldArrayIndexName(Target) + " = 0 To " + Field::GetFieldArraySizeLoop(Target)
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_BASIC_ARRAY
            
            Instruction + Comments::Tabulation(TabSize) + "IsFoundAtIndex.l = -1" + LineFeed::Twin()
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_STRING01, Field::#FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize) + "If CaseSensitive = #True" + LineFeed::Twin()
                Instruction + Field::InsertLinearSearch(TabSize + 1, ArraySizeLoop, Test01, Field::GetFieldArrayIndexName(Target)) + LineFeed::Single()
                Instruction + Comments::Tabulation(TabSize) + "Else" + LineFeed::Twin()
                Instruction + Field::InsertLinearSearch(TabSize + 1, ArraySizeLoop, Test02, Field::GetFieldArrayIndexName(Target)) + LineFeed::Single()
                Instruction + Comments::Tabulation(TabSize) + "EndIf" + LineFeed::Twin()
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_DOUBLE
                Instruction + Field::InsertLinearSearch(TabSize, ArraySizeLoop, Test02, Field::GetFieldArrayIndexName(Target)) + LineFeed::Single()
                
            EndSelect
            
        EndSelect
        
        Instruction + Comments::Tabulation(TabSize) + "ProcedureReturn IsFoundAtIndex" + LineFeed::Single()
        
      Case #INSTRUCTION_MODE_BINARY_SEARCH
        
        InstructionA.s = InstanceStyle + Field::GetFieldName(Target) + DollarSign + "[MiddlePosition]" 
        Test01.s = "UCase(SearchValue) < UCase(" + InstructionA + ")"
        Test02.s = "Ucase(SearchValue) > UCase(" + InstructionA + ")"
        Test03.s = "SearchValue < " + InstructionA
        Test04.s = "SearchValue > " + InstructionA
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_BASIC_ARRAY
            
            Instruction + Comments::Tabulation(TabSize) + "IsFoundAtIndex.l = -1" + LineFeed::Single()
            Instruction + Comments::Tabulation(TabSize) + "StartPosition.l = 0" + LineFeed::Single()
            Instruction + Comments::Tabulation(TabSize) + "EndPosition.l = " + Field::GetFieldArraySizeLoop(Target) + LineFeed::Twin()
            
            Select Field::GetFieldType(Target)
                
              Case Field::#FIELD_TYPE_STRING01, Field::#FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize) + "If CaseSensitive = #False" + LineFeed::Twin()
                Instruction + Comments::Tabulation(TabSize + 1) + "If EndPosition > 1" + LineFeed::Twin()
                Instruction + Field::InsertBinarySearch(TabSize + 2, "", Test01, Test02) + LineFeed::Single()
                Instruction + Comments::Tabulation(TabSize + 1) + "EndIf" + LineFeed::Twin()
                Instruction + Comments::Tabulation(TabSize) + "Else" + LineFeed::Twin()
                Instruction + Comments::Tabulation(TabSize + 1) + "If EndPosition > 1" + LineFeed::Twin()
                Instruction + Field::InsertBinarySearch(TabSize + 2, "", Test03, Test04) + LineFeed::Single()
                Instruction + Comments::Tabulation(TabSize + 1) + "EndIf" + LineFeed::Twin()
                Instruction + Comments::Tabulation(TabSize) + "EndIf" + LineFeed::Twin()
                
              Case Field::#FIELD_TYPE_BYTE To Field::#FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize) + "If EndPosition > 1" + LineFeed::Twin()
                Instruction + Field::InsertBinarySearch(TabSize + 1, "", Test03, Test04)+ LineFeed::Single()
                Instruction + Comments::Tabulation(TabSize) + "EndIf" + LineFeed::Twin()
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "ProcedureReturn IsFoundAtIndex" + LineFeed::Single()
            
        EndSelect 
        
      Case #INSTRUCTION_MODE_FIXED_LENGTH_QUEUE
        
        Select Field::GetFieldStyle(Target)
            
          Case Field::#FIELD_STYLE_BASIC_ARRAY
            Instruction + Comments::Tabulation(TabSize) + "For " + Field::GetFieldArrayIndexName(Target) +  " = " + Field::GetFieldArraySizeLoop(Target) + " To 1 Step -1" + LineFeed::Single()
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + Field::GetFieldName(Target) + DollarSign + "[" + Field::GetFieldArrayIndexName(Target) + "] = " + InstanceStyle + Field::GetFieldName(Target) + DollarSign + "[" + Field::GetFieldArrayIndexName(Target) + " - 1]" + LineFeed::Single()
            Instruction + Comments::Tabulation(TabSize) + "Next" + LineFeed::Twin()
            Instruction + Comments::Tabulation(TabSize) + InstanceStyle + Field::GetFieldName(Target) + DollarSign + "[0] = P_" + Field::GetFieldName(Target) + LineFeed::Twin()
            
        EndSelect 
    EndSelect 
    
    ProcedureReturn Instruction
  EndProcedure
    
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition QuickSortAscendant <<<<<
  
  Procedure.s DefineQuickSortAscendant()
    
    Select General::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        ExtraParam1.s = ""
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam1.s = Field::GetInstanceParam() + " = -1, "
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam1.s = Field::GetInstanceParam() + " = " + Field::#EmptyString + ", "
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
         ExtraParam1.s = "*" + General::GetModuleName() + "A." + General::GetModuleName() + ", "

    EndSelect
    
    If Field::FirstInstance(0)
      
      Repeat
        
        If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(0) <= Field::#FIELD_TYPE_STRING02
          
          If Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING02
            Output.s + Comments::Tabulation(1) + "Procedure QuickSortAscendant" + Field::GetFieldName(0) + "(" + ExtraParam1 +  "CaseSensitive.b = #False, FirstIndex = 0, LastIndex = " + Field::GetFieldArraySizeLoop(0) + ")" + LineFeed::Twin()
          Else
            Output.s + Comments::Tabulation(1) + "Procedure QuickSortAscendant" + Field::GetFieldName(0) + "(" + ExtraParam1 +  "FirstIndex = 0, LastIndex = " + Field::GetFieldArraySizeLoop(0) + ")" + LineFeed::Twin()
          EndIf
          
          Select General::GetInstanceStyle()
              
            Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_QUICK_SORT_ASCENDING, 2)
              
            Case Field::#INSTANCE_STYLE_MULTIPLE_ID
              Output + Comments::Tabulation(2) + "If P_InstanceID = -1" + LineFeed::Twin()
              Output + Comments::Tabulation(3) + "ForEach Instances()" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_QUICK_SORT_ASCENDING, 4)
              Output + Comments::Tabulation(3) + "Next" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "Else" + LineFeed::Twin()
              Output + Comments::Tabulation(3) + "If SearchInstances(P_InstanceID) <> -1" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_QUICK_SORT_ASCENDING, 4)
              Output + Comments::Tabulation(3) + "EndIf" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              
            Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
              Output + Comments::Tabulation(2) + "If P_Index = -1" + LineFeed::Twin()
              Output + Comments::Tabulation(3) + "ForEach Instances()" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_QUICK_SORT_ASCENDING, 4)
              Output + Comments::Tabulation(3) + "Next" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "Else" + LineFeed::Twin()
              Output + Comments::Tabulation(3) + "If SelectElement(Instances(), P_Index)" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_QUICK_SORT_ASCENDING, 4)
              Output + Comments::Tabulation(3) + "EndIf" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              
            Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
              Output + Comments::Tabulation(2) + "If P_Name = " + Field::#EmptyString + LineFeed::Twin()
              Output + Comments::Tabulation(3) + "ForEach Instances()" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_QUICK_SORT_ASCENDING, 4)
              Output + Comments::Tabulation(3) + "Next" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "Else" + LineFeed::Twin()
              Output + Comments::Tabulation(3) + "If FindMapElement(P_Name)" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_QUICK_SORT_ASCENDING, 4)
              Output + Comments::Tabulation(3) + "EndIf" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              
          EndSelect
          
          Output + Comments::Tabulation(1) + "EndProcedure" + LineFeed::Twin()
          
        EndIf
        
      Until Field::NextInstance(0) = #Null
      
    EndIf
    
    If Field::FirstInstance(1)
      
      Repeat
        
        If Field::GetFieldStyle(1) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(1) <= Field::#FIELD_TYPE_STRING02
          
          CommandName.s = "QuickSortAscendant" + Field::GetFieldName(1)
          
          If Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING02
            Output.s + Comments::Tabulation(1) + "Procedure " + CommandName + "(" + ExtraParam1 +  "CaseSensitive.b = #False, FirstIndex = 0, LastIndex = " + Field::GetFieldArraySizeLoop(1) + ")" + LineFeed::Twin()
          Else
            Output.s + Comments::Tabulation(1) + "Procedure " + CommandName + "(" + ExtraParam1 +  "FirstIndex = 0, LastIndex = " + Field::GetFieldArraySizeLoop(1) + ")" + LineFeed::Twin()
          EndIf
          
          Output + InstructionStaticArray(1, #INSTRUCTION_MODE_QUICK_SORT_ASCENDING, 2)
          Output + Comments::Tabulation(1) + "EndProcedure" + LineFeed::Twin()
          
        EndIf
        
      Until Field::NextInstance(1) = #Null
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
    
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition QuickSortDescendant <<<<<
  
  Procedure.s DefineQuickSortDescendant()
    
    Select General::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        ExtraParam1.s = ""
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam1.s = Field::GetInstanceParam() + " = -1, "
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam1.s = Field::GetInstanceParam() + " = " + Field::#EmptyString + ", "
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        ExtraParam1.s = "*" + General::GetModuleName() + "A." + General::GetModuleName() + ", "
       
    EndSelect
    
    If Field::FirstInstance(0)
      
      Repeat
        
        If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(0) <= Field::#FIELD_TYPE_STRING02
          
          If Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING02
            Output.s + Comments::Tabulation(1) + "Procedure QuickSortDescendant" + Field::GetFieldName(0) + "(" + ExtraParam1 +  "CaseSensitive.b = #False, FirstIndex = 0, LastIndex = " + Field::GetFieldArraySizeLoop(0) + ")" + LineFeed::Twin()
          Else
            Output.s + Comments::Tabulation(1) + "Procedure QuickSortDescendant" + Field::GetFieldName(0) + "(" + ExtraParam1 +  "FirstIndex = 0, LastIndex = " + Field::GetFieldArraySizeLoop(0) + ")" + LineFeed::Twin()
          EndIf
          
          Select General::GetInstanceStyle()
              
            Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_QUICK_SORT_DESCENDING, 2)
              
            Case Field::#INSTANCE_STYLE_MULTIPLE_ID
              Output + Comments::Tabulation(2) + "If P_InstanceID = -1" + LineFeed::Twin()
              Output + Comments::Tabulation(3) + "Foreach Instances()" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_QUICK_SORT_DESCENDING, 4)
              Output + Comments::Tabulation(3) + "Next" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "Else" + LineFeed::Twin()
              Output + Comments::Tabulation(3) + "If SearchInstances(P_InstanceID) <> -1" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_QUICK_SORT_DESCENDING, 4)
              Output + Comments::Tabulation(3) + "EndIf" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              
            Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
              Output + Comments::Tabulation(2) + "If P_Index = -1" + LineFeed::Twin()
              Output + Comments::Tabulation(3) + "Foreach Instances()" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_QUICK_SORT_DESCENDING, 4)
              Output + Comments::Tabulation(3) + "Next" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "Else" + LineFeed::Twin()
              Output + Comments::Tabulation(3) + "If SearchInstances(P_InstanceID) <> -1" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_QUICK_SORT_DESCENDING, 4)
              Output + Comments::Tabulation(3) + "EndIf" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              
            Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
              Output + Comments::Tabulation(2) + "If P_Name = " + Field::#EmptyString + LineFeed::Twin()
              Output + Comments::Tabulation(3) + "Foreach Instances()" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_QUICK_SORT_DESCENDING, 4)
              Output + Comments::Tabulation(3) + "Next" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "Else" + LineFeed::Twin()
              Output + Comments::Tabulation(3) + "If SearchInstances(P_InstanceID) <> -1" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_QUICK_SORT_DESCENDING, 4)
              Output + Comments::Tabulation(3) + "EndIf" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              
          EndSelect
          
          Output + Comments::Tabulation(1) + "EndProcedure" + LineFeed::Twin()
          
        EndIf
        
      Until Field::NextInstance(0) = #Null
      
    EndIf
    
    If Field::FirstInstance(1)
      
      Repeat
        
        If Field::GetFieldStyle(1) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(1) <= Field::#FIELD_TYPE_STRING02
          
          If Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING02
            Output.s + Comments::Tabulation(1) + "Procedure QuickSortDescendant" + Field::GetFieldName(1) + "(CaseSensitive.b = #False, FirstIndex = 0, LastIndex = " + Field::GetFieldArraySizeLoop(1) + ")" + LineFeed::Twin()
          Else
            Output.s + Comments::Tabulation(1) + "Procedure QuickSortDescendant" + Field::GetFieldName(1) + "(FirstIndex = 0, LastIndex = " + Field::GetFieldArraySizeLoop(1) + ")" + LineFeed::Twin()
          EndIf
          
          Output + InstructionStaticArray(1, #INSTRUCTION_MODE_QUICK_SORT_DESCENDING, 2)
          Output + Comments::Tabulation(1) + "EndProcedure" + LineFeed::Twin()
          
        EndIf
        
      Until Field::NextInstance(1) = #Null
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
    
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition fouille linaire <<<<<
  
  Procedure.s DefineLinearSearch()
    
    Select General::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        ExtraParam2.s = ""
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam2.s = Field::GetInstanceParam() + ", "
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam2.s = Field::GetInstanceParam() + ", "
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        ExtraParam2.s = "*" + General::GetModuleName() + "A." + General::GetModuleName() + ", "
        
    EndSelect
    
    If Field::FirstInstance(0)
      
      Repeat
        
        If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(0) <= Field::#FIELD_TYPE_STRING02
          
          If Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING02
            Output.s + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Field::GetFieldName(0) + "(" + ExtraParam2 + "SearchValue" + Field::GetFieldExtensionLong(0) + ", CaseSensitive.b = #False)" + LineFeed::Twin()
          Else
            Output.s + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Field::GetFieldName(0) + "(" + ExtraParam2 + "SearchValue" + Field::GetFieldExtensionLong(0) + ")" + LineFeed::Twin()
          EndIf
          
          Select General::GetInstanceStyle()
              
            Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_LINEAR_SEARCH, 2)
              
            Case Field::#INSTANCE_STYLE_MULTIPLE_ID
              Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> -1" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_LINEAR_SEARCH, 3) + LineFeed::Single()
              Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "ProcedureReturn -2" + LineFeed::Single()
              
            Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
              Output + Comments::Tabulation(2) + "If SelectElement(P_Index)" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_LINEAR_SEARCH, 3) + LineFeed::Single()
              Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "ProcedureReturn -2" + LineFeed::Single()
              
            Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
              Output + Comments::Tabulation(2) + "If FindMapElement(P_Name)" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_LINEAR_SEARCH, 3) + LineFeed::Single()
              Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "ProcedureReturn -2" + LineFeed::Single()
              
          EndSelect
          
          Output + Comments::Tabulation(1) + "EndProcedure" + LineFeed::Twin()
          
        EndIf 
        
      Until Field::NextInstance(0) = #Null
      
    EndIf
    
    If Field::FirstInstance(1)
      
      Repeat
        
        If Field::GetFieldStyle(1) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(1) <= Field::#FIELD_TYPE_STRING02
          
          If Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING02
            Output.s + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Field::GetFieldName(1) + "(SearchValue" + Field::GetFieldExtensionLong(1) + ", CaseSensitive.b = #False)" + LineFeed::Twin()
          Else
            Output.s + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Field::GetFieldName(1) + "(SearchValue" + Field::GetFieldExtensionLong(1) + ")" + LineFeed::Twin()
          EndIf
          
          Output + InstructionStaticArray(1, #INSTRUCTION_MODE_LINEAR_SEARCH, 2)
          
          Output + Comments::Tabulation(1) + "EndProcedure" + LineFeed::Twin()
          
        EndIf
        
      Until Field::NextInstance(1) = #Null
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition de fouille dichotomique <<<<<
  
  Procedure.s DefineBinarySearch()
    
    Select General::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        ExtraParam2.s = ""
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam2.s = Field::GetInstanceParam() + ", "
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam2.s = Field::GetInstanceParam() + ", "
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        ExtraParam2.s = "*" + General::GetModuleName() + "A." + General::GetModuleName() + ", "
        
    EndSelect
    
    If Field::FirstInstance(0)
      
      Repeat
        
        If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(0) <= Field::#FIELD_TYPE_STRING02
          
          If Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(0) = Field::#FIELD_TYPE_STRING02
            Output.s + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Field::GetFieldName(0) + "(" + ExtraParam2 + "SearchValue" + Field::GetFieldExtensionLong(0) + ", CaseSensitive.b = #False)" + LineFeed::Twin()
          Else
            Output.s + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Field::GetFieldName(0) + "(" + ExtraParam2 + "SearchValue" + Field::GetFieldExtensionLong(0) + ")" + LineFeed::Twin()
          EndIf
          
          Select General::GetInstanceStyle()
              
            Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_BINARY_SEARCH, 2)
              
            Case Field::#INSTANCE_STYLE_MULTIPLE_ID
              Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> -1" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_BINARY_SEARCH, 3) + LineFeed::Single()
              Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "ProcedureReturn -2" + LineFeed::Single()
              
            Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
              Output + Comments::Tabulation(2) + "If SelectElement(P_Index)" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_BINARY_SEARCH, 3) + LineFeed::Single()
              Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "ProcedureReturn -2" + LineFeed::Single()
              
            Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
              Output + Comments::Tabulation(2) + "If FindMapElement(P_Name)" + LineFeed::Twin()
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_BINARY_SEARCH, 3) + LineFeed::Single()
              Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              Output + Comments::Tabulation(2) + "ProcedureReturn -2" + LineFeed::Single()
              
          EndSelect
          
          Output + Comments::Tabulation(1) + "EndProcedure" + LineFeed::Twin()
          
        EndIf 
        
      Until Field::NextInstance(0) = #Null
      
    EndIf
    
    If Field::FirstInstance(1)
      
      Repeat
        
        If Field::GetFieldStyle(1) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(1) <= Field::#FIELD_TYPE_STRING02
          
          If Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING01 Or Field::GetFieldType(1) = Field::#FIELD_TYPE_STRING02
            Output.s + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Field::GetFieldName(1) + "(SearchValue" + Field::GetFieldExtensionLong(1) + ", CaseSensitive.b = #False)" + LineFeed::Twin()
          Else
            Output.s + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Field::GetFieldName(1) + "(SearchValue" + Field::GetFieldExtensionLong(1) + ")" + LineFeed::Twin()
          EndIf
          
          Output + InstructionStaticArray(1, #INSTRUCTION_MODE_BINARY_SEARCH, 2)
          
          Output + Comments::Tabulation(1) + "EndProcedure" + LineFeed::Twin()
          
        EndIf
        
      Until Field::NextInstance(1) = #Null
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
    
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur de dfinition de file d'attente  longueur fixe <<<<<
  
  Procedure.s DefineFixedLenghtQueue()
    
    Select General::GetInstanceStyle()
        
      Case Field::#INSTANCE_STYLE_UNIQUE
        ExtraParam2.s = ""
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_ID, Field::#INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam2.s = Field::GetInstanceParam() + ", "
        
      Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam2.s = Field::GetInstanceParam() + ", "
        
      Case Field::#INSTANCE_STYLE_OFF_MODULE
        ExtraParam2.s = "*" + General::GetModuleName() + "A." + General::GetModuleName() + ", "
        
    EndSelect
    
    If Field::FirstInstance(0)
      
      Repeat
        
        If Field::GetFieldStyle(0) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(0) <= Field::#FIELD_TYPE_STRING02
          
          Output.s + Comments::Tabulation(1) + "Procedure InsertTopBottomOut" + Field::GetFieldName(0) + "(" + ExtraParam2 + "P_" + Field::GetFieldName(0) + Field::GetFieldExtensionLong(0) + ")" + LineFeed::Twin()
          
          Select General::GetInstanceStyle()
              
            Case Field::#INSTANCE_STYLE_UNIQUE, Field::#INSTANCE_STYLE_OFF_MODULE
              Output + InstructionStaticArray(0, #INSTRUCTION_MODE_FIXED_LENGTH_QUEUE, 2)
              
            Case Field::#INSTANCE_STYLE_MULTIPLE_ID
              Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> -1" + LineFeed::Twin()
              Output +  InstructionStaticArray(0, #INSTRUCTION_MODE_FIXED_LENGTH_QUEUE, 3)
              Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              
            Case Field::#INSTANCE_STYLE_MULTIPLE_INDEX
              Output + Comments::Tabulation(2) + "If SelectElement(P_InstanceID)" + LineFeed::Twin()
              Output +  InstructionStaticArray(0, #INSTRUCTION_MODE_FIXED_LENGTH_QUEUE, 3)
              Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              
            Case Field::#INSTANCE_STYLE_MULTIPLE_NAME
              Output + Comments::Tabulation(2) + "If FindMapElement(P_InstanceID)" + LineFeed::Twin()
              Output +  InstructionStaticArray(0, #INSTRUCTION_MODE_FIXED_LENGTH_QUEUE, 3)
              Output + Comments::Tabulation(2) + "EndIf" + LineFeed::Twin()
              
          EndSelect
          
          Output + Comments::Tabulation(1) + "EndProcedure" + LineFeed::Twin()
          
        EndIf
        
      Until Field::NextInstance(0) = #Null
      
    EndIf
    
    If Field::FirstInstance(1)
      
      Repeat
        
        If Field::GetFieldStyle(1) = Field::#FIELD_STYLE_BASIC_ARRAY And Field::GetFieldType(1) <= Field::#FIELD_TYPE_STRING02
          
          Output.s + Comments::Tabulation(1) + "Procedure InsertTopBottomOut" + Field::GetFieldName(1) + "(P_" + Field::GetFieldName(1) + Field::GetFieldExtensionLong(1) + ")" + LineFeed::Twin()
          Output + InstructionStaticArray(1, #INSTRUCTION_MODE_FIXED_LENGTH_QUEUE, 2)
          Output + Comments::Tabulation(1) + "EndProcedure" + LineFeed::Twin()
          
        EndIf
                
      Until Field::NextInstance(1) = #Null
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (159000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 LTS (Linux - x64)
; Folding = -----
; EnableXP
; CompileSourceDirectory