; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Module - V0.0.6
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - Stats.pb
; Version du fichier : 0.9.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 04-11-2015
; Mise  jour : 21-05-2018
; Code PureBasic : V5.62
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Stats
  
  Declare Initialize()
  Declare Reset()
  Declare ReadPrefs(P_GroupName.s)
  Declare WritePrefs(P_GroupName.s)
  Declare RatesCandidateForTop5(P_Rates.d)
  Declare TimesCandidateForTop5(P_Times.l)
  Declare Analysis()
  Declare InsertTopBottomOutRatesTimes(P_Rates.d, P_Times.l)
  Declare OpenStatsWindow(MainWinCte.i)
  
EndDeclareModule

Module Stats
  
  Enumeration 600
    
    #Win_Stats
    
    #Frm_Rate_Stats
    #Txt_BestRate
    #Str_BestRate
    #Txt_MeanRate
    #Str_MeanRate
    #Txt_WorstRate
    #Str_WorstRate
    #Txt_RateDeviation
    #Str_RateDeviation
    
    #Frm_Time_Stats
    #Txt_BestTime
    #Str_BestTime
    #Txt_MeanTime
    #Str_MeanTime
    #Txt_WorstTime
    #Str_WorstTime
    #Txt_TimeDeviation
    #Str_TimeDeviation
    
    #Txt_Stats_Data_Count
    
    #Frm_Time_Top5
    #Txt_Time_Top5_1
    #Str_Time_Top5_1
    #Txt_Time_Top5_2
    #Str_Time_Top5_2
    #Txt_Time_Top5_3
    #Str_Time_Top5_3
    #Txt_Time_Top5_4
    #Str_Time_Top5_4
    #Txt_Time_Top5_5
    #Str_Time_Top5_5
    
    #Frm_Rate_Top5
    #Txt_Rate_Top5_1
    #Str_Rate_Top5_1
    #Txt_Rate_Top5_2
    #Str_Rate_Top5_2
    #Txt_Rate_Top5_3
    #Str_Rate_Top5_3
    #Txt_Rate_Top5_4
    #Str_Rate_Top5_4
    #Txt_Rate_Top5_5
    #Str_Rate_Top5_5
    
    #Btn_Stats_Close
    
    #ShortCut_Stats_Windows
    
  EndEnumeration
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Constantes de dimensionnement <<<<<
  
  #STATS_MAX = 200
  
  Structure Instance
    
    BestRate.d
    MeanRate.d
    WorstRate.d
    RateDeviation.d
    BestTime.l
    MeanTime.l
    WorstTime.l
    TimeDeviation.q
    SampleSize.w
    List Rates.d()
    List Times.l()
    RatesTop5.d[5]
    TimesTop5.l[5]
    DisplayWindowCounter.b
    
  EndStructure
  
  Global Instance.Instance
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Initialize <<<<<
  
  Procedure Initialize()
    
    Window::Initialize(#Win_Stats, 0, 0, 605, 410, #False)
    
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  
    ; Ici on force une valeur norme de temps de gnration
    ; cette astuce est ncessaire pour la recherche du Top 5
    ; des meilleurs temps de gnration.
    
    For TimesTop5ID = 0 To 4
      Instance\TimesTop5[TimesTop5ID] = 2147483647
    Next
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Reset <<<<<

  Procedure Reset()
    
    Instance\BestRate = 0.0
    Instance\MeanRate = 0.0
    Instance\WorstRate = 0.0
    Instance\RateDeviation = 0.0
    Instance\BestTime = 0
    Instance\MeanTime = 0
    Instance\WorstTime = 0
    Instance\TimeDeviation = 0
    Instance\SampleSize = 0
    
    ForEach Instance\Rates()
      Instance\Rates() = 0.0
    Next

    FreeList(Instance\Rates())
    
    ForEach Instance\Times()
      Instance\Times() = 0
    Next

    FreeList(Instance\Times())
    
    For RatesTop5ID = 0 To 4
      Instance\RatesTop5[RatesTop5ID] = 0.0
      Instance\TimesTop5[RatesTop5ID] = 0
    Next
    
    Instance\DisplayWindowCounter = 0
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Lecture d'un groupe Prfrences <<<<<

  Procedure ReadPrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    Instance\BestRate = ReadPreferenceDouble("BestRate", Instance\BestRate)
    Instance\MeanRate = ReadPreferenceDouble("MeanRate", Instance\MeanRate)
    Instance\WorstRate = ReadPreferenceDouble("WorstRate", Instance\WorstRate)
    Instance\RateDeviation = ReadPreferenceDouble("RateDeviation", Instance\RateDeviation)
    Instance\BestTime = ReadPreferenceLong("BestTime", Instance\BestTime)
    Instance\MeanTime = ReadPreferenceLong("MeanTime", Instance\MeanTime)
    Instance\WorstTime = ReadPreferenceLong("WorstTime", Instance\WorstTime)
    Instance\TimeDeviation = ReadPreferenceQuad("TimeDeviation", Instance\TimeDeviation)
    
    Rates_Max = ReadPreferenceLong("Rates_Max", 0) - 1

    For RatesID = 0 To Rates_Max
      AddElement(Instance\Rates())
      Instance\Rates() = ReadPreferenceDouble("Rates_" + Str(RatesID), Instance\Rates())
    Next
    
    Times_Max = ReadPreferenceLong("Times_Max", 0) - 1

    For TimesID = 0 To Times_Max
      AddElement(Instance\Times())
      Instance\Times() = ReadPreferenceLong("Times_" + Str(TimesID), Instance\Times())
    Next
    
    For RatesTop5ID = 0 To 4
      Instance\RatesTop5[RatesTop5ID] = ReadPreferenceDouble("RatesTop5_" + Str(RatesTop5ID), Instance\RatesTop5[RatesTop5ID])
    Next
    
    For TimesTop5ID = 0 To 4
      Instance\TimesTop5[TimesTop5ID] = ReadPreferenceLong("TimesTop5_" + Str(TimesTop5ID), Instance\TimesTop5[TimesTop5ID])
    Next
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<

  Procedure WritePrefs(P_GroupName.s)

    PreferenceGroup(P_GroupName)
    
    WritePreferenceDouble("BestRate", Instance\BestRate)
    WritePreferenceDouble("MeanRate", Instance\MeanRate)
    WritePreferenceDouble("WorstRate", Instance\WorstRate)
    WritePreferenceDouble("RateDeviation", Instance\RateDeviation)
    WritePreferenceLong("BestTime", Instance\BestTime)
    WritePreferenceLong("MeanTime", Instance\MeanTime)
    WritePreferenceLong("WorstTime", Instance\WorstTime)
    WritePreferenceQuad("TimeDeviation", Instance\TimeDeviation)
    
    WritePreferenceLong("Rates_Max", ListSize(Instance\Rates()))

    ForEach Instance\Rates()
      WritePreferenceDouble("Rates_" + Str(ListIndex(Instance\Rates())), Instance\Rates())
    Next
    
    WritePreferenceLong("Times_Max", ListSize(Instance\Times()))

    ForEach Instance\Times()
      WritePreferenceLong("Times_" + Str(ListIndex(Instance\Times())), Instance\Times())
    Next
    
    For RatesTop5ID = 0 To 4
      WritePreferenceDouble("RatesTop5_" + Str(RatesTop5ID), Instance\RatesTop5[RatesTop5ID])
    Next
    
    For TimesTop5ID = 0 To 4
      WritePreferenceLong("TimesTop5_" + Str(TimesTop5ID), Instance\TimesTop5[TimesTop5ID])
    Next
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< RatesCandidateForTop5 <<<<<
  
  Procedure RatesCandidateForTop5(P_Rates.d)
    
    CandidateID.b = -1
    
    For RatesTop5ID = 0 To 4
      
      If Instance\RatesTop5[RatesTop5ID] = P_Rates
        CandidateID = -1
        Break
      EndIf
      
      If Instance\RatesTop5[RatesTop5ID] < P_Rates
        CandidateID = RatesTop5ID
        Break
      EndIf
      
    Next
    
    If CandidateID <> -1
      
      For RatesTop5ID = 4 To CandidateID + 1 Step -1
        Instance\RatesTop5[RatesTop5ID] = Instance\RatesTop5[RatesTop5ID - 1]
      Next
      
      Instance\RatesTop5[CandidateID] = P_Rates
      
    EndIf
    
  EndProcedure
  
  Procedure TimesCandidateForTop5(P_Times.l)
    
    If P_Times > 0
      
      CandidateID.b = -1
      
      For TimesTop5ID = 0 To 4
        
        If Instance\TimesTop5[TimesTop5ID] = P_Times
          CandidateID = -1
          Break
        EndIf
        
        If Instance\TimesTop5[TimesTop5ID] > P_Times
          CandidateID = TimesTop5ID
          Break
        EndIf
        
      Next
      
      If CandidateID <> -1
        
        For TimesTop5ID = 4 To CandidateID + 1 Step -1
          Instance\TimesTop5[TimesTop5ID] = Instance\TimesTop5[TimesTop5ID - 1]
        Next
        
        Instance\TimesTop5[TimesTop5ID] = P_Times
        
      EndIf
      
    EndIf
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Analyse des donnes statistiques <<<<<
  
  Procedure Analysis()
    
    Instance\SampleSize = ListSize(Instance\Rates())
    
    If Instance\SampleSize <> 0
      
      FirstElement(Instance\Rates())
      FirstElement(Instance\Times())
      
      Instance\BestRate = Instance\Rates()
      Instance\WorstRate = Instance\Rates()
      Instance\BestTime = Instance\Times()
      Instance\WorstTime = Instance\Times()
      
      ForEach Instance\Rates()
        
        RatesCandidateForTop5(Instance\Rates())
        
        If Instance\Rates() > Instance\BestRate
          Instance\BestRate = Instance\Rates()
        EndIf
        
        If Instance\Rates() <> 0.0
          
          SumRate.d = SumRate + Instance\Rates()
          
          If Instance\Rates() < Instance\WorstRate
            Instance\WorstRate = Instance\Rates()
          EndIf
          
        EndIf
        
      Next
      
      ForEach Instance\Times()
        
        TimesCandidateForTop5(Instance\Times())
        
        If Instance\Times() <> 0
          
          SumTime = SumTime + Instance\Times()
          
          If Instance\Times() < Instance\BestTime
            Instance\BestTime = Instance\Times()
          EndIf
          
        EndIf
        
        If Instance\Times() > Instance\WorstTime
          Instance\WorstTime = Instance\Times()
        EndIf
        
      Next
      
      Instance\MeanRate = SumRate / Instance\SampleSize
      Instance\MeanTime = Int(SumTime / Instance\SampleSize)
      
      ForEach Instance\Rates()
        DeltaRate.d = Instance\Rates() - Instance\MeanRate
        SquareRateSum.d = SquareRateSum + DeltaRate * DeltaRate
      Next
      
      ForEach Instance\Times()
        DeltaTime.q = Instance\Times() - Instance\MeanTime
        SquareTimeSum.q = SquareTimeSum + DeltaTime * DeltaTime
      Next
      
      Instance\RateDeviation = Sqr(SquareRateSum / (Instance\SampleSize - 1))
      Instance\TimeDeviation = Int(Sqr(SquareTimeSum / (Instance\SampleSize - 1)))
      
    EndIf
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Insertion des donnes statistiques par le haut <<<<<
  
  Procedure InsertTopBottomOutRatesTimes(P_Rates.d, P_Times.l)
    
    FirstElement(Instance\Rates())
    InsertElement(Instance\Rates())
    Instance\Rates() = P_Rates
    
    FirstElement(Instance\Times())
    InsertElement(Instance\Times())
    Instance\Times() = P_Times
    
    If ListSize(Instance\Rates()) > #STATS_MAX
      LastElement(Instance\Rates())
      DeleteElement(Instance\Rates())
    EndIf

    If ListSize(Instance\Times()) > #STATS_MAX
      LastElement(Instance\Times())
      DeleteElement(Instance\Times())
    EndIf
    
    Analysis()
    
  EndProcedure
  
  Procedure TwinTextGroup(PosX.l, PosY.l, FrameID.l, LastTextID.l, FrameWidth.l = 240)
    
    FrameHeight = 25 + (((LastTextID+1) - FrameID) >> 1) * 30
    TextWidth = (FrameWidth - 15) >> 1
    
    FrameGadget(FrameID, PosX, PosY, FrameWidth, FrameHeight, "")
    PosY + 25
    FirstTextID = FrameID + 1
    
    For TextID = FirstTextID To LastTextID Step 2
      
      TextGadget(TextID, PosX + 5, PosY, TextWidth, 25, "", #PB_Text_Right)
      TextGadget(TextID+1, PosX + TextWidth + 5, PosY, TextWidth, 25, "")
      
      PosY + 30
      
    Next
    
  EndProcedure
  
  Procedure OpenStatsWindow(MainWinCte.i)
    
    If Instance\SampleSize >= 10
      
      ; Inutile d'afficher la fentre avec les stats s'il y a moins de 10
      ; entres actives dans le tableau principal. a veut rien dire,
      ; chantillon trop faible !
      
      If Instance\DisplayWindowCounter < 3
        
        Instance\DisplayWindowCounter = Instance\DisplayWindowCounter + 1
        
      Else
        
        Instance\DisplayWindowCounter = 0
        
        Analysis()
        
        HideWindow(MainWinCte, 1)
        
        If Window::OpenEx(#Win_Stats, Language::Message("Dev-Module") + " - " + Language::Message("Code Generator Statistics"), #PB_Window_WindowCentered, WindowID(MainWinCte))
          
          TwinTextGroup(5, 5, #Frm_Rate_Stats, #Txt_RateDeviation, 295)
          TwinTextGroup(GadgetLocate::RightOf(#Frm_Rate_Stats, 5), 5, #Frm_Time_Stats, #Txt_TimeDeviation, 295)
          
          TextGadget(#Txt_Stats_Data_Count, (WindowWidth(#Win_Stats) - 480) >> 1, GadgetLocate::DownOf(#Frm_Rate_Stats, 5) , 480, 25, "", #PB_Text_Center)
          
          TwinTextGroup(5, GadgetLocate::DownOf(#Txt_Stats_Data_Count, 10), #Frm_Rate_Top5, #Txt_Rate_Top5_5, 295)
          TwinTextGroup(GadgetLocate::RightOf(#Frm_Rate_Top5, 5), GadgetLocate::DownOf(#Txt_Stats_Data_Count, 10), #Frm_Time_Top5, #Txt_Time_Top5_5, 295)
          
          ButtonGadget(#Btn_Stats_Close, (WindowWidth(#Win_Stats) - 120) >> 1, WindowHeight(#Win_Stats) - 40, 120, 30, "")
          
          SetGadgetText(#Str_BestRate, FormatDouble::DoIt(StrD(Instance\BestRate, 2)))
          SetGadgetText(#Str_MeanRate, FormatDouble::DoIt(StrD(Instance\MeanRate, 2)))
          SetGadgetText(#Str_WorstRate, FormatDouble::DoIt(StrD(Instance\WorstRate, 2)))
          SetGadgetText(#Str_RateDeviation, FormatDouble::DoIt(StrD(Instance\RateDeviation, 2)))
          SetGadgetText(#Str_BestTime, FormatMilliSeconds::DoIt("%ss.%mss", Instance\BestTime))
          SetGadgetText(#Str_MeanTime, FormatMilliSeconds::DoIt("%ss.%mss", Instance\MeanTime))
          SetGadgetText(#Str_WorstTime, FormatMilliSeconds::DoIt("%ss.%mss", Instance\WorstTime))
          SetGadgetText(#Str_TimeDeviation, FormatMilliSeconds::DoIt("%ss.%mss", Instance\TimeDeviation))
          
          NoRateID = #Txt_Rate_Top5_1
          NoTimeID = #Txt_Time_Top5_1
          
          For RatesTop5ID = 0 To 4
            SetGadgetText(NoRateID, Str(RatesTop5ID + 1) + "." + Chr(9))
            SetGadgetText(NoRateID + 1, FormatDouble::DoIt(StrD(Instance\RatesTop5[RatesTop5ID], 2)))
            SetGadgetText(NoTimeID, Str(RatesTop5ID + 1) + "." + Chr(9))
            
            If Instance\TimesTop5[RatesTop5ID] = 2147483647
              SetGadgetText(NoTimeID + 1, "")
            Else
              SetGadgetText(NoTimeID + 1, FormatMilliSeconds::DoIt("%ss.%mss", Instance\TimesTop5[RatesTop5ID]))
            EndIf
            
            NoRateID + 2
            NoTimeID + 2
            
          Next
          
          SetGadgetText(#Frm_Rate_Stats, Language::Message("Generation Rate (Line/Second)"))
          SetGadgetText(#Txt_BestRate, Language::Message("Best") + " : ")
          SetGadgetText(#Txt_MeanRate, Language::Message("Average") + " : ")
          SetGadgetText(#Txt_WorstRate, Language::Message("Worst") + " : ")
          SetGadgetText(#Txt_RateDeviation, Language::Message("Standard Deviation") + " : ")
          
          SetGadgetText(#Frm_Time_Stats, Language::Message("Generation Time (Second)"))
          SetGadgetText(#Txt_BestTime, Language::Message("Best") + " : ")
          SetGadgetText(#Txt_MeanTime, Language::Message("Average") + " : ")
          SetGadgetText(#Txt_WorstTime, Language::Message("Worst") + " : ")
          SetGadgetText(#Txt_TimeDeviation, Language::Message("Standard Deviation") + " : ")
          
          SetGadgetText(#Txt_Stats_Data_Count, ReplaceString(Language::Message("Statistics based on last %X% code generations"), "%X%", Str(Instance\SampleSize)))
          SetGadgetText(#Frm_Rate_Top5, Language::Message("Top 5 (Line/Second)"))
          SetGadgetText(#Frm_Time_Top5, Language::Message("Top 5 (Second)"))
          
          SetGadgetText(#Btn_Stats_Close, Language::Message("Close"))
          
          AddKeyboardShortcut(#Win_Stats, #PB_Shortcut_Return, #Btn_Stats_Close)
          AddKeyboardShortcut(#Win_Stats, #PB_Shortcut_Escape, #Btn_Stats_Close)
          
          Repeat
            
            EventID = WaitWindowEvent()
            
            Select EventID
                
              Case #PB_Event_Menu
                
                Select EventMenu()
                    
                  Case #Btn_Stats_Close
                    EventID = #PB_Event_CloseWindow
                    
                EndSelect
                
              Case #PB_Event_Gadget
                
                Select EventGadget()
                    
                  Case #Btn_Stats_Close
                    EventID = #PB_Event_CloseWindow
                    
                EndSelect
                
            EndSelect
            
          Until EventID = #PB_Event_CloseWindow
          
          RemoveKeyboardShortcut(#Win_Stats, #PB_Shortcut_All)
          CloseWindow(#Win_Stats)
          HideWindow(MainWinCte, 0)
          
        EndIf    
        
      EndIf
      
    EndIf
    
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (204000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 LTS (Linux - x64)
; Folding = ---
; EnableXP
; CompileSourceDirectory
; EnableUnicode